var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-2B5AD0F9-DD6A-48A3-AF6F-DCD35D24A10E\">\n\
      <meta name=\"description\" content=\"This topic provides some principles to keep in mind when implementing the virtual MPxNode::compute() method for a custom dependency node class.\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Implementing the compute() method for a dependency graph node</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2B5AD0F9-DD6A-48A3-AF6F-DCD35D24A10E\"></a><div class=\"head\">\n\
            <h1>Implementing the compute() method for a dependency graph node</h1>\n\
         </div>\n\
         <p class=\"blurb\">This topic provides some principles to keep in mind when implementing the virtual\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::compute()</a></span> method for a custom dependency node class. \n\
         </p>\n\
         <p><a name=\"GUID-BFBE06FD-0C59-41C8-9E00-8A954D08DBC7\"></a>Maya calls your node\'s <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::compute()</a></span> method when it determines that one of your node\'s output attributes, or plugs, is\n\
            out-of-date and needs to be re-computed. It passes as arguments the plug that needs\n\
            to be recomputed, and a data block that contains the current values of the input and\n\
            output attributes for the current instance of your node. Your <span class=\"code\" translate=\"no\">compute()</span> method is expected to re-calculate the value of the requested plug based on the current\n\
            values of the node\'s input attributes, and to store the computed output values back\n\
            into the data block. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_F0BA86E7429D467F95701F198E363274\"></a> \n\
            <h2><a name=\"GUID-71F96771-0D4B-4A8A-B034-5575B4ED975F\"></a>Performance matters\n\
            </h2> \n\
            <p><a name=\"GUID-39E61C0F-0FCC-43B2-9B95-0278BFC75A95\"></a>Assume that your node will be re-evaluated frequently. Strive to make its computations\n\
               as efficient as possible. \n\
            </p> \n\
            <p><a name=\"GUID-A35C0F10-4621-4677-9C2C-9980EC912023\"></a>For example, during rendering a node may need to be evaluated several times per pixel.\n\
               If you do not take care to make its computations as fast as possible, the dependency\n\
               graph can easily become a bottleneck. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F11E3C26A95944EF9C1A9941C5038D87\"></a> \n\
            <h2><a name=\"GUID-F22677EB-621D-45AC-9CF6-A5E2BBF3FCEF\"></a>Rely only on input attributes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FC0A\"></a>The <span class=\"code\" translate=\"no\">compute()</span> method in every node must operate with only the data that is present in its parameters:\n\
               i.e. the current values of its attributes. \n\
            </p> \n\
            <p><a name=\"GUID-B2AC3191-9DA7-452A-9817-8CF488CD563C\"></a>If you need to use any other data in your computations, make that data into attributes.\n\
               Even if it is only temporarily cached information to speed up computation, it could\n\
               be useful as a hidden attribute to speed up the first refresh after file retrieval.\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E3AF46108C0041FE85BD142B0183A60D\"></a> \n\
            <h2><a name=\"GUID-66867211-E6A6-4350-A350-480F6A4BB5DB\"></a>Change only output attributes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FC04\"></a>A node must not affect any values or objects apart from its output attributes. For\n\
               instance, a node should not directly alter the DAG or any other dependency graph nodes.\n\
               Doing so could result in an infinite loop: it could prompt a new evaluation of the\n\
               dependency graph, which could cause your node to be re-evaluated, altering the DAG\n\
               or dependency graph again and forcing a new dependency graph evaluation. If for some\n\
               reason a node needs to alter something about its environment, you should encapsulate\n\
               that knowledge as an attribute and connect the attribute to another component that\n\
               can accept the computed data. Affecting any outside data will almost certainly violate\n\
               one of the following: \n\
            </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9FC05\"></a><ul>\n\
               <li>multiprocessing-friendliness </li>\n\
               <li>evaluating at an alternate context (for example, at time T) </li>\n\
               <li>node instancing </li>\n\
               <li>vectorization of computations </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_BD5A57147B074C16A797E09AD6ECF0AF\"></a> \n\
            <h2><a name=\"GUID-C9104F08-D245-47F6-B78A-0AA824D15A80\"></a>Always check the requested plug\n\
            </h2> \n\
            <p><a name=\"GUID-DA07A0D6-961F-45F2-8D3F-6CA0A5C2B606\"></a>Always check which plug Maya is requesting you to recompute, and handle any unrecognized\n\
               plugs by returning <span class=\"code\" translate=\"no\">MS::kUnknownParameter</span>. \n\
            </p> \n\
            <p><a name=\"GUID-1E94EA83-482D-4D1E-B1A3-E2C3BC1851F9\"></a>For example: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">{\n\
    ...\n\
\n\
    if ( (plug == myOutputPlug) || (plug == myOtherOutputPlug) )\n\
    {\n\
         ... // compute and set the requested output values here.\n\
    }\n\
    else\n\
         return MS::kUnknownParameter;\n\
\n\
    return MS::kSuccess;\n\
}</pre></div> \n\
            <p><a name=\"GUID-9A9CFFC2-2B7C-4469-936C-0F50FFF38270\"></a>This can avoid your node re-computing output attributes unnecessarily. \n\
            </p> \n\
            <p><a name=\"GUID-912197DC-1AEB-4F27-BBFD-FDC23F945AA3\"></a>In addition, returning <span class=\"code\" translate=\"no\">MS::kUnknownParameter</span> will make Maya call the <span class=\"code\" translate=\"no\">compute()</span> method of the base class that you have derived your class from. If the attribute\n\
               that needs to be recomputed is initialized in the base class and computed by its <span class=\"code\" translate=\"no\">compute()</span> method, the value will be automatically updated by the base class. Therefore, you\n\
               do not need to handle any inherited attributes in your derived class. You may, however,\n\
               <em class=\"mild\">override</em> the way the base class handles any of its attributes in your implementation by updating\n\
               its value and returning <span class=\"code\" translate=\"no\">MS::kSuccess</span> as you would for any attributes that are specific to your derived class. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6F470E54E20344EFAC51CDBDAD743F7D\"></a> \n\
            <h2><a name=\"GUID-34BB0E80-E26F-45E3-880A-3F39D9082603\"></a>Always set computed plugs as clean\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FC0B\"></a>When your node computes a new value for a requested plug and stores the value in the\n\
               data block passed to the <span class=\"code\" translate=\"no\">compute()</span> method, always notify Maya that the plug\'s value has been newly computed by marking\n\
               the plug as \"clean\" by calling: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">data.setClean(plug);</pre></div> \n\
            <p><a name=\"GUID-B9B5555D-8E2A-43EB-827F-CA2BD142A204\"></a>and returning <span class=\"code\" translate=\"no\">MS::kSuccess</span>. \n\
            </p> \n\
            <p><a name=\"GUID-71FD41E3-DDCD-4240-978D-A12173EA6448\"></a>If you do not mark the plug as clean, Maya may request multiple re-evaluations of\n\
               your node each time it refreshes the dependency graph. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9B8FB0707C7247E985244832274A68D1\"></a> \n\
            <h2><a name=\"GUID-FB26D4B2-72BE-4F6E-92F2-F7A56EBF53C3\"></a>Do not save references to data\n\
            </h2> \n\
            <p><a name=\"GUID-8E4820C5-99AC-4872-B0BE-C3001F159B5D\"></a>Your node must not save a reference to any of the data that is passed in to the <span class=\"code\" translate=\"no\">compute()</span> method for a plug. If, for example, surface geometry comes in on a plug, do not save\n\
               a pointer to this geometry. The data coming in on a plug is transitory and may cease\n\
               to exist without you knowing it. You are only guaranteed that it will exist during\n\
               the execution of your node’s <span class=\"code\" translate=\"no\">compute()</span> method. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_BFC59ADF171345C4B266284C435C02F3\"></a> \n\
            <h2><a name=\"GUID-F4C27DF3-7BC1-4E75-9E67-BC1BECD5CC61\"></a>Respond to the HasNoEffect node state, if necessary\n\
            </h2> \n\
            <p><a name=\"GUID-14A72EB4-6B72-4FFC-ADF5-042030945439\"></a> If your node accepts a certain type of input attribute and produces the same type\n\
               of data as an output, you may want to support the \"HasNoEffect\" or pass-through node\n\
               state. Setting a node to this state typically results in the input attribute value\n\
               being assigned directly to the output attribute, without any modifications. This allows\n\
               a Maya user to bypass the node\'s calculations without needing to break any connections\n\
               in the dependency graph. \n\
            </p> \n\
            <p><a name=\"GUID-6CC9AF66-8DF7-4942-9EF4-74242EE0C413\"></a>For example, the following snippet from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"splitUVCmd/splitUVNode.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/split_u_v_cmd_2split_u_v_node_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">splitUVCmd/splitUVNode.cpp</a></span> sample retrieves the value of the state attribute, and tests to see if its value\n\
               is <span class=\"code\" translate=\"no\">1</span>, which corresponds to the \"HasNoEffect\" setting. If so, it simply returns the input\n\
               attribute. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> splitUVNode::compute( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a>&amp; data )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status = MS::kSuccess;\n\
     \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a> stateData = data.outputValue( state, &amp;status );\n\
    MCheckStatus( status, \"ERROR getting state\" );\n\
\n\
    if( stateData.asShort() == 1 )\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a> inputData = data.inputValue( inMesh, &amp;status );\n\
        MCheckStatus(status,\"ERROR getting inMesh\");\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a> outputData = data.outputValue( outMesh, &amp;status );\n\
        MCheckStatus(status,\"ERROR getting outMesh\");\n\
        // Simply redirect the inMesh to the outMesh for the PassThrough effect\n\
        //\n\
        outputData.set(inputData.asMesh());\n\
    }\n\
    ...\n\
}</pre></div> \n\
            <p><a name=\"GUID-C06E79A4-D717-4163-A762-B44C183E6704\"></a>For details about node states and their values, see <span class=\"char_link\"><a href=\"#!/url=./files/Dependency_graph_plugins_Dependency_Graph_DG_nodes.htm\">About the dependency graph</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";