var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-0B85C721-C3C6-47D7-9D85-4F27B787ABB6\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Querying the Scene Graph</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0B85C721-C3C6-47D7-9D85-4F27B787ABB6\"></a><div class=\"head\">\n\
            <h1>Querying the Scene Graph</h1>\n\
         </div>\n\
         <p><a name=\"GUID-7A998B22-7B69-4AD1-922B-42FB352C28FC\"></a>This topic presents the basics of scene element organization in Maya. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_4912196DA9B64D30BBE8E863C9192B00\"></a> \n\
            <h2><a name=\"GUID-33040FDA-3B68-44C9-846E-499BBD6FD19D\"></a>The Directed Acyclic Graph (DAG)\n\
            </h2> \n\
            <p><a name=\"GUID-39A3BE3B-C199-44C1-9CFA-2D4D813B1F94\"></a> The scene graph in Maya is commonly referred to as the \"<em class=\"strong\">Directed Acyclic Graph</em>\", or <em class=\"strong\">DAG</em>. The DAG is actually a subset of a much larger graph, known as the <em class=\"mild\">Dependency Graph</em>, which encompasses a much wider variety of node types including shaders, deformers,\n\
               constraints, etc. For more information, consult the next section, <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A9070270-9B5D-4511-8012-BC948149884D.htm\">Dependency Graph Plug-in Basics</a></span>. For now, we will focus our attention DAG nodes, which can be categorized in one\n\
               of two ways: \n\
            </p> <a name=\"OL_09785F36E9274328B8CD6DCF6DB81F73\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">Transform Nodes (<span class=\"code\" translate=\"no\">MFn.kTransform</span>):</em> This node type defines a local 4x4 transformation matrix which affects all the objects\n\
                  beneath it in the hierarchy. This transformation data is manipulated by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTransform</a></span> function set. Transform nodes can have other transform nodes as their children to\n\
                  group scene elements together. \n\
               </li>\n\
               <li><em class=\"strong\">Shape Nodes (<span class=\"code\" translate=\"no\">MFn.kMesh</span>, <span class=\"code\" translate=\"no\">MFn.kCamera</span>, <span class=\"code\" translate=\"no\">MFn.kLight</span>, ... ):</em> This node type contains the actual geometric information of a scene element, such\n\
                  as the vertices of a mesh. A shape node always has a transform node as its parent.\n\
                  \n\
               </li>\n\
            </ol> \n\
            <p><a name=\"GUID-1050A678-2C9C-4574-9AF9-0D920A9C1DD5\"></a>The diagram below presents the simplified directed acyclic graph (DAG) of a basic\n\
               scene. The <span class=\"code\" translate=\"no\">world</span> node represents the scene\'s root. The green circles correspond to the transform nodes\n\
               (<span class=\"code\" translate=\"no\">kTransform</span>), and allow the shapes to be positioned in the scene. The shape nodes are identified\n\
               by blue circles. In this DAG, <span class=\"code\" translate=\"no\">perspShape</span> corresponds to a camera in the scene, while <span class=\"code\" translate=\"no\">pCubeShape1</span> and <span class=\"code\" translate=\"no\">pointLightShape1</span> respectively represent a cubic mesh and a point light in the scene. Observe that\n\
               the <span class=\"code\" translate=\"no\">pointLight1</span> transform node is a child of the <span class=\"code\" translate=\"no\">pCube1</span> transform node, which means that if the <span class=\"code\" translate=\"no\">pCube1</span> transform node is moved, the point light will be moved as well. \n\
            </p> <img src=\"images/GUID-1F434591-B916-443D-AD05-846D393634D9-low.png\"> \n\
            <div><a name=\"GUID-0105E6F2-C89A-4824-B6AA-37238149FD42\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Generally, a shape node cannot have any children under it. The exception to this rule\n\
                  is a special circumstance known as the <em class=\"mild\">underworld</em>. The <em class=\"mild\">underworld</em> is a DAG subgraph whose root is attached as a child to a shape node. This <em class=\"mild\">underworld</em> graph defines the control points and dependencies of a NURBS curve or a NURBS surface.\n\
                  \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6FF8CB32090A4EA4A00DEE77D6149224\"></a> \n\
            <h2><a name=\"GUID-69C625A7-0B75-419F-87DF-8663E3BD7D49\"></a>DAG Paths\n\
            </h2> \n\
            <p><a name=\"GUID-9A75C361-CB75-4BD1-AA5B-38500C39333F\"></a>The location of a specific scene element within the DAG is identified by a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a></span> object. \n\
            </p> \n\
            <p><a name=\"GUID-1F702F5C-F960-464C-A828-3A0BFDC6CBA3\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a></span> can return the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> to which it corresponds in the DAG using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.node()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a34b606120f12457f3128057a7b4740e3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.node()</a></span>. The path itself can be extended to encompass a shape node (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.extendToShape()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a6bbdc34b5bfd9747bfc59ad21771f7c6&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.extendToShape()</a></span>), or return the lowest transform node (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.transform()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a252aef07d234fb4f316d4fb32a41ea8b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.transform()</a></span>) to name a few convenient functions. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.fullPathName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a8ad464725ea36f88c4608d5525b1cde3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.fullPathName()</a></span> function returns a string representation of the DAG path to a given node, formatted\n\
               as a sequence of pipe-separated (\"<span class=\"code\" translate=\"no\">|</span>\") node names starting at the nameless root of the DAG. In the diagram above, the\n\
               string representation of the path from the root <span class=\"code\" translate=\"no\">world</span> node to <span class=\"code\" translate=\"no\">pointLightShape1</span> would be as follows: \"<span class=\"code\" translate=\"no\">|pCube1|pointLight1|pointLightShape1</span>\" (note that the root node has no name). \n\
            </p> \n\
            <p><a name=\"GUID-56475FAF-76B9-42F8-9F53-87F5714A6761\"></a>To reduce memory consumption, a complex shape such as a particularly dense mesh can\n\
               be <em class=\"mild\">instanced</em> in multiple locations in the scene graph. In other words, the same shape can appear\n\
               in different places in the scene without being copied. To achieve this, several transform\n\
               nodes in the DAG can be the parents of the same shape node. As such, a single shape\n\
               node can have multiple paths from the root of the DAG. Functions such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.isInstanced()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#accfb22081f7c3c5421741f68ffd16378&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.isInstanced()</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.instanceNumber()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a0ef64fd5f3cbf426aed9c78ad40f9f85&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath.instanceNumber()</a></span> can be used to identify instanced shape nodes. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_30C26C7290AF47218F827496114C9DA7\"></a> \n\
            <h2><a name=\"GUID-2DF3A1D5-1BC2-45F5-9D3F-46AB41D82FC7\"></a>Traversing the Scene Graph \n\
            </h2> \n\
            <p><a name=\"GUID-2EF367B7-DFE5-45D0-A6C7-0F791EAB4328\"></a> \n\
            </p> \n\
            <p><a name=\"GUID-CFE8B168-F4EB-43A7-B13C-265C4058522C\"></a>The scene graph can be traversed using an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag</a></span> object, and optionally with an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDependencyGraph</a></span> object, since the DAG is a subset of the Dependency Graph. \n\
            </p> \n\
            <p><a name=\"GUID-E967FC4F-B889-4F50-83CB-71141CC6052B\"></a> Classes prefixed with <span class=\"code\" translate=\"no\">MIt</span> are known as <em class=\"mild\">iterators</em>, and allow you to inspect each object in a collection. In our case, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag</a></span> will allow us to iterate over the DAG nodes in the scene. In the following code sample,\n\
               we create a DAG iterator which will traverse the scene starting at the root, and which\n\
               will visit each node in a depth-first manner. The <span class=\"code\" translate=\"no\">OpenMaya.MFn.kInvalid</span> parameter ensures that the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag</a></span> object will not filter any node types. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst, OpenMaya.MFn.kInvalid )\n\
\n\
# This reference to the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set will be needed\n\
# to obtain information about the DAG objects.\n\
dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()</pre></div> \n\
            <p><a name=\"GUID-B3B3ECFF-6641-4302-9BC3-059ACA5D7FB3\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.isDone()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#afce691ae1306e9ca23e6e889dec9b54b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.isDone()</a></span> function determines whether or not there are objects remaining to be inspected. The\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.currentItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a03b48b8d2d5b0bef88a48a362eac0eec&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.currentItem()</a></span> function returns the iterator\'s current DAG object whose depth relative to the root\n\
               can be obtained using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.depth()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a6dac1beb1726dcab80704d0c921079ce&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.depth()</a></span>. Calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.next()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a7e119c3d34279c19f6f26780981f39b9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.next()</a></span> will cause the internal state of the iterator to advance to the next item, but will\n\
               not return a DAG object; this is only achieved using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.currentItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a03b48b8d2d5b0bef88a48a362eac0eec&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.currentItem()</a></span>. If there are no more items to continue the iteration, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItDag.isDone()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#afce691ae1306e9ca23e6e889dec9b54b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItDag.isDone()</a></span> function will return <span class=\"code\" translate=\"no\">True</span>. We can therefore construct a simple while loop to traverse the scene graph: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Traverse the scene.\n\
while( not dagIterator.isDone() ):\n\
\n\
    # Obtain the current item.\n\
    dagObject = dagIterator.currentItem()\n\
\n\
    # Extract the depth of the DAG object.\n\
    depth = dagIterator.depth()\n\
            \n\
    # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
    dagNodeFn.setObject( dagObject )\n\
                       \n\
    # Extract the DAG object\'s name.\n\
    name = dagNodeFn.name()\n\
            \n\
    print name + \' (\' + dagObject.apiTypeStr() + \') depth: \' + str( depth )\n\
    \n\
    # Iterate to the next item.\n\
    dagIterator.next()</pre></div> \n\
            <div><a name=\"GUID-DCD7CF48-CC28-4482-892D-7552F4D5676C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>We elaborate on the use of <em class=\"mild\">function sets</em> (ex: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span>) in <span class=\"char_link\"><a href=\"#!/url=./files/GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D.htm\">Creating and Manipulating Objects</a></span>. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AC0834E890DD4EF3AA5EC9C01C23629A\"></a> \n\
            <h2><a name=\"GUID-CDB5361F-2593-4C3C-90BB-824809F9CBFF\"></a>Inspecting Selected Scene Elements\n\
            </h2> \n\
            <p><a name=\"GUID-D51F6E81-79BD-429D-B9A7-994E3BFC17EB\"></a>When objects are selected from Maya\'s user interface (or through scripts), they are\n\
               added to a global <em class=\"mild\">active selection list</em>, accessible via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGlobal.getActiveSelectionList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal.getActiveSelectionList()</a></span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGlobal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal</a></span> static class provides a variety of functions pertaining to the Maya application,\n\
               logging, object selection, command execution, 3D views (including the scene\'s up-axis),\n\
               and model manipulation. \n\
            </p> \n\
            <p><a name=\"GUID-2151D4E6-0DA2-49CF-B083-243ED956AB17\"></a>The code below illustrates how to obtain the active selection list by populating a\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSelectionList</a></span> object. \n\
            </p> \n\
            <p><a name=\"GUID-520639D8-7659-4090-B37E-89B8CFA0F705\"></a>Python API 2.0: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()</pre></div> \n\
            <p><a name=\"GUID-A91A4CC9-0CC8-41AB-A371-D04C0E532B0D\"></a>Python API 1.0: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>( selectionList )</pre></div> \n\
            <p><a name=\"GUID-CBFDE3EF-DDD7-43A5-9AD9-AD95A4A15F8A\"></a>We use an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a></span> to iterate over the selection list. The constructor of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a></span> allows us to specify a filter to iterate over objects of a specific type. In the\n\
               following example, our iterator filters for objects compatible with the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span> function set by specifying the <span class=\"code\" translate=\"no\">MFn.kDagNode</span> parameter: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )</pre></div> \n\
            <p><a name=\"GUID-B05D5C0B-3079-4FE4-A825-AED2C6DF496F\"></a>With the Python API 2.0, you can use a selection list to iterate over the entire scene\n\
               graph by selecting all nodes in the scene first, and calling <span class=\"code\" translate=\"no\">getDagPath()</span> on the iterator for each item. For example: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
 \n\
cmds.select(all=True)\n\
selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()\n\
if sList.length()&gt;0:\n\
    iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItSelectionList</a>(selectionList, OpenMaya.MFn.kDagNode)\n\
    while not iterator.isDone():  \n\
        print iterator.getDagPath()\n\
        iterator.next()</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F10DCCED6131401584A3F25036CFC881\"></a> \n\
            <h2><a name=\"GUID-4BED7155-115B-47B0-8C04-FD11D7721A06\"></a>Example Command Plug-in: Printing DAG Paths\n\
            </h2> \n\
            <p><a name=\"GUID-FBE1C0BA-F952-48BC-AACC-00506A2D3B78\"></a> <em class=\"strong\">Filename:</em> <span class=\"code\" translate=\"no\">printPaths.py</span> \n\
            </p> \n\
            <p><a name=\"GUID-43E05009-D6B5-4D9D-8C0C-CD17AB8DADAA\"></a> <em class=\"strong\">Sample Script Editor Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-B471F5D8-56F2-4552-84F2-00E31746614D\"></a></p> <img src=\"images/GUID-672831F9-C37D-4B2F-84DF-89F223FABEED-low.png\"> \n\
            <p><a name=\"GUID-50AF43F4-A86F-4303-B2A5-040BDFAFF4B5\"></a><em class=\"strong\">Program Summary:</em> The plug-in code below creates the <span class=\"code\" translate=\"no\">printPaths()</span> command. The behavior of this command depends on whether or not the <em class=\"mild\">active selection list</em> contains DAG objects. If one or more DAG objects have been selected, their respective\n\
               names, types, DAG paths and compatible function set types are printed to the Script\n\
               Editor output. Otherwise, the scene graph is printed using each DAG node\'s name and\n\
               type. \n\
            </p> <a name=\"SECTION_8CC988896708485B88AA39FBEC98340A\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-A528A117-D0FE-4A1E-B24D-01F96A6C384B\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pyPrintPaths.py\n\
\n\
import sys\n\
import maya.cmds as cmds\n\
import maya.api.OpenMaya as OpenMaya\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
kPluginCmdName = \'pyPrintPaths\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class printPathsCmd(<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a>):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
        \n\
    def doIt(self, args):\n\
        \'\'\' \n\
        Print the DAG paths of the selected objects.\n\
        If no DAG objects are selected, print the entire\n\
        scene graph.\n\
        \'\'\'\n\
        \n\
        # Populate the <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSelectionList</a> with the currently selected\n\
        # objects using the static function MGlobal.getActiveSelectionList().\n\
        \n\
        #selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
        selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()\n\
        \n\
        # This selection list can contain more than just scene elements (DAG nodes),\n\
        # so we must create an iterator over this selection list (<a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a>), \n\
        # and filter for objects compatible with the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set (MFn.kDagNode).\n\
        iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )\n\
        \n\
        if iterator.isDone():\n\
            # Print the whole scene if there are no DAG nodes selected.\n\
            print \'=====================\'\n\
            print \' SCENE GRAPH (DAG):  \'\n\
            print \'=====================\'\n\
            self.printScene()\n\
        else:\n\
            # Print the paths of the selected DAG objects. \n\
            print \'=======================\'\n\
            print \' SELECTED DAG OBJECTS: \'\n\
            print \'=======================\'\n\
            self.printSelectedDAGPaths( iterator )\n\
    \n\
    def printSelectedDAGPaths(self, pSelectionListIterator):\n\
        \'\'\' Print the DAG path(s) of the selected object(s). \'\'\'\n\
        \n\
        # Create an <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> object which will be populated on each iteration.\n\
        dagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        \n\
        # Obtain a reference to MFnDag function set to print the name of the DAG object\n\
        dagFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        \n\
        \n\
        # Perform each iteration.\n\
        while( not pSelectionListIterator.isDone() ):\n\
            \n\
            # Populate our <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> object. This will likely provide\n\
            # us with a Transform node.\n\
            dagPath = pSelectionListIterator.getDagPath()\n\
            try:\n\
                # Attempt to extend the path to the shape node.\n\
                dagPath.extendToShape()\n\
            except Exception as e:\n\
                # Do nothing if this operation fails.\n\
                pass\n\
            \n\
            # Obtain the name of the object.\n\
            dagObject = dagPath.node()\n\
            dagFn.setObject( dagObject )\n\
            name = dagFn.name()\n\
            \n\
            # Obtain the compatible function sets for this DAG object.\n\
            # These values refer to the enumeration values of <a href=\"javascript:void(0)\" data-symbol=\"MFn\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFn</a>\n\
            fntypes = []\n\
            fntypes = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getFunctionSetList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a89e813abc5d6f2fe65755bb0737aa628&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getFunctionSetList</a>( dagObject )\n\
            \n\
            # Print the DAG object information.\n\
            print name + \' (\' + dagObject.apiTypeStr + \')\'\n\
            print \'\\tDAG path: [\' + str( dagPath.fullPathName() ) + \']\'\n\
            print \'\\tCompatible function sets: \' + str( fntypes )\n\
            \n\
            # Advance to the next item\n\
            pSelectionListIterator.next()\n\
        \n\
        print \'=====================\'         \n\
            \n\
    def printScene(self):\n\
        \'\'\' Traverse and print the elements in the scene graph (DAG)  \'\'\'\n\
        \n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene\'s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the \'OpenMaya.MFn.kInvalid\' parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
       \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            dagObject = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
            dagNodeFn.setObject( dagObject )\n\
                       \n\
            # Extract the DAG object\'s name.\n\
            name = dagNodeFn.name()\n\
            \n\
            # Generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = \'\'\n\
            for i in range( 0, depth ):\n\
                output += \'\\t\'\n\
                \n\
            output += name + \' (\' + dagObject.apiTypeStr + \')\'\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print \'=====================\'\n\
\n\
    \n\
\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    \'\'\' Creates an instance of our command class. \'\'\'\n\
    return printPathsCmd() \n\
    \n\
def initializePlugin(mobject):\n\
    \'\'\' Initializes the plug-in.\'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\'\n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'pyPrintPaths.py\' )\n\
cmds.pyPrintPaths()\n\
 \n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_67A82094008B4A7DAA12F3A19A447CB3\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-45249DFB-87EE-4BB8-9D0F-4CED5CDE94C9\"></a><span class=\"collapsible-section-title\">Python API 1.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># printPaths.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
\n\
kPluginCmdName = \'printPaths\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class printPathsCmd(OpenMayaMPx.MPxCommand):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
        \n\
    def doIt(self, args):\n\
        \'\'\' \n\
        Print the DAG paths of the selected objects.\n\
        If no DAG objects are selected, print the entire\n\
        scene graph.\n\
        \'\'\'\n\
        \n\
        # Populate the <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSelectionList</a> with the currently selected\n\
        # objects using the static function MGlobal.getActiveSelectionList().\n\
        selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>( selectionList )\n\
        \n\
        # This selection list can contain more than just scene elements (DAG nodes),\n\
        # so we must create an iterator over this selection list (<a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a>), \n\
        # and filter for objects compatible with the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set (MFn.kDagNode).\n\
        iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )\n\
        \n\
        if iterator.isDone():\n\
            # Print the whole scene if there are no DAG nodes selected.\n\
            self.printScene()\n\
        else:\n\
            # Print the paths of the selected DAG objects. \n\
            self.printSelectedDAGPaths( iterator )\n\
    \n\
    def printSelectedDAGPaths(self, pSelectionListIterator):\n\
        \'\'\' Print the DAG path(s) of the selected object(s). \'\'\'\n\
        \n\
        # Create an <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> object which will be populated on each iteration.\n\
        dagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        \n\
        # Obtain a reference to MFnDag function set to print the name of the DAG object\n\
        dagFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        print \'=======================\'\n\
        print \' SELECTED DAG OBJECTS: \'\n\
        print \'=======================\'\n\
        \n\
        # Perform each iteration.\n\
        while( not pSelectionListIterator.isDone() ):\n\
            \n\
            # Populate our <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagPath</a> object. This will likely provide\n\
            # us with a Transform node.\n\
            pSelectionListIterator.getDagPath( dagPath )\n\
            try:\n\
                # Attempt to extend the path to the shape node.\n\
                dagPath.extendToShape()\n\
            except Exception as e:\n\
                # Do nothing if this operation fails.\n\
                pass\n\
            \n\
            # Obtain the name of the object.\n\
            dagObject = dagPath.node()\n\
            dagFn.setObject( dagObject )\n\
            name = dagFn.name()\n\
            \n\
            # Obtain the compatible function sets for this DAG object.\n\
            # These values refer to the enumeration values of <a href=\"javascript:void(0)\" data-symbol=\"MFn\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFn</a>\n\
            fntypes = []\n\
            <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getFunctionSetList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a89e813abc5d6f2fe65755bb0737aa628&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal.getFunctionSetList</a>( dagObject, fntypes )\n\
            \n\
            # Print the DAG object information.\n\
            print name + \' (\' + dagObject.apiTypeStr() + \')\'\n\
            print \'\\tDAG path: [\' + str( dagPath.fullPathName() ) + \']\'\n\
            print \'\\tCompatible function sets: \' + str( fntypes )\n\
            \n\
            # Advance to the next item\n\
            pSelectionListIterator.next()\n\
        \n\
        print \'=====================\'\n\
            \n\
            \n\
    def printScene(self):\n\
        \'\'\' Traverse and print the elements in the scene graph (DAG)  \'\'\'\n\
        \n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene\'s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the \'OpenMaya.MFn.kInvalid\' parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print \'=====================\'\n\
        print \' SCENE GRAPH (DAG):  \'\n\
        print \'=====================\'\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            dagObject = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
            dagNodeFn.setObject( dagObject )\n\
                       \n\
            # Extract the DAG object\'s name.\n\
            name = dagNodeFn.name()\n\
            \n\
            # Generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = \'\'\n\
            for i in range( 0, depth ):\n\
                output += \'\\t\'\n\
                \n\
            output += name + \' (\' + dagObject.apiTypeStr() + \')\'\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print \'=====================\'\n\
\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    \'\'\' Creates an instance of our command class. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( printPathsCmd() )\n\
    \n\
def initializePlugin(mobject):\n\
    \'\'\' Initializes the plug-in.\'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\'\n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'printPaths.py\' )\n\
cmds.printPaths()\n\
 \n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";