var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-0F59EAA2-849E-4BAB-843B-6262B256D80F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Customizing Geometric Data for Shaders</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0F59EAA2-849E-4BAB-843B-6262B256D80F\"></a><div class=\"head\">\n\
            <h1>Customizing Geometric Data for Shaders</h1>\n\
         </div>\n\
         <p><a name=\"GUID-411535E5-1E54-4A91-AFDF-292A4B8AA4E2\"></a>The data representation for Maya DAG objects dictates both the format as well as the\n\
            types of geometric streams that can be used as inputs for shading algorithms. For\n\
            a given shader it is possible that either the format or the type of stream provided\n\
            may be insufficient. \n\
         </p>\n\
         <p><a name=\"GUID-DF7665A7-F1C3-4291-84DD-24AFD1D2368C\"></a>To address these issues, an API to provide data customization is provided to: \n\
         </p><a name=\"UL_9AF347C0DAF843B6B627947184E60C87\"></a><ul>\n\
            <li>Allow for customized data streams to be provided. </li>\n\
            <li>Allow for more custom data formats. </li>\n\
            <li>Allow for data repackaging. </li>\n\
         </ul>\n\
         <p><a name=\"GUID-AB26ACD1-F76D-4137-BE1A-204CE881917B\"></a>All interfaces work within a unified system, which allows for any or all customizations\n\
            to be used in conjunction with each other. \n\
         </p>\n\
         <p><a name=\"GUID-42828273-DF18-4253-9EB6-D2C16EED2F81\"></a>There are two interfaces which provide the ability for a plug-in to provide custom\n\
            data streams and custom data indexing. \n\
         </p>\n\
         <div class=\"section\"><a name=\"AA1016870\"></a> \n\
            <h2><a name=\"GUID-6F602E01-E1F2-4728-85E2-C7F94B357B22\"></a>Geometry Generators\n\
            </h2> \n\
            <p><a name=\"GUID-75426090-E453-4077-AA9E-F68EF85FABBA\"></a>Custom streams can be provided using an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxVertexBufferGenerator</a></span>. There is no equivalent legacy class to which matches this functionality. \n\
            </p> \n\
            <p><a name=\"GUID-8DCE292D-6F82-46E2-8212-A59E8813A4DB\"></a>A generator can supply a stream based on new data and/or existing stream data. \n\
            </p> \n\
            <p><a name=\"GUID-2125851E-C469-406B-A6F6-DC1D4DB06EA4\"></a>In order to use an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxVertexBufferGenerator</a></span>, it needs to be registered via the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawRegistry</a></span> class in a similar fashion to how overrides are registered. \n\
            </p> \n\
            <p><a name=\"GUID-7C15D2D6-1DFD-4EF6-919B-48A279F254E6\"></a>When a shader requires certain data streams, it specifies its requirements using <span class=\"code\" translate=\"no\">MVertexBufferDescriptors</span>. Each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> specifies its stream using a stream name and a semantic. Every <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxVertexBufferGenerator</a></span> is required to have an associated name. To reference a generator, this name can be\n\
               used by an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span> as its semantic name. \n\
            </p> \n\
            <p><a name=\"GUID-7FF42848-9608-464D-86B4-08B65CCCC68F\"></a>The following is an example for an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span> which specifies the requirement for two custom streams: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// Create a custom position stream requirement. Set a unique semantic name for lookup.\n\
// Add to the list of requirements.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> positionDesc(\n\
                empty, \n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4aa20581584e5f9447cb96afb4f2e10703&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kPosition</a>,\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
                3);\n\
\n\
positionDesc.setSemanticName(\"customPositionStream\");\n\
addGeometryRequirement(positionDesc);\n\
\n\
// Create a custom normal stream requirement. Set a unique semantic name for lookup.\n\
// Add to the list of requirements.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> normalDesc(\n\
                empty,\n\
                MHWRender::MGeometry:: kNormal,\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
                3);\n\
normalDesc.setSemanticName(\"customNormalStream\");\n\
addGeometryRequirement(normalDesc);\n\
</pre></div> \n\
            <p><a name=\"GUID-22CA4CD0-FDE9-405A-9855-96A65FA2D2D8\"></a> A generator is called to fill in data via its <span class=\"code\" translate=\"no\">createVertexStreams()</span> method. For the given DAG path, the generator updates and returns an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-DDD39F57-8E60-43A9-9CBF-F621EE31303D\"></a>A set of existing source streams can be supplied for situations where new data is\n\
               generated based on existing data. The specific streams that are required are returned\n\
               via a query to the generator (<span class=\"code\" translate=\"no\">getSourceStreams()</span>) before <span class=\"code\" translate=\"no\">createVertexStreams()</span> is invoked. \n\
            </p> \n\
            <p><a name=\"GUID-9BE866C1-23A5-4FC0-9027-5E0FE922EAE4\"></a>As an example, existing position and normal streams can be combined to form a new\n\
               stream. Since the input streams (<span class=\"code\" translate=\"no\">MVertexBuffers</span>) are GPU resources, they need to be mapped to CPU memory before they can be read\n\
               from. Any source stream data should never be modified. \n\
            </p> \n\
            <p><a name=\"GUID-A1CE8679-5D70-41FA-BC45-4E86A5702043\"></a>In order to fill in the data correctly, the indexing which is used to reference the\n\
               data stream is also provided. The generator provides the desired indexing for the\n\
               custom stream (<span class=\"code\" translate=\"no\">getSourceIndexing()</span>). It is possible that indexing optimization may be performed based on the indexing\n\
               for all internal and custom streams. Both the original and the shared indexing data\n\
               are provided to the generator at stream creation time. Indexing is specified using\n\
               an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MComponentDataIndexing\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_component_data_indexing.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_component_data_indexing.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MComponentDataIndexing</a></span> instance. This is a wrapper for a set of index values and a component type. \n\
            </p> \n\
            <p><a name=\"GUID-01E69AEA-B296-4458-8BF1-F311901B5F8A\"></a>It is the responsibility of the generator to perform the correct allocation and transfer\n\
               of data into the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span> that it is supplied. \n\
            </p> \n\
            <p><a name=\"GUID-4D64FAD8-D44B-45EF-9F23-8BBCE4BA47B8\"></a></p> <img src=\"images/GUID-251AC68F-2F99-42FD-912B-65B660DEBAA1-low.jpg\"> \n\
            <p><a name=\"GUID-F65B4495-4F4E-4127-B4DC-DB14ED6CF262\"></a>Figure 69: The flow of execution is roughly shown based on the ordering of the methods\n\
               on the buffer generator. From the top downwards, source stream and indexing requirements\n\
               are queried. At creation time any requested source streams, the relevant dag path\n\
               and the overall shared indexing are provided as inputs. The generator is responsible\n\
               for filling in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span>. In this case, it swizzles an input position and a normal stream into a new stream.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-6714F3B4-F76F-40BB-845B-0C339A36357A\"></a>Custom stream indexing should be provided using an: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxPrimitiveGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxPrimitiveGenerator</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-759E93DF-B46E-4569-820A-BA1BB7B95979\"></a>As with stream generators a unique name is used to identify the indexing that can\n\
               be used. For indexing, a shader instance specifies the required indexing using a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBufferDescriptor</a></span>. The primitive name in the descriptor can be set to the name of the primitive generator.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-6D44609B-B6FE-44F3-A24A-04FD2C8BC8FD\"></a>In order to use an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxPrimitiveGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxPrimitiveGenerator</a></span>, it needs to be registered via the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawRegistry</a></span> class in a similar fashion to that of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxVertexBufferGenerator</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-B10247A1-0823-49BF-8FD4-190B956DC3FA\"></a>There are two entry points which currently can support adding in indexing requirements:\n\
               For an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span> this is the point when its geometry requirements are defined and for an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span> this is the point when geometry requirements are defined for additional render items.\n\
               In either case, the requirements are specified by a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBufferDescriptor</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-D106FC65-DD7A-4098-9FF2-5CB6098DA9DB\"></a>To add custom indexing as a requirement, an appropriately set up <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBufferDescriptor</a></span> must be added. The type must be set to “custom” and a unique name set. This name\n\
               should match the name of a registered generator. \n\
            </p> \n\
            <p><a name=\"GUID-2D2F462D-7632-4619-AA28-41CEA7A3DBE9\"></a>This is an example of how a non-custom index requirement is added for an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span>: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometryRequirements</a> geomRequirements;\n\
\n\
// As we are not using MIndexBufferDescriptor::kCustom for custom named index buffers\n\
// just use an empty string here.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> noName;\n\
\n\
// Add in a triangle indexing requirement\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> triangleDesc(\n\
        MHWRender::MIndexBufferDescriptor::kTriangle, \n\
        noName, \n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTriangles</a>, \n\
        3, \n\
        compObj);\n\
\n\
geomRequirements.addIndexingRequirement(triangleDesc);</pre></div> \n\
            <p><a name=\"GUID-6FDEC9B7-B8FE-4165-BE24-77E04FE06529\"></a>This is an example of adding a custom indexing requirement for a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span>: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// Name of custom indexing \n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> customPrimitiveName(\"customPrimitive\");\n\
\n\
// Add in a custom triangle indexing requirement\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> indexingRequirement( \n\
        MHWRender::MIndexBufferDescriptor::kCustom, \n\
        customPrimitiveName, \n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTriangles</a>);\n\
        \n\
addIndexingRequirement(indexingRequirement);</pre></div> \n\
            <p><a name=\"GUID-91D5B024-BD0F-444D-BE44-47651CEB962F\"></a></p> <img src=\"images/GUID-5B184977-9F83-48F2-B8E2-F15CD85535C5-low.jpg\"> \n\
            <p><a name=\"GUID-E8315107-B369-496A-B791-E2D0CE40339A\"></a>Figure 70: Resulting relationship based on code example. \n\
            </p> \n\
            <p><a name=\"GUID-43E4FBEC-1166-4A56-BA56-FD3A34EEC8C2\"></a>When custom indexing is required the appropriate calls to a generator instance are\n\
               made. The generator first provides the indexing size relative to a DAG object and\n\
               DAG component (<span class=\"code\" translate=\"no\">computeIndexingCount()</span>). The generator is then asked to create the actual indexing. The source and target\n\
               indexing data is also provided. An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBuffer</a></span> must be updated and returned. As this is a GPU resource, it must be mapped back to\n\
               CPU memory, updated, and then transferred back to GPU memory. \n\
            </p> <img src=\"images/GUID-837E8A37-86DD-4168-B153-1C2BA9E385ED-low.jpg\"> \n\
            <p><a name=\"GUID-0EBB0A48-8F4B-4D96-BA4B-F0A69C76D6F6\"></a>Figure 71 \n\
            </p> \n\
            <p><a name=\"GUID-EF9FCBF1-62B5-4711-98C7-15147853BE11\"></a>Examples provided in the Developer Kit include: \n\
            </p> <a name=\"UL_A63F70B0036B41DCA2DB86DF5A35EF4A\"></a><ul>\n\
               <li><em class=\"mild\">vertexBufferGenerator</em>: Performs the swizzle of position and normal as previously described. Note that this\n\
                  plug-ins is dependent on the dx11Shader and cgfxShaderNode plug-ins which parse the\n\
                  sample effects files for semantic names and uses them as the name key to activate\n\
                  the generator. There is a slight difference different shader semantics used for CgFx\n\
                  and HLSL. For CgFx, arbitrary string names cannot be used and thus the generator uses\n\
                  attribute name semantics “ATTR7” and “ATTR8”; whereas for HLSL, the names “myCustomStream”\n\
                  and “myCustomStream2” can be used instead. \n\
               </li>\n\
               <li><em class=\"mild\">customPrimitiveGenerator</em>: An example of a primitive generator. The usage of this generator can be activated\n\
                  via the <em class=\"mild\">hwPhongShader</em> plug-in. \n\
               </li>\n\
               <li><em class=\"mild\">crackFreePrimitiveGenerator</em>: An example of indexing mutator which is used for producing custom indexing and data\n\
                  to support tessellation shaders in the dx11Shader plug-in. \n\
                  <p><a name=\"GUID-68D0D433-D52C-4D66-835D-828A55A4583A\"></a> <img src=\"images/GUID-8D29AA0C-E3AB-4DEC-89F5-A9389D93E8EE-low.jpg\"> \n\
                  </p> \n\
                  <p><a name=\"GUID-547778EF-92B1-459C-8360-61057A25BF7D\"></a> Figure 72 \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-2A6355CE-EE0C-429E-883B-73910C40C2A2\"></a> The crack free mutator creates an indexing buffer with more information than that\n\
               of a normal triangle list. The triangle indexing provides, for each triangle, the\n\
               indices of their 3 vertices. The crack free mutator provides indexing fit for tessellation.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-18D958CE-D2CA-429D-ACA6-377445ACAAD8\"></a> The sample currently implements support for the modes “PN-AEN9” and “PN-AEN18” (Point-Normal\n\
               Triangles using Adjacent Edge Normals). \n\
            </p> \n\
            <p><a name=\"GUID-C63D6E5D-5771-4253-BB2A-B71ADD100682\"></a> The PN-AEN9 mode creates indexing for each triangle with the following data: \n\
            </p> <a name=\"UL_2ED8FF3DC2304D1089B4276B5CEECC2B\"></a><ul>\n\
               <li>the 3 triangle vertices indexes, </li>\n\
               <li>the 6 vertex indexes of the adjacent edges. </li>\n\
            </ul> \n\
            <p><a name=\"GUID-87292050-F1E3-4630-9F74-BD177A4A636F\"></a> This results in a stride of 9 for the index array. Hence, the name PN-AEN9. \n\
            </p> \n\
            <p><a name=\"GUID-D1678B7B-0409-4641-BB8D-293447426AF0\"></a> Based on the above diagram, for a triangle represented by the vertices a, b and c,\n\
               the PNAEN9 code generates the following indexing: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"> [a b c] [d e f g h i]</pre></div> \n\
            <p><a name=\"GUID-B41E444A-2E44-4CE9-AACE-23BF4B5CD6E0\"></a> The PN-AEN18 adds even more data than PN-AEN9: \n\
            </p> <a name=\"UL_A56582082975455FBBE0AA6455C59CFC\"></a><ul>\n\
               <li>3 triangle vertices indices </li>\n\
               <li>6 vertex indices of the adjacent edges </li>\n\
               <li>6 vertex indices of the dominant edges </li>\n\
               <li>3 vertices of the dominant uv position. </li>\n\
            </ul> \n\
            <p><a name=\"GUID-3AE76E2E-4A78-4AF8-B52D-E01EE5FC84ED\"></a> This results in a stride of 18 for the index array. \n\
            </p> \n\
            <p><a name=\"GUID-544D80B4-D7B0-4B18-8B43-3D8094A3D021\"></a>A dominant edge is the edge that has the lowest vertex indices. In the same example\n\
               above, the dominant edge between <span class=\"code\" translate=\"no\">[ab]</span> and <span class=\"code\" translate=\"no\">[de]</span> for triangle <span class=\"code\" translate=\"no\">[abc]</span> will be <span class=\"code\" translate=\"no\">[ab]</span> and for triangle <span class=\"code\" translate=\"no\">[dej]</span> it will still be <span class=\"code\" translate=\"no\">[ab]</span> \n\
            </p> \n\
            <p><a name=\"GUID-EA8BCE85-AB63-4454-883E-071DA9CE32CC\"></a>A dominant uv position is the triangle for which each vertex has the lowest uv coordinates.\n\
               In the example above, the dominant position for triangle <span class=\"code\" translate=\"no\">[abc]</span> is <span class=\"code\" translate=\"no\">[afh]</span> \n\
            </p> <a name=\"UL_D227EF9B9A8F4917BF92BA600779F9DA\"></a><ul>\n\
               <li>if the uv coordinates of <span class=\"code\" translate=\"no\">[a]</span> are lower than those of <span class=\"code\" translate=\"no\">[d]</span>, <span class=\"code\" translate=\"no\">[i]</span>, <span class=\"code\" translate=\"no\">[r]</span> and <span class=\"code\" translate=\"no\">[s]</span> \n\
               </li>\n\
               <li>if the uv coordinates of <span class=\"code\" translate=\"no\">[f]</span> are lower than those of <span class=\"code\" translate=\"no\">[b], [e], [k], [l]</span> and <span class=\"code\" translate=\"no\">[m]</span> \n\
               </li>\n\
               <li>if the uv coordinates of <span class=\"code\" translate=\"no\">[h]</span> are lower than those of <span class=\"code\" translate=\"no\">[c], [g], [o], [p]</span> and <span class=\"code\" translate=\"no\">[q]</span> \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-10D7B872-28E0-4BAE-BD6D-69BDDA569586\"></a>The PN-AEN18 code generates the following indexing: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">[a b c] [d e f g h i] [a b f g h i] [a f h]</pre></div> \n\
            <p><a name=\"GUID-0292F5AC-983E-4281-934F-6B6AD0BCB073\"></a>The dx11Shader and CgFx plug-in respectively show usage of generators for HLSL and\n\
               CgFx. The dx11Shader explicitly registers the crack-free tesselator mutators for shader\n\
               semantics “PNAEN9” and “PNAEN18”. \n\
            </p> \n\
            <p><a name=\"GUID-4830D8BE-61FF-4A9D-BECE-E43002477529\"></a>The SDK provided sample shader (AutodeskUberShader.fx) uses the following technique\n\
               declaration to notify the API of the special indexing requirements: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">technique11 TessellationON\n\
&lt;\n\
    string index_buffer_type = \"PNAEN18\"; // Indicate index buffer type required\n\
&gt;\n\
{  \n\
    pass p0\n\
    {\n\
        SetRasterizerState(CullFront);\n\
        SetDepthStencilState(DepthNormal, 0);\n\
        SetVertexShader(CompileShader(vs_5_0, vt()));\n\
        SetHullShader(CompileShader(hs_5_0, HS()));\n\
        SetDomainShader(CompileShader(ds_5_0, DS()));\n\
        SetGeometryShader(NULL);                                \n\
        SetPixelShader(CompileShader(ps_5_0, f()));\n\
    }\n\
}\n\
</pre></div> \n\
            <p><a name=\"GUID-09938AC9-A561-4E03-B749-A11056B976AA\"></a>In this case, an annotation per technique is being parsed within the plug-in code.\n\
               The <em class=\"mild\">customIndexingMutatorName</em> string value “PNAEN18” is the semantic name on an index descriptor requirement, which,\n\
               at update time, calls the registered crack-free indexing mutator. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> customIndexingMutatorName;\n\
\n\
ID3DX11EffectTechnique * mpD3DTechnique;\n\
\n\
ID3DX11EffectVariable* indexBufferType = \n\
        mpD3DTechnique-&gt;GetAnnotationByName(\"index_buffer_type\");\n\
\n\
if(indexBufferType &amp;&amp; indexBufferType-&gt;IsValid())\n\
{\n\
    ID3DX11EffectStringVariable* indexBufferTypeStr = indexBufferType-&gt;AsString();\n\
    if(indexBufferTypeStr &amp;&amp; indexBufferTypeStr-&gt;IsValid())\n\
    {\n\
        LPCSTR value; \n\
        if( SUCCEEDED ( indexBufferTypeStr-&gt;GetString( &amp;value ) ) )\n\
        {\n\
            customIndexingMutatorName = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a>(value);\n\
        }\n\
    }\n\
}</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"AA1018554\"></a> \n\
            <h2><a name=\"GUID-889E365A-4A62-426E-8FA0-3BCCB49BE1C7\"></a>Geometry Mutators \n\
            </h2> \n\
            <p><a name=\"GUID-3F8FAD95-2E63-420A-BC74-7724E62C807E\"></a>As the name implies a mutator can be used to modify the packing of data for a given\n\
               existing vertex buffer (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span>). As with stream generators, mutators are associated with a descriptor through name\n\
               matching between the mutator and the semantic name on a descriptor (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBufferDescriptor</a></span>) \n\
            </p> \n\
            <p><a name=\"GUID-C092B968-F99B-4DE0-ACE7-E8F618926B10\"></a>A mutator is represented as an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferMutator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_mutator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_mutator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxVertexBufferMutator</a></span>. Mutators must be registered with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawRegistry</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-80B42E9B-1ED7-4853-9669-E199FA258B54\"></a>This example illustrates how to specify an existing mutator for use: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> empty;\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> positionDesc(\n\
        empty,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4aa20581584e5f9447cb96afb4f2e10703&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kPosition</a>,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
        3);\n\
        \n\
// Use the custom semantic name \"swizzlePosition\" which corresponds to a plug-in which will\n\
// swizzle the x,y, and z channels of a position stream using this positionDesc.setSemanticName(\"swizzlePosition\"); \n\
\n\
// Add the descriptor as part of the requirements for this shader\n\
addGeometryRequirement(positionDesc);\n\
</pre></div> \n\
            <p><a name=\"GUID-34C0D16E-7649-483D-9A39-1A2FEAC62AE5\"></a>The following diagram illustrates the relationship of the above code example. An additional\n\
               “customMutator” is added to show the lookup by semantic name. \n\
            </p> \n\
            <p><a name=\"GUID-51081786-6A98-4D99-B82C-44F0CD77131C\"></a></p> <img src=\"images/GUID-9C793830-D2D1-4F4E-A34E-FE48B1B9D229-low.jpg\"> \n\
            <p><a name=\"GUID-0060FEB5-155B-4F4E-AB78-314593B2F94B\"></a>Figure 73 \n\
            </p> \n\
            <p><a name=\"GUID-C59B1485-4AC4-44DB-B4EE-A77449259186\"></a>When a mutator is required to perform an update, an associated Maya DAG path and data\n\
               stream indexing are passed in. An existing <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVertexBuffer</a></span> is passed in for update and data is modified in-place. \n\
            </p> <img src=\"images/GUID-B443C7E6-66EE-4D85-A79D-B51083105266-low.jpg\"> \n\
            <p><a name=\"GUID-8EA49DFE-CF1D-43CB-B1D8-D44A790308E3\"></a>Figure 74 \n\
            </p> \n\
            <p><a name=\"GUID-DD46E457-42F7-4923-B85C-C836F0617F97\"></a>The Developer Kit example <em class=\"mild\">vertexBufferMutator</em> has the full code for registering a mutator which performs the swizzle. The hwPhongShader\n\
               plug-in has code which demonstrates the usage of the custom swizzle. \n\
            </p> \n\
            <p><a name=\"GUID-29CF724C-83B4-4C70-815F-42CBDC67CEA8\"></a>The following is an excerpt from the sample code which shows how in-place editing\n\
               is performed: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// Input argument\n\
MVertexBuffer&amp; vertexBuffer;\n\
\n\
unsigned int vertexCount = vertexBuffer.vertexCount();\n\
if (vertexCount &lt;= 0)\n\
    return;\n\
    \n\
// Acquire the buffer to fill with data. Data is not in CPU memory\n\
float* buffer = (float*)vertexBuffer.acquire(vertexCount);\n\
float* start = buffer;\n\
\n\
for (unsigned int i = 0; i &lt; vertexCount; ++i)\n\
{\n\
    // Here we swap the x, y and z values\n\
    float x = buffer[0];\n\
    buffer[0] = buffer[1];    // y --&gt; x\n\
    buffer[1] = buffer[2];    // z --&gt; y\n\
    buffer[2] = x;            // x --&gt; z\n\
    buffer += 3;\n\
}\n\
\n\
// Commit the buffer to signal completion. CPU data will be transferred to GPU memory.\n\
vertexBuffer.commit(start);\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"AA1018928\"></a> \n\
            <h2><a name=\"GUID-2D2DA9A4-7457-4B88-8B46-7195AA0AA127\"></a>Indexing Mutators \n\
            </h2> \n\
            <p><a name=\"GUID-F01CC2D0-9F79-4344-AB73-803A63DEDD38\"></a>An indexing mutator can be used to modify the data for a given existing index buffer\n\
               (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBuffer</a></span>). Mutators are associated with a descriptor through name matching between the mutator\n\
               and the semantic name on a descriptor (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIndexBufferDescriptor</a></span>) \n\
            </p> \n\
            <p><a name=\"GUID-783BE1EB-EFCC-439B-A212-645D122C3603\"></a>A mutator is represented as an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxIndexBufferMutator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_index_buffer_mutator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_index_buffer_mutator.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxIndexBufferMutator</a></span>. Mutators must be registered with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDrawRegistry</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-F7778127-B033-402A-985B-EE07A25141D7\"></a>This example illustrates how to specify an existing mutator for use: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> indexingRequirement(\n\
        MHWRender::MIndexBufferDescriptor::kCustom,\n\
        customIndexingMutatorName,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kTriangles</a>);\n\
        \n\
// Add the descriptor as part of the requirements for this shader\n\
addIndexingRequirement(indexingRequirement);\n\
</pre></div> \n\
            <p><a name=\"GUID-308E34D5-2F7E-4CDD-85FD-4A39B1894CF5\"></a>The following diagram illustrates the relationship of the above code example. An additional\n\
               “customMutator” is added to show the lookup by semantic name. \n\
            </p> \n\
            <p><a name=\"GUID-30AD30B4-5779-4A44-94B2-243CA5E1A67C\"></a></p> <img src=\"images/GUID-DB4978D3-1094-41D9-B7DD-6EFBE5A6AC8B-low.png\"> \n\
            <p><a name=\"GUID-C6F120EC-ACD2-4E9E-88AD-44178DE9495F\"></a>Figure 75 \n\
            </p> \n\
            <p><a name=\"GUID-A176A394-24E6-4621-AA2D-2A9846D0DFD6\"></a>When a mutator is required to perform an update, an associated data stream indexing\n\
               and previously generated vetex buffer array are passed in. An existing MIndexBuffer\n\
               is passed in for update and data is modified in-place. \n\
            </p> \n\
            <p><a name=\"GUID-D779046F-CC1E-4577-A2A3-7BAA8D5FA67F\"></a></p> <img src=\"images/GUID-10B21D2E-A57C-4D25-9F2C-E05A76BAEC2F-low.png\"> \n\
            <p><a name=\"GUID-F8B01FF9-89BD-4CF7-8041-43807BE19F70\"></a>Figure 76 \n\
            </p> \n\
            <p><a name=\"GUID-18C0784E-AEF2-46A0-9691-4CFC8EE2E77A\"></a>The Developer Kit example <em class=\"mild\">crackFreePrimitiveGenerator</em>, part of the dx11Shader project has the full code for registering a mutator which\n\
               performs PN AEN patch generation. The dx11Shader plug-in has code which demonstrates\n\
               the usage of the custom patch when the “TessellationON” or “Wireframe” techniques\n\
               of the MayaUberShader.fx effect file is selected. \n\
            </p> \n\
            <p><a name=\"GUID-2E43A844-B97C-425C-9ECA-F9286860D350\"></a>The following is an excerpt from the sample code which shows how in-place editing\n\
               is performed: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">// Input argument\n\
MIndexBuffer&amp; indexBuffer;\n\
\n\
// Acquire the buffer to fill with data. Data is not in CPU memory\n\
unsigned int* buffer = (unsigned int *) indexBuffer.acquire(numTri * triSize, true);\n\
unsigned int* start = buffer;\n\
\n\
for (unsigned int i = 0; i &lt; numTri; ++i)\n\
{\n\
    // Here we fill PN AEN information\n\
    buffer[0] = vertexId0; \n\
    buffer[1] = vertexId1;\n\
    buffer[2] = vertexId2;\n\
    // ...\n\
    buffer[17] = dominantVertex2;\n\
    buffer += triSize;\n\
}\n\
\n\
// Commit the buffer to signal completion. CPU data will be transferred to GPU memory.\n\
indexBuffer.commit(start);\n\
primitiveStride = triSize; // Output argument\n\
return <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPatch\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1ea23d4e011c2b72a286021ca9a5a121830&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MGeometry::kPatch</a>;\n\
</pre></div> \n\
            <p><a name=\"GUID-7EC9B772-429C-487B-AB36-DFF2EBC878AC\"></a> <em class=\"strong\">Pipeline Summary: </em> \n\
            </p> <img src=\"images/GUID-DD9657B3-5DC5-4B56-9D01-B6CCE8BCDF51-low.jpg\"> \n\
            <p><a name=\"GUID-154C0C1A-3714-4B48-A254-8A2379277E33\"></a>Figure 77 \n\
            </p> \n\
            <p><a name=\"GUID-24698DB3-75F8-4536-8DDD-7A8C3EFF3768\"></a>The above diagram shows how generators and mutators fit in the overall pipeline. Shown\n\
               is a shader override which has custom requirements (based on shader parameters) for\n\
               the generation and mutation of vertex buffers, and primitive generation (as represented\n\
               by the descriptors). When updates need to occur (Update phase), the shader requirements\n\
               on an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxGeometryOverride</a></span> are name matched to generators and mutators which are invoked to update or create\n\
               vertex and index buffers. These custom buffers can be used by one or more render items\n\
               which flow down the pipeline until it reaches the Draw Phase. At this point, the custom\n\
               vertex and index buffers can be bound to the shader parameters which initiated the\n\
               custom data requirement. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";