var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-13434252-F0BF-4AC0-B47B-09BD626B0881\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using Qt in Plug-ins</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-13434252-F0BF-4AC0-B47B-09BD626B0881\"></a><div class=\"head\">\n\
            <h1>Using Qt in Plug-ins</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755527CC80126D167FFA2-7161\"></a> \n\
            <h2><a name=\"GUID-EF0BF352-EE75-4E5D-ACA6-DEF8A255B547\"></a>Preparing for development\n\
            </h2> <a name=\"FIG_347811D408EC4C4E908A2E95B7B0E3D7\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-18F963A9-A2D7-4CA7-B4B1-EDBC323666BF-low.png\"></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7160\"></a>Maya uses a customized version of The Qt Company\'s Qt framework and ships with its\n\
               own versions of all the libraries and header files you need to use Qt in your plug-ins.\n\
               On Linux and OS X the libraries are in Maya\'s \n\
               		  <em class=\"strong\">lib</em> directory. On Windows the link libraries are in Maya\'s \n\
               		  <em class=\"strong\">lib</em> folder and the DLLs are in Maya\'s \n\
               		  <em class=\"strong\">bin</em> folder. On all platforms the header files are shipped as a compressed archive (e.g.\n\
               qt-5.6.1-include.tar.gz) in the \n\
               		  <em class=\"strong\">include</em> directory of your Developer Kit installation. Before doing any Qt plug-in work, uncompress\n\
               the archive into a directory where you have write permission and be sure to include\n\
               that directory ahead of any others in your include path. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-89E9EC3C-7C41-4DA3-9B06-DE270FD0AA6D\"></a>You can create custom UI for Maya using Qt Designer. For Windows and Linux users,\n\
               Qt Designer is installed with Maya. For Mac OS X users, you can find Qt Designer directly\n\
               at the Qt Development Tools website; or, you can build Qt from source. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-83E72B87-6873-4B47-A2B2-21AD0631CDD3\"></a>To obtain Qt Designer, you can also install The Qt Company\'s standard version of Qt\n\
               on your system or download a copy of the customized Qt source from Autodesk\'s Open\n\
               Source web-site (<a href=\"http://www.autodesk.com/lgplsource\" target=\"_blank\">http://www.autodesk.com/lgplsource</a>) and building the tools yourself. If you choose the latter option the download includes\n\
               text files describing how to configure, build and install Qt for each platform supported\n\
               by Maya. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755527CC80126D167FFA2-715F\"></a> \n\
            <h2><a name=\"GUID-3A443612-FD5E-43C7-B943-AF5FCE6356AB\"></a>Writing The Plug-in\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-715E\"></a>If you were writing your own Qt application from scratch, you would need to create\n\
               your own QCoreApplication or QApplication instance to handle your application\'s event\n\
               loop. When writing a Maya plug-in, you must instead use Maya\'s own application object\n\
               which can be retrieved using Qt\'s \n\
               		  <em class=\"strong\">qApp</em> macro. The example code below uses the \n\
               		  <em class=\"strong\">qApp</em> macro to retrieve Maya\'s application name: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
QCoreApplication*  app = qApp;\n\
if (app) {\n\
    cout &lt;&lt; \"Application name is \'\" &lt;&lt; app-&gt;applicationName().toStdString() &lt;&lt; \"\'\" &lt;&lt; endl;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-715D\"></a>Creating new windows and dialogs using Qt is done the same way as you would if you\n\
               were writing a standalone Qt application. The helixQtCmd plug-in in the Developer\n\
               Kit gives a very simple example of this. The plug-in provides the helixQt command\n\
               which creates a Qt-based button. Whenever the button is pressed it uses API calls\n\
               to create a helical curve within Maya. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-715C\"></a>The button is a regular Qt pushButton with a createHelix() slot added to handle the\n\
               creation of the curve. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class HelixButton : public QPushButton\n\
{\n\
&nbsp;&nbsp; Q_OBJECT\n\
public:\n\
 &nbsp;&nbsp;HelixButton(const QString&amp; text, QWidget* parent = 0); \n\
&nbsp;&nbsp;&nbsp;virtual	~HelixButton();\n\
public slots:\n\
 &nbsp;&nbsp;void	createHelix(bool checked);\n\
};\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-715B\"></a>Whenever the helixQt command is executed, it first checks to see if the button already\n\
               exists. If not then it creates the button and connects its \n\
               		  <em class=\"strong\">clicked</em> signal to its \n\
               		  <em class=\"strong\">createHelix</em> slot, so that whenever the button is clicked the code to create the helix will be\n\
               executed: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
QPointer	HelixQtCmd::button;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> HelixQtCmd::doIt(const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a>&amp; /* args */)\n\
{\n\
 &nbsp;&nbsp;if (button.isNull()) {\n\
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;button = new HelixButton(\"Create Helix\");\n\
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;button-&gt;connect(button, SIGNAL(clicked(bool)), button, SLOT(createHelix(bool)));\n\
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;button-&gt;show();\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-715A\"></a>If the button already exists, then the command simply ensures that it is visible and\n\
               not hidden beneath other windows: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
&nbsp;&nbsp;&nbsp;else {\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;button-&gt;showNormal();\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;button-&gt;raise();\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} \n\
&nbsp;&nbsp;&nbsp;return MS::kSuccess;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7159\"></a>Controls created directly using Qt are not in general recognized by Maya\'s UI commands.\n\
               The \n\
               		  <span class=\"code\" translate=\"no\">IsUI</span> command does not list them and the commands for specific types of controls, such\n\
               as \n\
               		  <span class=\"code\" translate=\"no\">button</span>, do not recognize them. The generic control command is an exception, though. So long\n\
               as the control has been given a unique name, then the \n\
               		  <span class=\"code\" translate=\"no\">control</span> command can be used to test for its existence and perform basic operations on the\n\
               control such as setting its visibility. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7158\"></a>For example, if the createHelix method of the helixQtCmd plug-in had given the button\n\
               the unique name of \"myButton\": \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
&nbsp;&nbsp;&nbsp;button = new HelixButton(\"Create Helix\");\n\
&nbsp;&nbsp;&nbsp;button-&gt;setObjectName(\"myButton\");\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7157\"></a>then the following MEL script could be used to hide the button: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
if (`control -q -exists myButton`) {\n\
&nbsp;&nbsp;&nbsp;control -e -visible false myButton;\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7156\"></a>However, the same code using the \n\
               		  <span class=\"code\" translate=\"no\">button</span> command would not work because \n\
               		  <span class=\"code\" translate=\"no\">button</span> only recognizes those buttons which it has created: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
if (`button -q -exists myButton`) {      // Will always be false.\n\
 &nbsp;&nbsp;button -e -visible false myButton;   // Will never be executed.\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7155\"></a>It may sometimes be desirable to use Qt to directly access UI elements created using\n\
               Maya commands. The \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a></span> API class provides methods for retrieving the Qt object underlying a Maya control,\n\
               layout, window or menu item. For example, if you have a Maya checkBox control named\n\
               \"myCheckBox\" which was created with the following MEL script: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
window;\n\
columnLayout;\n\
checkBox myCheckBox;\n\
showWindow;\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7154\"></a>You can use the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a></span> class to retrieve the checkBox\'s QWidget pointer, and from that determine the current\n\
               state of the checkBox: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
QWidget* control = <a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::findControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a4117d34bd18ee0fa108c4952bda68e94&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil::findControl</a>(\"myCheckBox\");\n\
if (control) {\n\
 &nbsp;&nbsp;QCheckBox* cb = qobject_cast(control);\n\
 &nbsp;&nbsp;if (cb) {\n\
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if (cb-&gt;isChecked()) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal::displayInfo</a>(\"myCheckBox is checked\");\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; } else {\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal::displayInfo</a>(\"myCheckBox is not checked\");\n\
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}\n\
 &nbsp;&nbsp;}\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7153\"></a>The example above also serves to illustrate why you must always be careful using MQtUtil.\n\
               The code will only work if Maya\'s \n\
               		  <span class=\"code\" translate=\"no\">checkbox</span> command creates a QCheckBox widget or something derived from QCheckBox. While that\n\
               may be the case in the current version of Maya, it could change in some future version.\n\
               If you write code which uses Qt to directly access UI elements created using Maya\n\
               commands, then it is up to you to ensure that your code still behaves as expected\n\
               in each new release of Maya. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7152\"></a>Layouts are an even greater minefield of potential problems: \n\
               		\n\
            </p> <a name=\"WS73099CC142F48755527CC80126D167FFA2-7151\"></a><ul>\n\
               <li>In Maya, a layout is considered to be part of the widget hierarchy, while in Qt it\n\
                  is not. To get around this, Maya creates proxy widgets for most, but not all, layouts.\n\
                  \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a></span> provides some methods to make navigating through layouts easier, but keeping track\n\
                  of the proxy versus the actual layout can still be challenging for the plug-in writer\n\
                  and a common source of bugs. \n\
                  		  \n\
               </li>\n\
               <li>Some of Maya\'s controls and layouts have special code to interact with each other.\n\
                  If you try adding your own Qt-created controls to a Maya layout, or a Maya control\n\
                  to your own Qt-created layout, you may get unexpected results. Even using Qt to add\n\
                  a Maya control to Maya layout may cause problems. \n\
                  		  \n\
               </li>\n\
               <li>Some of Maya\'s layouts are not implemented as a single Qt layout but rather as a small\n\
                  hierarchy of layouts and controls. \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a></span> provides methods to help in navigating these complex layouts, but care must be taken.\n\
                  \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-714D\"></a>See \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil</a></span> for a more in-depth discussion of these and other issues surrounding layouts. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755527CC80126D167FFA2-714B\"></a> \n\
            <h2><a name=\"GUID-E408D8FD-6C63-424F-8969-71287B2B5FD9\"></a>Building the plug-in\n\
            </h2> <a name=\"FIG_1F39BFE8B00D4ADAAC02F070E895CFBE\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-18F963A9-A2D7-4CA7-B4B1-EDBC323666BF-low.png\"></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-714A\"></a>As noted at the start of this section, Maya ships with customized versions of the\n\
               Qt libraries and header files. It is important to ensure that the directory containing\n\
               Maya\'s version of the headers appears in your include path before those which you\n\
               may have in a separate Qt installation elsewhere on your system, and that the directory\n\
               containing Maya\'s version of the libraries appears in your library path before any\n\
               others. \n\
               		\n\
            </p> \n\
            <p>It is important to use the version of qmake that is provided with the Maya Developer\n\
               Kit. After running qmake, a makefile is generated that can be used to build the Qt\n\
               plug-in. \n\
               		\n\
            </p> \n\
            <p>To build the Qt plug-ins provided with the Maya Developer Kit, follow these steps:\n\
               \n\
               		\n\
            </p> <a name=\"OL_610E1FB206564D2AB8E1FBBB391889A8\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Use the following Qt archives from the Maya installation, and extract them in place.\n\
                  \n\
                  			 \n\
                  <p>You can also obtain the same files from the Maya Developer Kit: \n\
                     			 \n\
                  </p> <a name=\"UL_26F1533C60D445B2BE093D58531A60B0\"></a><ul>\n\
                     <li><span class=\"code\" translate=\"no\">include/qt-5.6.1-include.tar.gz</span> \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">mkspecs/qt-5.6.1-mkspecs.tar.gz</span> \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">lib/cmake/qt-5.6.1-cmake.tar.gz</span> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li>Obtain the plug-in example files from the Maya Developer Kit; for example, the \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"helixQtCmd.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/helix_qt_cmd_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">helixQtCmd.cpp</a></span>, \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"helixQtCmd.h\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/helix_qt_cmd_8h-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">helixQtCmd.h</a></span>, and \n\
                  			 <span class=\"code\" translate=\"no\">helixQtCmd.pro</span> files for the \n\
                  			 <em class=\"mild\">helixQtCmd</em> example. \n\
                  		  \n\
               </li>\n\
               <li>Create a \n\
                  			 <span class=\"code\" translate=\"no\">helixQtCmd</span> directory. \n\
                  			 \n\
                  <p>Copy the aforementioned \n\
                     				<span class=\"code\" translate=\"no\">helixQtCmd.*</span> files to the \n\
                     				<span class=\"code\" translate=\"no\">helixQtCmd</span> directory. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li>Copy the \n\
                  			 <span class=\"code\" translate=\"no\">qtconfig</span> file (from the \n\
                  			 <span class=\"code\" translate=\"no\">devkit/plug-ins</span> directory) to the \n\
                  			 <span class=\"code\" translate=\"no\">helixQtCmd</span> directory. \n\
                  		  \n\
               </li>\n\
               <li>Set your MAYA_LOCATION environment variable to point to your Maya installation, and\n\
                  the DEVKIT_LOCATION environment variable to point to the directory where the devkit\n\
                  \n\
                  			 <span class=\"code\" translate=\"no\">include</span>, \n\
                  			 <span class=\"code\" translate=\"no\">mkspecs</span>, and \n\
                  			 <span class=\"code\" translate=\"no\">cmake</span> directories are located. \n\
                  		  \n\
               </li>\n\
               <li>Navigate to the \n\
                  			 <span class=\"code\" translate=\"no\">helixQtCmd</span> directory. \n\
                  		  \n\
               </li>\n\
               <li>Run the version of \n\
                  			 <em class=\"strong\">qmake</em> that is \n\
                  			 <em class=\"strong\">provided with the Maya Developer Kit</em>. \n\
                  			 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">$DEVKIT_LOCATION/devkit/bin/qmake helixQtCmd.pro</pre></div> \n\
                  <p>A \n\
                     				<span class=\"code\" translate=\"no\">makefile</span> is created as a result. On Mac OS X, the make file is named per plugin with a \n\
                     				<span class=\"code\" translate=\"no\">.mak</span> extension. On Linux and Windows, it is \n\
                     				<span class=\"code\" translate=\"no\">Makefile</span>: \n\
                     			 \n\
                  </p> <a name=\"UL_F04BF7DBA1FC42EF93351D218FA8AC40\"></a><ul>\n\
                     <li>Linux/Windows: \n\
                        				  <span class=\"code\" translate=\"no\">Makefile</span> \n\
                     </li>\n\
                     <li>Mac OS X: \n\
                        				  <span class=\"code\" translate=\"no\"> helixQtCmd.mak</span> \n\
                     </li>\n\
                  </ul> \n\
                  <p>A top level \n\
                     				<span class=\"code\" translate=\"no\">Makefile.qt</span> is provided for Linux and Windows, while a \n\
                     				<span class=\"code\" translate=\"no\">make –fhelixQtCmd.mak \n\
                        				</span> is provided for Mac OS X. You use these files to build the default Qt plug-ins. \n\
                     			 \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p>Run \n\
                     				<span class=\"code\" translate=\"no\">make</span> using the generated \n\
                     				<span class=\"code\" translate=\"no\">Makefile</span> as follows: \n\
                     			 \n\
                  </p> <a name=\"WS73099CC142F48755527CC80126D167FFA2-7149\"></a><ul>\n\
                     <li>Linux: \n\
                        				  <span class=\"code\" translate=\"no\">make –f Makefile</span> \n\
                     </li>\n\
                     <li>Mac OS X: \n\
                        				  <span class=\"code\" translate=\"no\">make –f helixQtCmd.mak</span> \n\
                     </li>\n\
                     <li>Windows: \n\
                        				  <span class=\"code\" translate=\"no\">nmake /f Makefile</span> \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
            </ol> \n\
            <div><a name=\"GUID-7B1E0E6B-2EAA-48CC-8368-841714997C9D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
               </div>\n\
            </div> \n\
            <p><a name=\"GUID-7D5FBD3A-60A5-4EF0-9ABB-F5A6BF5A5890\"></a><span class=\"code\" translate=\"no\">Makefile</span> requires a qmake project file ending with the extension \n\
               		  <span class=\"code\" translate=\"no\">.pro</span>. Shown below is \n\
               		  <span class=\"code\" translate=\"no\">helixQtCmd.pro</span>, the project file provided in the Developer Kit for the helixQtCmd plug-in. It provides\n\
               a good example of the straightforward nature of the majority of project files. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
include(qtconfig)\n\
TARGET = helixQtCmd\n\
HEADERS += helixQtCmd.h\n\
SOURCES += helixQtCmd.cpp\n\
LIBS += -lOpenMayaUI\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7143\"></a>The \n\
               		  <em class=\"strong\">TARGET</em> setting contains the name of the plug-in, excluding its platform-specific extension.\n\
               \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7142\"></a>The \n\
               		  <em class=\"strong\">HEADERS</em> setting contains a space-separated list of all the header files which are part of\n\
               the plug-in. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7141\"></a>The \n\
               		  <em class=\"strong\">SOURCES</em> setting contains a space-separated list of all the source files which are part of\n\
               the plug-in. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7140\"></a>By default, the plug-in is automatically linked to Maya\'s \n\
               		  <em class=\"strong\">Foundation</em> and \n\
               		  <em class=\"strong\">OpenMaya</em> libraries. If the plug-in needs other libraries, then they should be added to the\n\
               \n\
               		  <em class=\"strong\">LIBS</em> setting. Library names should be preceded by \'-l\' while additional library directories\n\
               should be specified using \'-L\'. For example: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
LIBS += -L/usr/local/lib -lxml\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-713F\"></a>For more complex needs, please refer to Qt\'s qmake documentation. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755527CC80126D167FFA2-713E\"></a> \n\
            <h2><a name=\"GUID-708B5098-21F8-49EE-9D11-D758AD6264E0\"></a>Debugging\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-713D\"></a>All of the example Qt plug-ins are built in release (that is, non-debug) mode. To\n\
               build them for debug, turn on qmake\'s debug configuration parameter by doing the following\n\
               in your .pro file: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
CONFIG += debug\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-713C\"></a>That should be sufficient to build your plug-in for debug on Linux and OS X. Unfortunately,\n\
               on Windows, the debug configuration setting does not just compile your plug-in with\n\
               debugging information, but it also forces the plug-in to link with the debug versions\n\
               of the Qt libraries. That makes the plug-in incompatible with Maya, which was linked\n\
               using the release versions of the Qt libraries. Depending upon which Qt classes your\n\
               plug-in uses, it may or may not load into Maya, but even if it does successfully load,\n\
               it is unlikely to perform correctly since it will not have access to Maya\'s QCoreApplication\n\
               or other Qt global values.To get around this, set the \n\
               		  <em class=\"mild\">debug</em> configuration parameter described above and build the intermediate makefiles using\n\
               the following command, substituting the name of your plug-in for \n\
               		  <em class=\"mild\">myPlugin</em>: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
nmake /f Makefile.qt myPlugin.mak\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7137\"></a>This generates, among other things, a \n\
               		  <span class=\"code\" translate=\"no\">.mak.Debug</span> file for your plug-in (for example, \n\
               		  <span class=\"code\" translate=\"no\">myPlugin.mak.Debug</span>). Edit that file, find the \n\
               		  <em class=\"strong\">LIBS</em> line, and replace all of the debug Qt libraries with their non-debug versions by\n\
               removing the final \n\
               		  <em class=\"mild\">d</em> from their names. For example, in \n\
               		  <span class=\"code\" translate=\"no\">helixQtCmd.mak.Debug</span> the \n\
               		  <em class=\"strong\">LIBS</em> line would initially look like this: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
LIBS = /LIBPATH:..\\..\\lib ..\\..\\lib\\OpenMaya.lib ..\\..\\lib\\Foundation.lib ..\\..\\lib\\OpenMayaUI.lib c:\\qt-adsk-5.6.1\\lib\\QtGuid4.lib c:\\qt-adsk-5.6.1\\lib\\QtCored4.lib`\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7136\"></a>You would replace \n\
               		  <span class=\"code\" translate=\"no\">QtGuid4.lib</span> with \n\
               		  <span class=\"code\" translate=\"no\">QtGui4.lib</span>, and \n\
               		  <span class=\"code\" translate=\"no\">QtCored4.lib</span> with \n\
               		  <span class=\"code\" translate=\"no\">QtCore4.lib</span>, leaving you with this: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
LIBS = /LIBPATH:..\\..\\lib ..\\..\\lib\\OpenMaya.lib ..\\..\\lib\\Foundation.lib ..\\..\\lib\\OpenMayaUI.lib c:\\qt-adsk-5.6.1\\lib\\QtGui4.lib c:\\qt-adsk-5.6.1\\lib\\QtCore4.lib`\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7135\"></a>Now use the modified \n\
               		  <span class=\"code\" translate=\"no\">.mak.Debug</span> file to explicitly build your plug-in: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
nmake /f myPlugin.mak.Debug debug\\myPlugin.mll\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-7130\"></a>This still leaves one potential problem area on Windows. Qt\'s QList template class\n\
               provides inline methods which can create and destroy Qt objects. Because those methods\n\
               are inlined, if they are called by plug-in code which has been built for debug, any\n\
               objects created or deleted will use the memory allocator from the debug version of\n\
               Microsoft\'s C Runtime Library. If the methods are called within Maya, they will use\n\
               the release version of the C Runtime Library. Thus it is possible to get situations\n\
               where objects are allocated within Maya using the release runtime library and deleted\n\
               in the plug-in using the debug runtime library, or vice-versa. Since the release and\n\
               debug versions of Microsoft\'s C Runtime Library are incompatible with each other,\n\
               this can lead to crashes. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755527CC80126D167FFA2-712F\"></a>At the moment, QList is the only Qt class we are aware of which has this potential\n\
               for failure, but other Qt template classes could exhibit similar problems. To date,\n\
               the only known workarounds are either to avoid the use of Qt template classes in your\n\
               code, or to only build your plug-in in release mode on Windows. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";