var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-258601E3-3783-4709-8DD7-916BD60FD918\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Internationalization Process</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-258601E3-3783-4709-8DD7-916BD60FD918\"></a><div class=\"head\">\n\
            <h1>Internationalization Process</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7FD\"></a>Internationalization enables the plug-in to support localized strings in its user\n\
            interface and to operate correctly in localized environments. The process of localizing\n\
            the string resources is a separate set of steps outlined later in this document. Localization\n\
            can take place any time after the plug-in has been internationalized, the plug-in\n\
            will continue to work using the default resource values until translations are available.\n\
            \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7FC\"></a>The following steps are involved in internationalization: \n\
         </p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7FB\"></a><ol type=\"1\" start=\"1\">\n\
            <li>Determine what aspects of the plug-in will require localization. </li>\n\
            <li>Identify the user interface strings that need to change when the plug-in is running\n\
               in another language. The strings may be located in C++ code or MEL scripts. Modify\n\
               the code and scripts to use string resources in place of hard-coded strings. \n\
            </li>\n\
            <li>Add string registration calls to the plug-in initialization sequence. </li>\n\
            <li>Review string handling code and make modifications as required to properly handle\n\
               strings in both single and multi-byte encodings. \n\
            </li>\n\
         </ol>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7F6\"></a> \n\
            <h2><a name=\"GUID-005F7058-81F7-4648-9467-23D3264A679C\"></a>Assessing Requirements \n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7F5\"></a>Before doing the work to internationalize a plug-in, it is useful to assess what the\n\
               actual requirements are. Not all aspects of plug-in internationalization may be necessary\n\
               or appropriate for each situation. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7F4\"></a>The most important consideration is to determine the number of target languages the\n\
               plug-in needs to support. If a plug-in is only targeted at a single language (for\n\
               example, only Japanese) it may be possible to supply the custom UI for the plug-in\n\
               in a localized script instead of using string resources. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7F3\"></a>String resources are required if the plug-in meets one or more of the following criteria:\n\
               \n\
            </p> <a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7F2\"></a><ul>\n\
               <li>the plug-in is to support more than one user interface language (for example, English\n\
                  and Japanese) \n\
               </li>\n\
               <li>the plug-in issues user messages from C++ code (for example, calls to <span class=\"code\" translate=\"no\">displayError()</span>) \n\
               </li>\n\
               <li>the plug-in creates nodes which are to be displayed in the UI with localized node\n\
                  and attribute name labels \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7EE\"></a>Another consideration is the type of string handling and I/O the plug-in code performs.\n\
               Plug-ins with little or no string manipulation or file handling should require few\n\
               changes, while others will need to be reviewed to ensure they are dealing properly\n\
               with multi-byte characters. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7ED\"></a> \n\
            <h2><a name=\"GUID-9548AD48-A4F9-4709-9E47-67059EC4050D\"></a>Defining and Registering String Resources \n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7EC\"></a>This section will discuss how string resources are used in C++ and MEL scripts, and\n\
               how to register them during plug-in initialization. \n\
            </p> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7EB\"></a> \n\
               <h3><a name=\"GUID-F259BF2B-369F-4451-8DE3-0DCCFD2E589A\"></a>String Resource Keys\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7EA\"></a>Each string resource in the Maya String Catalog is identified by a unique key. For\n\
                  plug-ins, the key consists of an ordered pair of strings. The first element of the\n\
                  pair is the plug-in name, which will be the same for all strings used by the plug-in.\n\
                  The second part of the key is a unique identifier for the string being defined. For\n\
                  example, string resource keys used by the <span class=\"code\" translate=\"no\">closestPointOnCurve</span> plug-in will have the form: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
(\"closestPointOnCurve\", \"stringId1\");\n\
(\"closestPointOnCurve\", \"stringId2\");\n\
(\"closestPointOnCurve\", \"stringId3\");\n\
</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E9\"></a> \n\
               <h3><a name=\"GUID-8D10A78E-08EA-4524-9BC3-E607857DF3B6\"></a>String Resources in C++\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E8\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResource\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResource</a></span> classes are used to define and access string resources in the plug-in C++ code. The\n\
                  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a></span> constructor accepts three arguments, the two elements used to form the resource key,\n\
                  and the default value of the resource string. In the example below the plug-in name\n\
                  is \"<span class=\"code\" translate=\"no\">closestPointOnCurve</span>\", and the unique user-defined key being given to this string is \"<span class=\"code\" translate=\"no\">kNoValidObject</span>\". \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a> invalidObject(\"closestPointOnCurve\", \"kNoValidObject\", \"A curve or its transform node must be specified as a command argument, or using your current selection.\");\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E7\"></a>Using #define statements to associate the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a></span> with a constant is helpful to provide a single point of definition for each resource.\n\
                  Typically the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a></span> declarations for the plug-in will be grouped together in a header file that is shared\n\
                  between the C++ modules that require it. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#define kPluginId  \"closestPointOnCurve\"\n\
#define kNoValidObject <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a>(kPluginId, \"kNoValidObject\", \\\"A curve or its transform node must be specified as a command argument, or using your current selection.\")\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E6\"></a>The <span class=\"code\" translate=\"no\">MStringResource::getString</span> method is used to look up the catalog entry when the string is needed in the code.\n\
                  The catalog lookup will return either the default value or localized string value\n\
                  (if it is available). Once the string is loaded it can be used like any other <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span>. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> stat;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> msg = <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::getString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a121315f443a9c4ea512738dc1d39414d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResource::getString</a>(kNoValidObject, stat);\n\
displayError(msg);\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E5\"></a>A string resource cannot be accessed until it has been registered. This is done by\n\
                  calling <span class=\"code\" translate=\"no\">MstringResource::registerString</span>. The registration steps are described below under String Resource Registration. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E4\"></a> \n\
               <h3><a name=\"GUID-D98B8647-4C2C-484B-AC04-9B899559CC41\"></a>String Resources in MEL Scripts\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E3\"></a>MEL scripts can use string resources in a similar manner to the C++ code. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E2\"></a>To use a string resource, the value is retrieved using the <span class=\"code\" translate=\"no\">getPluginResource</span> command. The arguments passed are the two elements of the string resource key. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
string $titleStr = getPluginResource(\"closestPointOnCurve\", \"kAETitle\");\n\
editorTemplate -beginScrollLayout;\n\
editorTemplate -beginLayout $titleStr -collapse 0;\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E1\"></a>MEL resources are registered using the <span class=\"code\" translate=\"no\">registerPluginResource</span> command. The registration process is described below. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7E0\"></a> \n\
               <h3><a name=\"GUID-E306EADE-4B8A-4314-979E-F056ED076045\"></a>String Resource Registration\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DF\"></a>This section describes the process of registering string resources in the plug-in.\n\
                  All string registration is done during plug-in initialization. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DE\"></a>Each string resource must be registered before it can be used. The registration step\n\
                  ensures that the resource\'s default value is loaded into the string catalog. After\n\
                  the default values are registered the plug-in writer must add a call which will load\n\
                  the localized resource values. When localized resource values are available for the\n\
                  language Maya is running in, the localized values will override the default values.\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DD\"></a>The main registration method is <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin::registerUIStrings()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html#a92e203dc380e1d56d08d2866dcbd697e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin::registerUIStrings()</a></span>. A call to this routine is added to the plug-in\'s <span class=\"code\" translate=\"no\">initializePlugin()</span> function. It should be placed early in the initialization sequence since the string\n\
                  resources will not be available until it is called, and some of the other initialization\n\
                  methods may require them. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DC\"></a>The <span class=\"code\" translate=\"no\">MFnPlugin::registerUIStrings</span> function takes two arguments. The first argument is the name of a procedure which\n\
                  will register the strings used in the C++ code. The second argument is the name of\n\
                  a script that will register the string resources used in MEL scripts. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
 // Register string resources used in the code and scripts\n\
status = plugin.registerUIStrings(registerMStringResources, \"closestPointOnCurveInitStrings\");\n\
if (!status)\n\
{\n\
    status.perror(\"registerUIStrings\");\n\
&nbsp;&nbsp;&nbsp;&nbsp;return status;\n\
}\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DB\"></a>The C++ routine <span class=\"code\" translate=\"no\">registerMStringResources</span> referenced in this call registers each <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a></span> used by the C++ code. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
// Register all strings used by the plugin C++ source \n\
static <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> registerMStringResources(void)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::registerString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a02fc22430bb24b5bfe27a65bd2d9a762&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResource::registerString</a>(kNoValidObject);\n\
    // other resources would go here\n\
    return MS::kSuccess;\n\
}\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7DA\"></a>This example is using a constant previously defined in a header file: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#define kPluginId  \"closestPointOnCurve\"\n\
#define kNoValidObject <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a>(kPluginId, \"kNoValidObject\", \\\"A curve or its transform node must be specified as a command argument, or using your current selection.\")\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D9\"></a>The second argument is the name of a script which initializes all resources used by\n\
                  the plug-in\'s MEL scripts. Each resource is registered with a call to <span class=\"code\" translate=\"no\">registerPluginResources</span>. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-12BA6B3A11A9C207460-7513\"></a>The initialization script serves a dual purpose. In addition to the MEL resource registration\n\
                  it also contains the logic to load language-dependent resources for the plug-in. The\n\
                  routine <span class=\"code\" translate=\"no\">loadPluginLanguageResources</span> takes the name of a resource file that will contain the localized version of the\n\
                  plug-in string resources. More details creating and installing the localized resource\n\
                  file are found under Localization Process below. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
global proc closestPointOnCurveInitStrings()\n\
{\n\
    // Register script resources\n\
    registerPluginResource(\"closestPointOnCurve\", \"kAETitle\",\n\
        \"Closest Point On Curve Attributes\");\n\
    registerPluginResource(\"closestPointOnCurve\", \"kInputCurve\",\n\
        \"Input Curve\");\n\
    registerPluginResource(\"closestPointOnCurve\", \"kResults\",\n\
        \"Results\");\n\
    // Load any localized resources\n\
    loadPluginLanguageResources(\"closestPointOnCurve\", \"closestPointOnCurve.pres.mel\");\n\
}\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D8\"></a>Once the registration sequence is complete the strings are available in the Maya Catalog\n\
                  and can be retrieved using <span class=\"code\" translate=\"no\">MString::getStringResource</span> (C++) or <span class=\"code\" translate=\"no\">getPluginResource </span>(MEL). If localized values for the resources were located by<span class=\"code\" translate=\"no\"> loadPluginLanguageResources</span> they will be returned from the catalog instead of the default values. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D7\"></a> \n\
            <h2><a name=\"GUID-C18BFF5B-A6C0-4E6C-80D8-BC1FBA1A358A\"></a>String Handling\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D6\"></a>Plug-in writers using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> class are largely insulated from locale-dependent changes, but some string handling\n\
               code may require changes to operate correctly in both single and multi-byte environments.\n\
               This section mainly focuses on issues as they relate to the use of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> in a localized environment but many of the problems described apply in to character\n\
               handling in general. \n\
            </p> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D5\"></a> \n\
               <h3><a name=\"GUID-B8F7CA6E-D0E9-4504-A718-F9CB07B38012\"></a>Encoding\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D4\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> class operates under the assumption that by default, character data in char* form\n\
                  is encoded in the codeset of the locale. This is a natural extension of the existing\n\
                  functionality of the class and in many cases an existing plug-in will continue to\n\
                  work without changes in a localized environment. New methods have been added to explicitly\n\
                  assign or access the string using UTF-8 and wide character formats which are commonly\n\
                  used in internationalized applications. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D3\"></a> \n\
               <h3><a name=\"GUID-12E790B2-1167-4FEB-814B-5218315E6B7D\"></a>String Length and Position Values\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D2\"></a>The most common problem when dealing with localized text is the correct interpretation\n\
                  of string length. In multi-byte environments, the character (<span class=\"code\" translate=\"no\">char *</span>) representation of the string will use one or more bytes to represent each character\n\
                  in the string. This means that the string\'s storage length in bytes does not necessarily\n\
                  correspond to the number of individual characters in the string and code using this\n\
                  assumption may not behave as expected. For backwards compatibility, the <span class=\"code\" translate=\"no\">MString::length</span> method will continue to return the number of bytes in the character buffer, a new\n\
                  method <span class=\"code\" translate=\"no\">MString::numChars</span> can be used instead when it is necessary to determine the number of individual characters\n\
                  in the string. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D1\"></a>The interpretation of positional indexes into the string data is similarly problematic\n\
                  in a multi-byte environment (for example when using the <span class=\"code\" translate=\"no\">MString::substring</span> method). See the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-258601E3-3783-4709-8DD7-916BD60FD918.htm#WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CA\">New MString Methods</a></span> for details on what has been added to deal correctly with multi-byte strings. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7D0\"></a> \n\
               <h3><a name=\"GUID-C825063D-C2A8-4295-9900-CEB9C502CD62\"></a>Formatting Message Strings\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CF\"></a>User message strings are often built by concatenating multiple strings or variables.\n\
                  This technique is not appropriate for strings that will be localized, since the context\n\
                  and placement of the strings may need to change for another language. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CE\"></a>The <span class=\"code\" translate=\"no\">MString::format</span> method or MEL <span class=\"code\" translate=\"no\">format</span> command should be used to format the string. Format allows positional arguments to\n\
                  be correctly placed in context when the string is translated. \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CD\"></a>The following example shows an original block of code which creates an error message\n\
                  string containing the name of a file using string concatenation: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> filename;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> msg;\n\
msg = \"The file \";\n\
msg += filename;\n\
msg += \" cannot be opened\";\n\
displayError(msg);\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CC\"></a>The following replacement code shows how this would be done correctly in an internationalized\n\
                  application. The message is being created using a resource string and the <span class=\"code\" translate=\"no\">MString::format</span> command: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#define kOpenError <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResourceId</a>(\"myPlugin\", \"kOpenError\", \"File ^1s cannot be opened\");\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> filename;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> msgFmt = <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::getString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a121315f443a9c4ea512738dc1d39414d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringResource::getString</a>(kOpenError,status);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> msg;\n\
msg.format(msgFmt, filename);\n\
displayError(msg);\n\
</pre></div> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CB\"></a>MEL scripts can make use of the MEL format command in a similar manner. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7CA\"></a> \n\
               <h3><a name=\"GUID-77F32F37-89CA-4AC1-8A58-37618C83CAC2\"></a>New MString Methods \n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7C9\"></a>The following table lists new methods that have been added to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> to support internationalization. See the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> class documentation for more details about each method, as well as notes about the\n\
                  behavior of existing methods within a localized environment. \n\
               </p> <a name=\"WS1A9193826455F5FF-4FDFBFFB11A5310C890-7C8\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"50%\">\n\
                        <col width=\"50%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> Method \n\
                        </th>\n\
                        <th class=\"table-heading\">Notes </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"code\" translate=\"no\">MString::numChars </span> \n\
                        </td>\n\
                        <td class=\"table-body\">This routine returns the number of characters in the string. This does not necessarily\n\
                           correspond to the number of bytes in the string, or the value returned by <span class=\"code\" translate=\"no\">MString::length</span>. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <a name=\"GUID-E30E1E57-7963-489B-85CE-729D4E3B6722\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> MString::setUTF8( const char * utf8String )</span> \n\
                           </p> <a name=\"GUID-87511EB3-FA02-4981-A2CB-1DD630A15CCD\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">const char * <a href=\"javascript:void(0)\" data-symbol=\"MString::asUTF8()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html#a9b62657aaecded5f56277d2c407ec64e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString::asUTF8()</a></span> \n\
                           </p> <a name=\"GUID-93692639-297D-4540-87CB-B707BAB67E61\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">const char * MString::asUTF8(int *length)</span> \n\
                           </p> \n\
                        </td>\n\
                        <td class=\"table-body\">These methods assign or access the string value as a UTF-8 encoded character string.\n\
                           \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <a name=\"GUID-D3FDF0AC-26C1-4B04-B2B1-3F69092316F3\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">Mstring::MString(wchar_t *str)</span> \n\
                           </p> <a name=\"GUID-5B878F7B-B901-4FCF-9160-1398F33FFFCD\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">MString::MString(wchar_ *str, int length)</span> \n\
                           </p> <a name=\"GUID-002AB11F-ED63-42D0-94CE-5468852B0061\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> MString::setWChar(wchar_t *str, int length)</span> \n\
                           </p> <a name=\"GUID-187CF52C-C11B-4498-A615-DD330F23A931\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> MString::setWChar(wchar_t *str, int length)</span> \n\
                           </p> <a name=\"GUID-4E5C9D7F-F822-43D8-A2C5-5F53001B4EAD\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">const wchar_t* <a href=\"javascript:void(0)\" data-symbol=\"MString::asWChar()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html#ade6a9ba4bd9b9d2d0ae95b05a7f75522&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString::asWChar()</a></span> \n\
                           </p> <a name=\"GUID-255E7BEA-6DC5-4A0B-A652-0B6A6644DA41\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">const wchar_t* MString::asWChar(int length)</span> \n\
                           </p> \n\
                        </td>\n\
                        <td class=\"table-body\">These methods allow the string\'s value to be set or accessed using wide character\n\
                           values. Note: the use of wide character representation is not recommended for persistent\n\
                           storage, use of a portable format such as UTF-8 is recommended instead. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <a name=\"GUID-E0DD2517-BCAC-4EDC-8682-58CC56CD9B7B\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\">int MString::indexW(char c) const </span> \n\
                           </p> <a name=\"GUID-7BFA3217-4FC2-4106-9BD6-914B457CAE6F\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"> int MString::indexW(wchar_t c) const</span> \n\
                           </p> <a name=\"GUID-DF0A7148-F737-42D6-9829-C824490FB9A4\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"> int MString::rindexW(char c) const</span> \n\
                           </p> <a name=\"GUID-FD077AD4-9F6F-4406-8CFC-29443AF9177E\"></a><p class=\"table-body\"> <span class=\"code\" translate=\"no\"> int MString::rindexW(wchar_t c) const</span> \n\
                           </p> \n\
                        </td>\n\
                        <td class=\"table-body\">These routines are multi-byte compatible versions of<span class=\"code\" translate=\"no\"> MString::index</span> and <span class=\"code\" translate=\"no\">MString::rindex</span> respectively and return character-based position values. Use of these routines for\n\
                           internationalized plug-ins is recommended. See also <span class=\"code\" translate=\"no\">MString::substringW</span>. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> MString::substringW(int start, int end)</span> \n\
                        </td>\n\
                        <td class=\"table-body\">This is a multi-byte compatible version of <span class=\"code\" translate=\"no\">MString::substring</span> which accepts character-based position values (such as those returned by <span class=\"code\" translate=\"no\">MString::indexW</span> and <span class=\"code\" translate=\"no\">MString::rindexW</span>). \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> MString::split(wchar_t c, <a href=\"javascript:void(0)\" data-symbol=\"MStringArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStringArray</a>&amp; array) const</span> \n\
                        </td>\n\
                        <td class=\"table-body\">This version of <span class=\"code\" translate=\"no\">MString::split</span> accepts a wide-character value as the delimiter. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> MString::format( const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;fmt, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;arg1, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;arg2,\n\
                              ... ,const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> &amp;arg10 )</span> \n\
                        </td>\n\
                        <td class=\"table-body\">This routine provides string formatting capabilities, using a format specifier and\n\
                           up to 10 positional arguments. \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";