var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-328D2310-7F66-4F35-8055-BB10D7B45D5F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Intel Threading Building Blocks</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-328D2310-7F66-4F35-8055-BB10D7B45D5F\"></a><div class=\"head\">\n\
            <h1>Intel Threading Building Blocks</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70EF\"></a> \n\
            <h2><a name=\"GUID-2E91C866-5887-4EED-B94D-F535E8BD3E4F\"></a>Overview\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70EE\"></a>Intel® Threading Building Blocks (TBB) is a relatively new higher level API for threading.\n\
               It replaces the concept of threads with the concept of tasks, which are defined by\n\
               the user and queued up. TBB then maps those tasks to threads efficiently. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70ED\"></a>TBB is available on all platforms that Maya supports. It provides wrappers for common\n\
               functionality such as for, while, reduce and sort operations. It also provides atomic\n\
               primitives a scalable memory allocator (allocators such as malloc access the global\n\
               heap and so are locking operations, leading to contention when many threads are working\n\
               with memory.) Finally, there are threadsafe containers based on STL such as lists,\n\
               queues, and hash maps. These threadsafe containers have poor single threaded performance\n\
               than regular containers because they usually require internal locking, and they must\n\
               be used only when required for threadsafety. \n\
               		\n\
            </p> \n\
            <p>The task-based approach avoids the problem of \n\
               		  <em class=\"strong\">oversubscription \n\
                  		  </em>encountered with OpenMP. In particular, oversubscription can create issues when using\n\
               the Maya Evaluation Manager. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70EC\"></a> \n\
            <h2><a name=\"GUID-3EB2872B-6601-4B97-B7D0-7536C7B0DB40\"></a>Pros and cons of TBB\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70EB\"></a>TBB is a higher level library than OpenMP and provides increased flexibility at the\n\
               cost of greater complexity. Parallel code must be extracted into separate classes,\n\
               which is more invasive than OpenMP. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70EA\"></a>The task-based approach avoids the problem of \n\
               		  <em class=\"strong\">oversubscription \n\
                  		  </em>encountered with OpenMP. In particular, oversubscription can create issues when using\n\
               the Maya Evaluation Manager. Maya makes use of TBB in several places, partly to avoid\n\
               the oversubscription issues of OpenMP, and partly to make use of the higher level\n\
               algorithms and containers. Writing threadsafe cross-platform primitives and containers\n\
               is remarkably difficult, and using a third party library designed for the purpose\n\
               allows developers to focus on optimizing their specific application rather than building\n\
               the required threading infrastructure. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E9\"></a>Although TBB is used by Maya, it is not exposed in a way that plug-in writers can\n\
               access directly. You must acquire a license to use TBB in your plug-ins. There is\n\
               no requirement to use TBB when threading Maya plug-ins, however the Maya API does\n\
               provide an indirect way for plug-ins to use TBB without needing their own license.\n\
               See \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE.htm\">Threading and Maya</a></span> for more information. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E8\"></a>The version compatibility is important for TBB. In Maya 2018, it is necessary to use\n\
               TBB version 4.4 Update 6. The compatible TBB re-distributable files that are shipped\n\
               with Maya should be sufficient to use TBB. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-C4E856A8-A95D-4F4F-A116-1AE68B73FEA9\"></a>You can also download the corresponding commercial aligned releases from the TBB web\n\
               site (<a href=\"http://threadingbuildingblocks.org/download#stable-releases\" target=\"_blank\">http://threadingbuildingblocks.org/download#stable-releases</a>). \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";