var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-48A55A76-0E51-4AE7-9ED9-7E5A4E15F60E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Creating a Hello World command plug-in using .NET</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-48A55A76-0E51-4AE7-9ED9-7E5A4E15F60E\"></a><div class=\"head\">\n\
            <h1>Creating a Hello World command plug-in using .NET</h1>\n\
         </div>\n\
         <p><a name=\"GUID-C4978AE5-59FB-469D-8AD5-3A4A04B4B8D6\"></a> The following is an example of a minimalist custom .NET command: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">using System;\n\
\n\
using Autodesk.Maya.Runtime;\n\
using Autodesk.Maya.OpenMaya;\n\
\n\
[assembly: MPxCommandClass(typeof(MayaNetPlugin.helloWorldCmd), \"helloWorldCmd\")]\n\
[assembly: ExtensionPlugin(typeof(MayaNetPlugin.helloWorldPlugin), \"Autodesk\", \"1.0\", \"Any\")]\n\
\n\
namespace MayaNetPlugin\n\
{\n\
    public class helloWorldPlugin : IExtensionPlugin\n\
    {\n\
        bool IExtensionPlugin.InitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
\n\
        bool IExtensionPlugin.UninitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
        String IExtensionPlugin.GetMayaDotNetSdkBuildVersion()\n\
        {\n\
            String version = \"\";\n\
            return version;\n\
        }\n\
\n\
    }\n\
\n\
    public class helloWorldCmd : <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a>,IMPxCommand\n\
    {\n\
        public override void doIt(<a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a> argl)\n\
        {\n\
            MGlobal.displayInfo(\"Hello World\\n\");\n\
        }\n\
    }\n\
}</pre></div>\n\
         <p><a name=\"GUID-B67B9B3E-5CFB-4E22-9D0D-A7FBDFDC60B5\"></a>This simple example demonstrates how to create a helloWorld Maya command in C# that\n\
            outputs text to the Maya Output window. \n\
         </p>\n\
         <p><a name=\"GUID-672F4016-96D3-4EFC-90D3-9FAEDC3DD6B1\"></a>The two <em class=\"mild\">using Autodesk.Maya…</em> directives add the namespaces of the .NET SDK. This way, you can use the types from\n\
            these namespaces without qualification. Without using a directive, you must write\n\
            the full name of the types in the file, such as <span class=\"code\" translate=\"no\">Autodesk.Maya.OpenMaya.MPxCommand</span>. \n\
         </p>\n\
         <p><a name=\"GUID-2DA0D8F2-ECA1-4296-83AE-3D0025DF4E95\"></a>This plug-in consists of two logical parts: the <span class=\"code\" translate=\"no\">IExtensionPlugin</span> interface implementation and the command itself. \n\
         </p>\n\
         <p><a name=\"GUID-82E987DC-0541-49ED-AB62-D4D9AD6D1AEE\"></a>The <span class=\"code\" translate=\"no\">ExtensionPlugin</span> assembly attribute points to the <span class=\"code\" translate=\"no\">IExtensionPlugin</span> implementation. \n\
         </p>\n\
         <p><a name=\"GUID-2A822BA3-342A-415C-9516-24E05949893F\"></a>When implementing <span class=\"code\" translate=\"no\">IExtensionPlugin.InitializePlugin()</span>, it returns true if the initialization can proceed. If the plug-in cannot load, then\n\
            it returns false and Maya discontinues the loading process. The same applies to <span class=\"code\" translate=\"no\">IExtensionPlugin.UninitializePlugin()</span>. \n\
         </p>\n\
         <p><a name=\"GUID-42C00C20-8E7A-4E1A-B4C5-C53C511B080C\"></a>When implementing <span class=\"code\" translate=\"no\">IExtensionPlugin.GetMayaDotNetSdkBuildVersion()</span>, you can return the API version number you are using to build the plug-in; or return\n\
            an empty string. \n\
         </p>\n\
         <p><a name=\"GUID-AD4D01CB-C0A7-43F0-AB78-794728AF1CCD\"></a>The <span class=\"code\" translate=\"no\">MPxCommandClass</span> assembly attribute describes your plug-in type to the .NET SDK. The <span class=\"code\" translate=\"no\">MPxCommandClass</span> attribute requires as parameter the type of the class implementing the user defined\n\
            command and the name of the command. To provide the type of the class, use the <span class=\"code\" translate=\"no\">typeof</span> operator. Because the attribute is located outside of the <em class=\"mild\">MayaNetPlugin</em> namespace you must specify the full path for your class to the <span class=\"code\" translate=\"no\">typeof</span> operator including its namespace. \n\
         </p>\n\
         <p><a name=\"GUID-11D58311-48BD-4C42-80FE-C3356F80E885\"></a><em class=\"mild\">namespace MayaNetPlugin</em>: All types must be declared within a namespace. A C# namespace can contain classes,\n\
            structs, interfaces, and enums. The namespace is useful for organizing code and preventing\n\
            name collisions. \n\
         </p>\n\
         <p><a name=\"GUID-71CD8341-9A4F-4A4E-BCA2-B847B8B4776C\"></a><em class=\"mild\">public class helloWorldCmd : MPxCommand, IMPxCommand</em>: The helloWorldCmd class derives from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> class and implements the <span class=\"code\" translate=\"no\">IMPxCommand</span> interface. You can have multiple interfaces, but you can only derive from one class.\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> is the base class for user commands and every command is derived from it. \n\
         </p>\n\
         <p><a name=\"GUID-E5E2AA0A-6E49-4842-8FE8-EB7DE898133B\"></a><em class=\"mild\"> public override void doIt(MArgList argl)</em>: Use doIt() to execute the actions of your command. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";