var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-4F1D2DC9-D544-432B-A103-7A32D47757C4\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Dependency Graph Plug-ins</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4F1D2DC9-D544-432B-A103-7A32D47757C4\"></a><div class=\"head\">\n\
            <h1>Dependency Graph Plug-ins</h1>\n\
         </div>\n\
         <p><a name=\"GUID-096C075F-3568-4498-9799-C98528FC0FDB\"></a>In the following topic, we outline the basic code structure of a Dependency Graph\n\
            plug-in. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_39D99B720637432282BAABFFCED31E39\"></a> \n\
            <h2><a name=\"GUID-45D52B60-CEE4-48AE-83BB-0E83ED9B4860\"></a>Sample Dependency Graph Plug-in\n\
            </h2> \n\
            <p><a name=\"GUID-17C94C20-DFC3-4D1F-8306-D78DE2CBE6A6\"></a>The following Python code is a sample Dependency Graph plug-in. This sample defines\n\
               a utility (<span class=\"code\" translate=\"no\">utility/general</span>) Hypershade node named <span class=\"code\" translate=\"no\">myNodeName</span>. It has one input attribute which accepts a float (decimal number), and one output\n\
               attribute which outputs the inputted float. This node can be created using <span class=\"code\" translate=\"no\">cmds.createNode( \'myNodeName\' )</span> or <span class=\"code\" translate=\"no\">cmds.shadingNode( \'myNodeName\', asUtility=True )</span>. If it is created with the later command, or manually via the Maya Hypershade user\n\
               interface (filter by typing \'<span class=\"code\" translate=\"no\">My Node Name</span>\' in the text box), an instance of this node will appear in the <em class=\"strong\">Window &gt; Rendering Editors &gt; Hypershade &gt; \'Utilities\' Tab</em>. \n\
            </p> <a name=\"SECTION_2F524AAB9A8449EE9D8076E37AF0871E\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-61C15031-47D6-4DCB-8A6D-59DC8EA5DAEB\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleDGNode.py\n\
\n\
import sys\n\
\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
\n\
# Plug-in information:\n\
kPluginNodeName = \'myNodeName\'              # The name of the node.\n\
kPluginNodeClassify = \'utility/general\'     # Where this node will be found in the Maya UI.\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>( 0x87EFE ) # A unique ID associated to this node type.\n\
\n\
# Default attribute values\n\
sampleDefaultValue = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class myNode(<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxNode</a>):\n\
    # Static variables which will later be replaced by the node\'s attributes.\n\
    sampleInAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    sampleOutAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxNode.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#a0769ac5b3ecf4060e81dfe4bdc6ed327&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxNode.__init__</a>(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        \'\'\'\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        \'\'\'\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    \'\'\' Creates an instance of our node class and delivers it to Maya as a pointer. \'\'\'\n\
    return  myNode() \n\
\n\
def nodeInitializer():\n\
    \'\'\' Defines the input and output attributes as static variables in our plug-in class. \'\'\'\n\
    \n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    global sampleDefaultValue\n\
    myNode.sampleInAttribute = numericAttributeFn.create( \'myInputAttribute\', \'i\', \n\
                                                          <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>,\n\
                                                          sampleDefaultValue )\n\
    numericAttributeFn.writable = True \n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.hidden = False \n\
    myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    myNode.sampleOutAttribute = numericAttributeFn.create( \'myOutputAttribute\', \'o\',\n\
                                                           <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a> )\n\
    numericAttributeFn.storable = False \n\
    numericAttributeFn.writable = False\n\
    numericAttributeFn.readable = True \n\
    numericAttributeFn.hidden = False \n\
    myNode.addAttribute( myNode.sampleOutAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
    myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMaya.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( \'Failed to register node: \' + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( \'Failed to deregister node: \' + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
\n\
cmds.loadPlugin( \'pySampleDGNode.py\' )\n\
cmds.createNode( \'myNodeName\' )\n\
# ...\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_CCE54BE91EA847CCBA91132124169D11\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-FB8DB3D4-EA6B-4C02-9152-B7765F2F7FA2\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleDGNode.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
# Plug-in information:\n\
kPluginNodeName = \'myNodeName\'              # The name of the node.\n\
kPluginNodeClassify = \'utility/general\'     # Where this node will be found in the Maya UI.\n\
kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>( 0x87EFE ) # A unique ID associated to this node type.\n\
\n\
# Default attribute values\n\
sampleDefaultValue = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class myNode(OpenMayaMPx.MPxNode):\n\
    # Static variables which will later be replaced by the node\'s attributes.\n\
    sampleInAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    sampleOutAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        \'\'\'\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        \'\'\'\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    \'\'\' Creates an instance of our node class and delivers it to Maya as a pointer. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( myNode() )\n\
\n\
def nodeInitializer():\n\
    \'\'\' Defines the input and output attributes as static variables in our plug-in class. \'\'\'\n\
    \n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    global sampleDefaultValue\n\
    myNode.sampleInAttribute = numericAttributeFn.create( \'myInputAttribute\', \'i\', \n\
                                                          <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>,\n\
                                                          sampleDefaultValue )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setStorable( True ) \n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    myNode.sampleOutAttribute = numericAttributeFn.create( \'myOutputAttribute\', \'o\',\n\
                                                           <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a> )\n\
    numericAttributeFn.setStorable( False )\n\
    numericAttributeFn.setWritable( False )\n\
    numericAttributeFn.setReadable( True )\n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleOutAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
    myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( \'Failed to register node: \' + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( \'Failed to deregister node: \' + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
\n\
cmds.loadPlugin( \'sampleDGNode.py\' )\n\
cmds.createNode( \'myNodeName\' )\n\
# ...\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_EA5D1DA8FA7341E3881EE4F84FB2AEB8\"></a> \n\
            <h2><a name=\"GUID-9A32C258-5173-4E31-AE49-F979C1AF9065\"></a>Maya Plug-in Entry and Exit Points\n\
            </h2> \n\
            <p><a name=\"GUID-6A814D04-D953-4BC2-8A15-C5AE4A12DE66\"></a>Dependency Graph plug-ins require the same entry and exit point functions as <span class=\"char_link\"><a href=\"#!/url=./files/GUID-85B1116E-F0C1-42AD-9CD4-30E936B6C7B8.htm\">Command Plug-ins</a></span>, namely: <span class=\"code\" translate=\"no\">initializePlugin()</span> and <span class=\"code\" translate=\"no\">uninitializePlugin()</span>. These two functions are respectively invoked when Maya loads and unloads the plug-in.\n\
               Your plug-in will fail to load if these two functions are absent in your file. Dependency\n\
               Graph plug-ins are used to create new node types by inheriting from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> or one of its many subclasses. In the sample contained within this topic, we are\n\
               inheriting directly from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span>, so we must register our node via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#aa3cf6972b9e540d832fca5dbb5671ebe&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerNode()</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( \'Failed to register node: \' + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( \'Failed to deregister node: \' + kPluginNodeName )</pre></div> \n\
            <p><a name=\"GUID-E704C7ED-7EB1-4E43-B387-EAE85F5DE442\"></a>You will notice that our call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#aa3cf6972b9e540d832fca5dbb5671ebe&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerNode()</a></span> contains six parameters. We describe these parameters as follows: \n\
            </p> <a name=\"OL_CB6068D353AA44579A8A7E646D25CFF0\"></a><ol type=\"1\" start=\"1\">\n\
               <li> \n\
                  <p><a name=\"GUID-BB672A4D-A9AB-41FE-ABA5-0DC12DBE9032\"></a><em class=\"strong\">Node Name</em> - The name of the node. We specify this value in the arbitrarily named variable <span class=\"code\" translate=\"no\">kPluginNodeName</span>. This variable is also used in <span class=\"code\" translate=\"no\">uninitializePlugin()</span>, as well as in our error-reporting calls to <span class=\"code\" translate=\"no\">sys.stderr.write()</span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">kPluginNodeName = \'myNodeName\'              # The name of the node.</pre></div> \n\
                  <p><a name=\"GUID-9F402E3F-0636-48E9-9718-2EE60ECFD548\"></a>By registering this node name, we can create an instance of node using the following\n\
                     Python command: \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.createNode( \'myNodeName\' )</pre></div> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-D80ACF8B-0063-4D46-849B-0320B6D33E42\"></a><em class=\"strong\">Node ID</em> - A unique identification number to represent our node\'s type (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span>) among all the other node types registered in Maya. We specify this value with the\n\
                     arbitrarily named variable <span class=\"code\" translate=\"no\">kPluginNodeId</span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">kPluginNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>( 0x87EFE ) # A unique ID associated to this node type.</pre></div> \n\
                  <p><a name=\"GUID-2454E9F3-1BEB-4B44-85F1-F2234FA517DC\"></a>It is important that this <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span> value be unique; when Maya attempts to save and load files containing our nodes,\n\
                     it will label our nodes using this unique ID. If the unique ID of loaded nodes is\n\
                     not registered in Maya (perhaps because our plug-in isn\'t loaded), these nodes will\n\
                     fail to appear in the Dependency Graph. As explained in more detail in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span> API documentation, specific numeric ranges of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span> are reserved for different purposes. We present a brief summary of these ranges in\n\
                     the table below: \n\
                  </p> <a name=\"TABLE_D733063613B443968059F8EF082B3515\"></a><div class=\"table-ruled\">\n\
                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                        <colgroup>\n\
                           <col width=\"23.076923076923077%\">\n\
                           <col width=\"76.92307692307692%\">\n\
                        </colgroup>\n\
                        <tr class=\"ruled-heading\">\n\
                           <th class=\"table-heading\">Reserved <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span> Range \n\
                           </th>\n\
                           <th class=\"table-heading\">Description </th>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">0x00000 - 0x7ffff</span> \n\
                           </td>\n\
                           <td class=\"table-body\"> Plug-ins which are not intended to be widely distributed. This range is suitable\n\
                              for internally-developed plug-ins. \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">0x80000 - 0xfffff</span> \n\
                           </td>\n\
                           <td class=\"table-body\"> Example plug-ins provided with Maya and its API documentation. </td>\n\
                        </tr>\n\
                     </table>\n\
                  </div> \n\
                  <div><a name=\"GUID-6F2716A2-5626-44AE-A1E7-EC6F39052ABD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If you intend to publically distribute a Dependency Graph plug-in you have written,\n\
                        it will require a globally unique ID. The <a href=\"http://www.autodesk.com/developmaya\" target=\"_blank\">Autodesk Developer Network</a> will provide such id\'s in blocks of 64, 128, 256 or 512. You will be assigned one\n\
                        or more 24-bit prefixes. Once this has been obtained, use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTypeId</a></span> constructor which takes two <span class=\"code\" translate=\"no\">unsigned int</span> parameters. The prefix goes in the first parameter, and you are responsible for managing\n\
                        the allocation of the IDs that go into the second parameter. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-01783456-7A5B-479A-AE7D-381E36DF2152\"></a><em class=\"strong\">Node Creation Function Reference</em> - A reference to the arbitrarily named <span class=\"code\" translate=\"no\">nodeCreator()</span> function. This function is responsible for creating an instance of our node and returning\n\
                     it as a valid Maya object pointer. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">def nodeCreator():\n\
    \'\'\' Creates an instance of our node class and delivers it to Maya as a pointer. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( myNode() )\n\
</pre></div> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-0B92FEA1-82CE-4A34-B81F-8BC2B027F6C1\"></a><em class=\"strong\">Node Attribute Initialization Function Reference</em> - A reference to the arbitrarily named <span class=\"code\" translate=\"no\">nodeInitializer()</span> function. This function is responsible for creating the node\'s set of input and output\n\
                     attributes. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">def nodeInitializer():\n\
    \'\'\' Defines the input and output attributes as static variables in our plug-in class. \'\'\'\n\
    \n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    global sampleDefaultValue\n\
    myNode.sampleInAttribute = numericAttributeFn.create( \'myInputAttribute\', \'i\', \n\
                                                          <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>,\n\
                                                          sampleDefaultValue )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setStorable( True ) \n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    myNode.sampleOutAttribute = numericAttributeFn.create( \'myOutputAttribute\', \'o\',\n\
                                                           <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a> )\n\
    numericAttributeFn.setStorable( False )\n\
    numericAttributeFn.setWritable( False )\n\
    numericAttributeFn.setReadable( True )\n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleOutAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
    myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )</pre></div> \n\
                  <p><a name=\"GUID-A442A885-A415-4DC5-B369-6A79BDF600E5\"></a>We use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNumericAttribute</a></span> function set to create instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> which encapsulate numeric attributes. These attributes require a long and short name,\n\
                     as well as a type and an optional default value. We assign the created attributes\n\
                     as static variables of the <span class=\"code\" translate=\"no\">myNode</span> class, for example: <span class=\"code\" translate=\"no\">myNode.sampleInAttribute</span>. Assigning these objects as static variables allows us to refer to them in the <span class=\"code\" translate=\"no\">myNode.compute()</span> method. \n\
                  </p> \n\
                  <p><a name=\"GUID-6BA6366C-E4F4-4569-84B5-97994CF321AE\"></a>The created attributes are also added to the node\'s base class via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.addAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ada4bc68f1df98730aa5074ef87f00716&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.addAttribute()</a></span>. This makes the node\'s attributes accessible in the Dependency Graph. \n\
                  </p> \n\
                  <p><a name=\"GUID-6A68965B-D3CC-4CA7-B620-25B3C38A33B7\"></a>The <span class=\"code\" translate=\"no\">MFnNumericAttribute.setWritable()</span> function allows the attribute to be connected as a destination to an input source.\n\
                     The <span class=\"code\" translate=\"no\">MFnNumericAttribute.setStorable()</span> allows the value associated with the attribute to be saved to a file. The <span class=\"code\" translate=\"no\">MFnNumeric.setReadable()</span> function allows the value associated with this attribute to be used as input to another\n\
                     node\'s writable attribute(s). The <span class=\"code\" translate=\"no\">MFnNumeric.setHidden()</span> attribute hides the attribute in the user interface so it cannot be mistakenly connected.\n\
                     \n\
                  </p> \n\
                  <p><a name=\"GUID-5DFD0584-725E-49B9-A12B-DE63B93248F3\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.attributeAffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#adf19fe538d775ac2ec0169e6bc300f1c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.attributeAffects()</a></span> function ensures that if the value associated with the given input changes, the node\'s\n\
                     <span class=\"code\" translate=\"no\">compute()</span> function will be called to recompute the value of the output attribute. For more\n\
                     information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-AABB9BB4-816F-4C7C-A526-69B0568E1587.htm#SECTION_50DBB94939C64D659B9BACB40CF37CCA\">The Dependency Graph</a></span>. \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-156A71CC-B0EE-4F63-A866-18B464C9FE33\"></a><em class=\"strong\">Node Type</em> - The node type defined by the plug-in. By default, this is set to <span class=\"code\" translate=\"no\">MPxNode.kDependNode</span>, but other types, such as <span class=\"code\" translate=\"no\">MPxNode.kLocatorNode</span>, <span class=\"code\" translate=\"no\">MPxNode.kDeformerNode</span>, <span class=\"code\" translate=\"no\">MPxNode.kSurfaceShape</span>, etc, can be specified to define different behaviors in the Dependency Graph. \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-7684EEFC-26DF-4C8D-865B-34A102727716\"></a><em class=\"strong\">Node Classification</em> - The node classification is a string which determines how the node will be categorized\n\
                     in various rendering-related user interfaces, such as the Create Render Node and the\n\
                     HyperShade windows. If no string is supplied, the node will not be considered as a\n\
                     rendering node, and will therefore not be displayed in these user interfaces. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">kPluginNodeClassify = \'utility/general\'     # Where this node will be found in the Maya UI.</pre></div> \n\
                  <p><a name=\"GUID-C078BD2D-A866-41A4-87FD-DAADA6133368\"></a> The following table presents a set of valid rendering node classifications: \n\
                  </p> <a name=\"TABLE_5DB2B44F41B14704A9299BBF16FC4672\"></a><div class=\"table-ruled\">\n\
                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                        <colgroup>\n\
                           <col width=\"23.076923076923077%\">\n\
                           <col width=\"76.92307692307692%\">\n\
                        </colgroup>\n\
                        <tr class=\"ruled-heading\">\n\
                           <th class=\"table-heading\">Category </th>\n\
                           <th class=\"table-heading\">Classification String </th>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">2D Textures </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'texture/2d\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">3D Textures </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'texture/3d\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Env Textures </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'texture/environment\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">Surface Materials </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'shader/surface\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Volumetric Materials </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'shader/volume\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">Displacement Materials </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'shader/displacement\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Lights </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'light\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">General Utilities </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'utility/general\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Color Utilities </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'utlity/color\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">Particle Utilities </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'utility/particle\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-odd-row\">\n\
                           <td class=\"table-body\">Image Planes </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'imageplane\'</span> \n\
                           </td>\n\
                        </tr>\n\
                        <tr class=\"ruled-even-row\">\n\
                           <td class=\"table-body\">Glow </td>\n\
                           <td class=\"table-body\"> <span class=\"code\" translate=\"no\">\'postprocess/opticalFX\'</span> \n\
                           </td>\n\
                        </tr>\n\
                     </table>\n\
                  </div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_14FEF2EB9E004DE3928C94F164CB6531\"></a> \n\
            <h2><a name=\"GUID-5CCE09BA-7A1F-42D3-B493-8C8BE45979F8\"></a>Node Behavior\n\
            </h2> \n\
            <p><a name=\"GUID-2317B68B-6EA0-440C-BC78-80D6BF1931BE\"></a>The behavior of our Dependency Graph node (<span class=\"code\" translate=\"no\">myNode</span>) is defined in a class which inherits from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">class myNode(OpenMayaMPx.MPxNode):\n\
    # Static variables which will later be replaced by the node\'s attributes.\n\
    sampleInAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    sampleOutAttribute = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        \'\'\'\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        \'\'\'\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter</pre></div> \n\
            <p><a name=\"GUID-9BEA4922-7256-45B4-822B-E346138B463B\"></a>The node attributes added with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.addAttribute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ada4bc68f1df98730aa5074ef87f00716&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.addAttribute()</a></span> in <span class=\"code\" translate=\"no\">nodeInitializer()</span> are used by Maya to define the input and output connection points of our node when\n\
               it is instantiated in the Dependency Graph. \n\
            </p> \n\
            <p><a name=\"GUID-8DC78C93-B96B-41C4-9BF0-FCC091754B0B\"></a>These connection points are known as <em class=\"mild\">plugs</em>, and are represented by instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>. The call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode.attributeAffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#adf19fe538d775ac2ec0169e6bc300f1c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode.attributeAffects()</a></span> in <span class=\"code\" translate=\"no\">nodeInitializer()</span> determines the causal input &gt; output link between these plugs. Ultimately, the Dependency\n\
               Graph keeps track of the directed edges of connected plugs among all the nodes. During\n\
               Maya\'s ongoing Dependency Graph evaluation process, if data associated to a plug is\n\
               changed, this plug is marked as <em class=\"mild\">dirty</em>, meaning that its cached value is stale and must be recomputed. The plug hierarchy\n\
               is recursively traversed to mark the remaining affected plugs as dirty. \n\
            </p> \n\
            <p><a name=\"GUID-F653F9DD-2E1E-45C7-9F15-51DF0D8DC013\"></a>Maya then calls the <span class=\"code\" translate=\"no\">compute()</span> method on each node containing a dirty plug, passing an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> as well as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a></span>. The related attribute of the passed <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span> should be checked to determine what to compute. This is done using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPlug</a></span>\'s overloaded equality operator \'<span class=\"code\" translate=\"no\">==</span>\'. \n\
            </p> \n\
            <p><a name=\"GUID-2536DBB5-5DFF-423E-8AE7-0427E92B208B\"></a>The passed <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataBlock</a></span> instance contains <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span> objects, which store the values associated to their respective attributes. The <span class=\"code\" translate=\"no\">float</span> input value is obtained as follows: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
sampleInValue = sampleInDataHandle.asFloat()</pre></div> \n\
            <p><a name=\"GUID-158FABA0-DAE5-432F-A1A8-0A58BC38F220\"></a>The <span class=\"code\" translate=\"no\">compute()</span> method should conclude by setting a newly computed value to the correct output <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span>. The call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle.setClean()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html#aa661a5e598b62836bfa018aa27933d5b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle.setClean()</a></span> removes the dirty flag from its corresponding plug. \n\
            </p> \n\
            <p><a name=\"GUID-556889DC-F06A-406C-8EC2-112F3150A9A8\"></a>If the plug passed into the <span class=\"code\" translate=\"no\">compute()</span> function is not related to an output attribute we can compute, the function should\n\
               return <span class=\"code\" translate=\"no\">OpenMaya.kUnknownParameter</span>. This lets Maya know that the plug\'s value should be computed using one of our base\n\
               class\'s <span class=\"code\" translate=\"no\">compute()</span> functions. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";