var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-53D14E65-0134-49F2-8913-2AB7B2B8AC1E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Meta Data</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-53D14E65-0134-49F2-8913-2AB7B2B8AC1E\"></a><div class=\"head\">\n\
            <h1>Meta Data</h1>\n\
         </div>\n\
         <p><a name=\"GUID-5A05E69C-3957-4938-90AF-5702784799BF\"></a>The <em class=\"strong\">meta data</em> classes of the C++ API are ported to the .NET API just like all other Maya API classes.\n\
            In addition, several enhancements have been made to take advantage of the power of\n\
            .NET. \n\
         </p>\n\
         <p><a name=\"GUID-89A4B6A3-FB48-4978-BF28-3FDBFF9E6B61\"></a> Metadata is a very important part of the Maya API, and enables clients to describe\n\
            their custom data (its structure, the types, how to access the data per element, and\n\
            so forth). .NET features can make the process much simpler and more powerful than\n\
            it is in C++. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_17396B23525F41BC87C2412BB65239B0\"></a> \n\
            <h2><a name=\"GUID-F76BDFC8-CC21-4811-B512-5087FC25B9E7\"></a>.NET Examples\n\
            </h2> \n\
            <p><a name=\"GUID-0BA663C0-A30B-48DC-949C-419CDCB270D4\"></a>Several interesting examples that demonstrate the .NET enhancements described on this\n\
               page are included with the examples that are shipped with Maya (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-8CEC80EF-30F0-43BE-8291-8F197C83E692.htm\">Compiling examples</a></span>). Open the <span class=\"code\" translate=\"no\">examples.sln</span> solution (in the <span class=\"code\" translate=\"no\">devkit\\dotnet\\examples</span> folder of your Developer Kit installation; see <span class=\"char_link\"><a href=\"#!/url=./files/Setting_up_your_build_env_Windows_env_32bit_and_64bit.htm\">Setting up your build environment: Windows environment (64-bit)</a></span>) using Microsoft Visual Studio, and you can find these examples in the <span class=\"code\" translate=\"no\">MetaData</span> folder. The following are some interesting examples: \n\
            </p> <a name=\"UL_390F5EE3E95E410DA5C16AFFC918FE3F\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">CreateMetadataFromTypeCmd.cs</span> (tested with <span class=\"code\" translate=\"no\">CreateMetadataXMLCmd.mel</span>) \n\
                  <p><a name=\"GUID-6BF66F4E-BD45-481B-94FC-34CFD7093A1D\"></a>This example shows how you can use the new <span class=\"code\" translate=\"no\">StructureClass</span> assembly attribute and the special class <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;</span> for a .NET type (that is, MyStructureClass in the example). \n\
                  </p> \n\
                  <p><a name=\"GUID-A7FB38FB-2F81-4A1E-BABE-B38EE2CEC29B\"></a>This eliminates the need for the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> classes since everything is done automatically by the generic class <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;</span>. \n\
                  </p> \n\
                  <p><a name=\"GUID-D32AD068-252B-40AD-8C8E-70FEA1E3EB1E\"></a>The example also shows how to use LINQ to perform queries on any of the collections\n\
                     (that is, querying elements of a stream in the example) \n\
                  </p> \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">WriteMetadataToConsoleCmd.cs</span> (tested with every MEL script in the <span class=\"code\" translate=\"no\">MetaData</span> folder) \n\
                  <p><a name=\"GUID-04073A9F-11F5-491C-B80E-25DC4355A7C2\"></a>This example shows how simple enumerating channels, streams, structure members and\n\
                     stream handles can be when using the <span class=\"code\" translate=\"no\">foreach</span> syntax, thanks to the support of the .NET interface <span class=\"code\" translate=\"no\">IEnumerable</span> in the Associations, Channel, Stream and Structure classes. \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_55049AF391BC4ECBB2C14FD0BE09DF3F\"></a> \n\
            <h2><a name=\"GUID-D7E33E27-2C17-4041-93E2-6ED7BB29626A\"></a>Summary\n\
            </h2> \n\
            <p><a name=\"GUID-65B1071B-5A1D-4C67-91F7-4902DADFB5DE\"></a>The following is a list of the main classes of the metadata API, and a quick summary\n\
               of each along with a list of C++ methods that have been ported to .NET: \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_3CA09688A5C04B4FAA434D90E3C1FA9F\"></a> \n\
               <h3><a name=\"GUID-D0FD1F49-BEDE-47C0-B341-5F60F07A1578\"></a>Associations\n\
               </h3> \n\
               <p><a name=\"GUID-6250A89F-F41A-49DD-BE92-77C07D2E7EF1\"></a>This is an entry point to access the meta data from a Maya object (for example, by\n\
                  getting the <span class=\"code\" translate=\"no\">MFnDependencyNode.metadata</span> property). \n\
               </p> \n\
               <p><a name=\"GUID-13561E04-0C27-4882-879A-0ED243F828E8\"></a>It’s basically a simple container of channels. \n\
               </p> \n\
               <p><a name=\"GUID-693927AF-544E-40F4-B992-49CBEB21AC5D\"></a>A few interesting methods ported from C++ are: \n\
               </p> <a name=\"UL_2817FC27891647F6A4509A84360994FA\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Channel</a> findChannel(string)</span> searches for a channel given its name \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">void setChannel(<a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Channel</a>)</span> adds a channel, or replaces an existing channel that has the same name \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">bool removeChannel(string)</span> removes a channel given its name \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"AssociationsIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_associations_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">AssociationsIterator</a> begin()</span> returns a C++/STL-style iterator to iterate over the channels \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_30F9A86ACB7147AEB428386867A5F234\"></a> \n\
               <h3><a name=\"GUID-96A987F4-F1A7-4217-8706-D02FFB6DE5B5\"></a>Channel\n\
               </h3> \n\
               <p><a name=\"GUID-EC522A15-D472-45B3-AB5B-CE9E16BB0164\"></a>This is a collection of streams that are grouped together, either because they share\n\
                  the same topology (the same stream indices) or because the user decides they should\n\
                  logically be in the same group (for example, all the streams for a simulation effect\n\
                  would be in the same channel and given a channel name that is the name of the effect).\n\
                  \n\
               </p> \n\
               <p><a name=\"GUID-036AF54B-9715-4D63-BF4E-93FE7DE393DE\"></a>A channel can be named, but some names are reserved (for example, <span class=\"code\" translate=\"no\">vertex</span> is reserved to indicate that its streams have one element per vertex). \n\
               </p> \n\
               <p><a name=\"GUID-CBD25975-FC0B-4594-950E-A6007F5F35C6\"></a>A few interesting methods ported from C++ are: \n\
               </p> <a name=\"UL_6311AB13B35F4EB985AAC44B3E7FB98A\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a> findDataStream(string)</span> looks for a stream given its name \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a> setDataStream(<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a>)</span> adds a stream \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">void removeDataStream(string)</span> removes a stream given its name \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"ChannelIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ChannelIterator</a> begin()</span> returns a C++/STL-style iterator to iterate over the streams \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">bool removeElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a> elementIndex)</span> removes the specified element from every stream found in the channel \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">bool addElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a> elementIndex)</span> adds the specified element to every stream found in the channel \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_223579E306BD484EA192817A17162592\"></a> \n\
               <h3><a name=\"GUID-EE0B74C5-3AC0-4A6C-8E46-8A660A79C5DE\"></a>Stream\n\
               </h3> \n\
               <p><a name=\"GUID-C0C91635-425B-4D4B-9608-922B7F1B6C24\"></a>This is a container of data on the object (for example, on a mesh, in the channel\n\
                  <span class=\"code\" translate=\"no\">vertex</span>, you have as many data elements as you have vertices in the stream). \n\
               </p> \n\
               <p><a name=\"GUID-BB196B07-EBC1-4DE3-A415-9CFBF2DC6F6B\"></a>A few interesting methods ported from C++ are: \n\
               </p> <a name=\"UL_348BB5F1D63142E8A8F7B46F1EE6F25C\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a>(<a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a>, string)</span> creates a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> object using the specified structure and given the specified name \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">bool setElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a>, <a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a>)</span> replaces the data at a given index with that of another \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a> element(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a>)</span> obtains a handle of the data at a given index \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"StreamIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">StreamIterator</a> begin()</span> returns a C++/STL-style iterator to iterate over the handles \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_08E1B4E8E72D447083F8F1B8FE8EF443\"></a> \n\
               <h3><a name=\"GUID-C585E1A5-1D45-4E13-B720-BE8F1A68C023\"></a>Structure\n\
               </h3> \n\
               <p><a name=\"GUID-0DBF227A-F0FE-4A9B-ACFF-E18373D36585\"></a>This class describes the meta data found at each element of the stream. \n\
               </p> \n\
               <p><a name=\"GUID-E2E4EEF9-A177-4700-88C1-1E7E286B1B54\"></a>Its method <span class=\"code\" translate=\"no\">AddMember</span> is used to define each field of the meta data. \n\
               </p> \n\
               <p><a name=\"GUID-40051C65-F927-4241-B71D-B01186EA4FA0\"></a>For instance, if you want one float and one boolean to be stored at every element,\n\
                  first create a structure and call <span class=\"code\" translate=\"no\">AddMember(kFloat,1,”MyFloatField”)</span> and <span class=\"code\" translate=\"no\">AddMember(kBoolean,1,”MyBooleanField”)</span>. \n\
               </p> \n\
               <p><a name=\"GUID-F08CBC44-ECB0-4669-AA22-CB1455D0B010\"></a>A few interesting methods ported from C++ are: \n\
               </p> <a name=\"UL_9890DD26B6374CDDB6DE841F5BC959F6\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">bool addMember( Member.eDataType, uint arraySize, string memberName )</span> adds a member with the specified type, size (typically 1), and name to the structure\n\
                     \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"StructureIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">StructureIterator</a> begin()</span> returns a C++/STL-style iterator to iterate over the members \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_0F7A65520E33428BBE1B27961853856D\"></a> \n\
               <h3><a name=\"GUID-F596BD31-60A7-414C-812A-4CA67EB6796B\"></a>Handle\n\
               </h3> \n\
               <p><a name=\"GUID-2C58947B-0616-4521-AF59-96101E00F1AF\"></a>This class allows you to access the data for a specified element of the stream. \n\
               </p> \n\
               <p><a name=\"GUID-D20116A0-3CB6-497D-B14E-D3929E7D58F6\"></a>With a handle, you can get or set the data of the stream element. \n\
               </p> \n\
               <p><a name=\"GUID-87E0185C-BFC4-4F79-A6A2-A629C62B0932\"></a>A few interesting methods ported from C++ are: \n\
               </p> <a name=\"UL_FA6F2F3519F344E8982B3FA0A991A645\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">bool setPositionByMemberIndex(uint)</span> indicates the member of the structure that this handle is associated with \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">int[] asInt32Array</span> gets or sets the integer data as an array of integers (even if there is only one\n\
                     integer) \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">float[] asFloatArray</span> gets or sets the float data as an array of floats (even if there is only one float)\n\
                     \n\
                  </li>\n\
                  <li>... and so forth </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_23DE128083DC4A4581B875B74D90ECB0\"></a> \n\
            <h2><a name=\"GUID-8870B26A-A407-4D1E-A175-1556847CC1A9\"></a>Taking advantage of .NET\n\
            </h2> \n\
            <p><a name=\"GUID-67ADA212-7882-4CD5-BCDB-76CD28EE4FDA\"></a>.NET provides several enhancements to the metadata API. Here are the main classes\n\
               of the API with the .NET enhancements: \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_F54752E02F314762AD75A3B1D13A662A\"></a> \n\
               <h3><a name=\"GUID-D6819B32-3BDE-48D5-8DF1-3CE6B51231CC\"></a>Associations\n\
               </h3> \n\
               <p><a name=\"GUID-346FF755-959C-40D9-8BC8-16F146844B1C\"></a>Because it acts as a dictionary of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Channel</a></span> objects, the class supports the .NET interface <span class=\"code\" translate=\"no\">IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Channel</a>&gt;</span>. \n\
               </p> \n\
               <p><a name=\"GUID-4D6F0D55-BED8-4937-9D5D-F21724C52593\"></a>This interface enables you to use the following standard methods/properties that are\n\
                  expected from a dictionary in .NET: \n\
               </p> <a name=\"UL_88BFF19A1B1146E48DEE196D0D1EFD0A\"></a><ul>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Channel channel;\n\
if( myAssociations.TryGetValue( “vertex”, out channel ) { ... }</pre></div> \n\
                     <p><a name=\"GUID-5A916A11-56C7-4347-A0E3-3F3D28843274\"></a>This method allows you to look for a channel given its name and tests for its existence\n\
                        at the same time. \n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Channel channel =  myAssociations[“vertex”];</pre></div> \n\
                     <p><a name=\"GUID-10BED626-59D9-43CB-A28F-488345285644\"></a>This indexer also looks for a channel given its name, but in this case, the channel\n\
                        is expected to be found (throws <span class=\"code\" translate=\"no\">KeyNotFoundException</span> otherwise). \n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">if(myAssociations.ContainsKey( “vertex” ) { ... }</pre></div> \n\
                     <p><a name=\"GUID-3082A2B8-3A31-4E17-8410-5BE128AEFBE3\"></a>This simply tests if a channel with the specified name exists. The channel is not\n\
                        returned. \n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">myAssociations.Add( “vertex”, myChannel );</pre></div> \n\
                     <p><a name=\"GUID-2B4A25A2-36DD-4416-8DE0-E5BB05BEE717\"></a>This adds the channel, or throws <span class=\"code\" translate=\"no\">ArgumentException</span> if a channel with the same name already exists. \n\
                     </p> \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( Channel chnl in myAssociations )  { ... }</pre></div> \n\
                     <p><a name=\"GUID-23F77FC7-FE0F-4F58-AC50-64807AA2E83C\"></a>This lets you enumerate all the channels using this very simple syntax instead of\n\
                        the complicated C++/STL syntax: \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">for( AssociationsIterator iter = myAssociations.begin(); iter.notEqual( myAssociations.end() ); iter.next() ) { \n\
    Channel chnl = iter.__deref__();\n\
    ... \n\
}</pre></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_B5581E83BB5E4CC8BA8C82CE967947A0\"></a> \n\
               <h3><a name=\"GUID-06BFCD2E-F46C-46C2-A3E3-3DC31C7A881E\"></a>Channel\n\
               </h3> \n\
               <p><a name=\"GUID-A522BBED-37D8-46CE-93DD-D976A27A0DC1\"></a>Because it acts as a dictionary of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> objects, the class supports the .NET interface <span class=\"code\" translate=\"no\">IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a>&gt;</span>. \n\
               </p> \n\
               <p><a name=\"GUID-1A171F05-33AE-41AF-9047-BEBA0E28FF6F\"></a>This interface enables you to use the following standard methods/properties that are\n\
                  expected from a dictionary in .NET: \n\
               </p> <a name=\"UL_2FF8447200844AC5BF81B5A6A5D464B4\"></a><ul>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Stream stream; \n\
if( myChannel.TryGetValue( “myStream”, out stream ) { ... }</pre></div>This method allows you to look for a stream given its name and tests for its existence\n\
                     at the same time. \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Stream stream =  myChannel[“myStream”]; </pre></div>This indexer also looks for a stream given its name, but in this case, the stream\n\
                     is expected to be found (throws <span class=\"code\" translate=\"no\">KeyNotFoundException</span> otherwise). \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">if( myChannel.ContainsKey( “myStream” ) { ... }</pre></div>This simply tests if a stream with the specified name exists. The stream is not returned.\n\
                     \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">myChannel.Add( “myStream”, myStream );</pre></div>This adds the stream or throws <span class=\"code\" translate=\"no\">ArgumentException</span> if a stream with the same name already exists. \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( Stream stream in myChannel )  { ... }</pre></div>This lets you enumerate all the streams using this very simple syntax instead of the\n\
                     complicated C++/STL syntax: \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">for( ChannelIterator iter = myChannel.begin(); iter.notEqual( myChannel.end() ); iter.next() ) { \n\
    Stream stream = iter.__deref__();\n\
    ... \n\
}</pre></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_8C8E14573A384D4699F0506D2F30905D\"></a> \n\
               <h3><a name=\"GUID-20715DED-71CA-4EBC-B330-9E36BA98DE34\"></a>Stream\n\
               </h3> \n\
               <p><a name=\"GUID-A1D56E05-CD88-4A01-917E-F0B0F838B14B\"></a>Because it acts as a dictionary of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> objects, the class supports the .NET interface <span class=\"code\" translate=\"no\">IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a>&gt;</span>. \n\
               </p> \n\
               <p><a name=\"GUID-6A3BA039-E76B-4071-A790-C4CF55C8F889\"></a>This enables you to use the following standard methods/properties that are expected\n\
                  from a dictionary in .NET: \n\
               </p> <a name=\"UL_E878BCE4BF4441F893AF00029E6258C3\"></a><ul>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Handle handle; \n\
if( myStream.TryGetValue( 18, out handle ) { ... }</pre></div>This method allows you to look for a handle given its index and tests for its existence\n\
                     at the same time. \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">Handle handle = myStream[18]; </pre></div>This indexer also looks for a handle given its index, but in this case, the handle\n\
                     is expected to be found (throws <span class=\"code\" translate=\"no\">KeyNotFoundException</span> otherwise). \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">if( myStream.ContainsKey(18) { ... }</pre></div>This simply tests if a handle with the specified index exists. The handle is not returned.\n\
                     \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">myStream.Add( 18, myHandle );</pre></div>This adds the handle or throws <span class=\"code\" translate=\"no\">ArgumentException</span> if a handle with the same index already exists. \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( Handle handle in myStream )  { ... }</pre></div>This lets you enumerate all the handles using this very simple syntax instead of the\n\
                     complicated C++/STL syntax: \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">for( StreamIterator iter = myStream.begin(); iter.notEqual( myStream.end() ); iter.next() ) { \n\
    Handle handle = iter.__deref__();\n\
    ... \n\
}</pre></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_C0D776F319CB457E837AEC56F59B992B\"></a> \n\
               <h3><a name=\"GUID-B30BD949-49C0-4524-A483-ADB5C120D9DC\"></a>Structure\n\
               </h3> \n\
               <p><a name=\"GUID-D5C355C7-DAA4-4621-879A-C83BEA1897E2\"></a><span class=\"code\" translate=\"no\">IEnumerable&lt;Member&gt;</span> was added in order to enable this syntax: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( Member member in myStructure )  { ... }</pre></div> \n\
               <p><a name=\"GUID-6040480F-68E0-45A7-9E98-042A9AEFAA25\"></a>This lets you enumerate all the members using this very simple syntax instead of the\n\
                  complicated C++/STL syntax: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">for( StructureIterator iter = myStream.begin(); iter.notEqual( myStream.end() ); iter.next() ) { \n\
    Member member = iter.__deref__();\n\
    ... \n\
}</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_946E256D3B37473BA95941EF4EFAF457\"></a> \n\
               <h3><a name=\"GUID-2CD34B5C-3251-4A06-8CBC-BE4A8BB05825\"></a>Handle\n\
               </h3> \n\
               <p><a name=\"GUID-47D82DD6-E68D-4958-A4B5-DC006A34FBA0\"></a>The C++ API uses a single method using pointers (for example, <span class=\"code\" translate=\"no\">int *asInt32()</span>) to let you access the data for a given type. You can use it as a pointer to a single\n\
                  integer (for example, <span class=\"code\" translate=\"no\">myInteger = *asInt32()</span>) or an array of integer values (for example, <span class=\"code\" translate=\"no\">asInt32()[6]</span>) if you had specified a size of greater than 1 when you created the corresponding\n\
                  member in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a></span> object. \n\
               </p> \n\
               <p><a name=\"GUID-BA9B5E99-A165-4B65-AA9B-B1099EF73CE3\"></a>For .NET, using pointers in the API was not feasible so two properties are provided\n\
                  per type: \n\
               </p> <a name=\"UL_7E5AA524B3674A9298090EC410FD60EC\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\">int[] asInt32Array</span> to get or set the integer data as an array of integers \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">int asInt32</span> to get or set the single integer (will throw an <span class=\"code\" translate=\"no\">ApplicationException</span> if the size found in the corresponding structure member is greater than 1) \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">float[] asFloatArray</span> to get or set the float data as an array of floats \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">float asFloat</span> to get or set the single float (will throw an <span class=\"code\" translate=\"no\">ApplicationException</span> if the size found in the corresponding structure member is greater than 1) \n\
                  </li>\n\
                  <li>... and so forth </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E9F000A11CAA496696FE897C178B9A76\"></a> \n\
            <h2><a name=\"GUID-620D335A-6141-473A-B8B4-E079EE9B79DB\"></a>Matching a client .NET type: the ultimate technique to simplify data description and\n\
               access\n\
            </h2> \n\
            <p><a name=\"GUID-1AE749C5-09C2-4B5D-A18B-B8CD853CBB6B\"></a>Using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a></span> class to describe the data of an element and then the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> class to access the data is quite low-level and C++ like, for example: \n\
            </p> <a name=\"UL_BD43E12B512048DEB7FCB065CC23D567\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">Structure.AddMember( kInt32, 1, “myIntMember”)</span> to add an int member, \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">Handle.setPositionByMemberIndex(uint)</span> to specify the member of the handle that you want to access \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">Handle.asInt</span> to get or set the integer data of the member \n\
               </li>\n\
               <li>... and so forth </li>\n\
            </ul> \n\
            <p><a name=\"GUID-7B5D071F-A41F-40B6-946D-52B0CF5B58DE\"></a>.NET simplifies the whole process, as long as you have a class or structure that describes\n\
               the data where each member of your type is a member in the expected <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a></span> object. \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_E6DCBDDC98BF4C509AEEAF8BAE842958\"></a> \n\
               <h3><a name=\"GUID-79DDC3F9-89F2-4049-A70E-D121488041BA\"></a>The new StructureClass assembly attribute\n\
               </h3> \n\
               <p><a name=\"GUID-232CD55E-C50A-4D0C-A82C-EEC1A760BAD4\"></a>In your plug-in, if you use the new <span class=\"code\" translate=\"no\">StructureClass</span> assembly attribute and provide your type that describes the structure of your metadata,\n\
                  .NET can automatically create the <em class=\"strong\">Structure</em> object for you: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">[assembly: StructureClass(typeof(MyNameSpace.MyStructureClass))]\n\
\n\
namespace MyNameSpace\n\
{\n\
   public class MyStructureClass\n\
   {\n\
      public int a;\n\
      public int b { get; set; }\n\
      public float[] c = new float[3];\n\
   }\n\
}</pre></div> \n\
               <p><a name=\"GUID-B3F2E4FB-40ED-4745-80FD-0BD90C78576F\"></a>Thanks to introspection, .NET can find all the public fields and properties in your\n\
                  class (or struct) and automatically create a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Structure</a></span> object that is registered using <span class=\"code\" translate=\"no\">Structure.registerStructure</span>. \n\
               </p> \n\
               <p><a name=\"GUID-873267B7-3A81-44DE-93C1-F8D581EF34E4\"></a>The name of the Structure is the full name of your type (for example, <span class=\"code\" translate=\"no\">MyNameSpace.MyStructureClass</span>). The name of each Structure member is the name of the corresponding member in your\n\
                  type. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_939BC505DD6E416DAEE3E7632F2CD86C\"></a> \n\
               <h3><a name=\"GUID-0D9A902C-4812-4B9C-88F3-BD2FD46C9AAD\"></a>Converting from a Handle to a .NET object or vice-versa\n\
               </h3> \n\
               <p><a name=\"GUID-A50F2F5E-A683-4330-9E22-9D8C70ADBA77\"></a>If you use the new <em class=\"strong\">StructureClass</em> assembly attribute (see previous section) with the type of a .NET object, you can\n\
                  use the new following methods of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> class: \n\
               </p> <a name=\"UL_63311DEEEB7A47879673640D2D42CC21\"></a><ul>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">public void SetFromDotNetObject( Object dotNetObj, Structure structure );</pre></div> \n\
                     <p><a name=\"GUID-3B826DE2-7275-4B41-8514-FC5705D9CB59\"></a>This does a member wise copy from your .NET object to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> object. \n\
                     </p> \n\
                     <p><a name=\"GUID-8DB76F60-1D7D-4960-9C63-84CE2B50B672\"></a>This is the equivalent of the following pseudo-code: \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">for each public member in the type of dotNetObj \n\
    find corresponding member in Structure object\n\
    call this.setPositionByMemberIndex( index of member found ) \n\
    if type is int32\n\
        this.asInt = get value of member in dotNetObj\n\
    else if type is float\n\
        this.asFloat = get value of member in dotNetObj\n\
    …\n\
next</pre></div> \n\
                  </li>\n\
                  <li> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">public void CopyToDotNetObject(Object dotNetObj, Structure structure);</pre></div> \n\
                     <p><a name=\"GUID-F931544F-3686-4551-B5C8-265EE1CD54E7\"></a>This does a member wise copy from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> object to your .NET object. \n\
                     </p> \n\
                     <p><a name=\"GUID-0D633EA4-9A5D-4CD5-B0FE-146CB7C824B7\"></a>This is the equivalent of the following pseudo-code: \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">for each public member in the type of dotNetObj \n\
    find corresponding member in Structure object\n\
    call this.setPositionByMemberIndex( index of member found ) \n\
    if type is int32\n\
        dotNetObj.SetValue( this.asInt )\n\
    else if type is float\n\
        dotNetObj.SetValue( this.asFloat )\n\
    …\n\
next\n\
</pre></div> \n\
                  </li>\n\
               </ul> \n\
               <p><a name=\"GUID-1BC40326-3BC5-4C4A-9736-B09092E4B897\"></a>These methods become unnecessary, however, when you use the new generic class <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;</span> explained in the next section. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_2E582FA8D2CF4534A4F304E226613993\"></a> \n\
               <h3><a name=\"GUID-197A2ABD-7836-4720-AA89-A01F3DBE972D\"></a>StreamForType&lt;T&gt;: special version of the Stream class tailored to your .NET type\n\
               </h3> \n\
               <p><a name=\"GUID-9E45A83A-3EC4-47D7-B8CD-6BCD0446011A\"></a>While Stream is the class to use when you can’t provide a .NET type that describes\n\
                  your Structure, the class <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;</span> should be used when you have provided your type with the new StructureClass assembly\n\
                  attribute. \n\
               </p> \n\
               <p><a name=\"GUID-7FD30E78-6853-407F-9A0E-6D66E0742AD1\"></a>Use the same type for the T parameter of this generic class and you are given a Stream-like\n\
                  class that is completely tailored for your type. \n\
               </p> \n\
               <p><a name=\"GUID-F9F19D2E-4F23-45BA-AF42-F3E6714DE773\"></a>This generic class is a wrapper to a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> object so you can create it in two ways. The following are the two constructors:\n\
                  \n\
               </p> <a name=\"UL_8E6A189BD34C494CBBB7F6ED09A55618\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\"> StreamForType&lt;T&gt;(string streamName) </span> \n\
                     <p><a name=\"GUID-BC16D770-3964-4DB1-AB7C-ED9726DACA52\"></a>This constructor looks for an existing Structure called with the full name of your\n\
                        type T (it should find it if you used the StructureClass assembly attribute). It then\n\
                        creates a new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> object using the specified name and the structure found and wraps this new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> object. \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;(<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a> baseStream)</span> \n\
                     <p><a name=\"GUID-0B994E4B-4AD3-4B93-947C-9304F8C37187\"></a>This constructor wraps the specified stream but also ensures that the structure of\n\
                        this base stream is compatible with your type (it should be if you used the StructureClass\n\
                        assembly attribute). \n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
               <p><a name=\"GUID-D1BD558F-3A57-4BE1-8B60-982A781EF91F\"></a>While the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Stream</a></span> class can be seen as a dictionary of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> objects, the <span class=\"code\" translate=\"no\">StreamForType&lt;T&gt;</span> generic class can be seen as a dictionary of T objects where T is your .NET class\n\
                  (or struct). This is done with the <span class=\"code\" translate=\"no\">IDictionary&lt;T&gt;</span> supported by the generic class. \n\
               </p> \n\
               <p><a name=\"GUID-91238658-981F-4976-A98A-922191DC5A58\"></a>The following are a few interesting methods: \n\
               </p> <a name=\"UL_C6C48B0D071349D496C3DF19BC9FE3E8\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\">bool TryGetValue(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a>, out T value)</span> \n\
                     <p><a name=\"GUID-B58E40F0-4BB5-4251-B58C-4F3678077E36\"></a>Finds the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Handle</a></span> object with the specified index, then calls <span class=\"code\" translate=\"no\">handle.CopyToDotNetObject()</span> on a new instance of T. It returns the new instance; or, if the handle is not found,\n\
                        it returns false. \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">void Add(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a>, T value)</span> \n\
                     <p><a name=\"GUID-FD3FE6B7-BEB8-47B5-B0B2-E70AEDF313EA\"></a>Creates a new handle at the specified index, then calls <span class=\"code\" translate=\"no\">handle.SetFromDotNetObject()</span> using the specified T value. \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">T this[<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Index</a> key]</span> \n\
                     <p><a name=\"GUID-D410A05B-DC84-4EEB-8E2D-2CE5846CE26D\"></a>This enables the following syntax (<span class=\"code\" translate=\"no\">MyStructureClass</span> is the .NET type used for the T parameter): \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">MyStructureClass myDotNetObj ;\n\
myDotNetObj.myInt = 3;\n\
myStream[18] = myDotNetObj;</pre></div> \n\
                     <p><a name=\"GUID-A7BFF7D1-1A20-4EA2-869C-B2F09408CDF1\"></a>The example above adds the .NET object at the specified index or replaces the current\n\
                        object if one already exists at that index. \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">MyStructureClass myDotNetObj = myStream[18];</pre></div> \n\
                     <p><a name=\"GUID-AF944524-855D-4B82-90CD-6D911E5F0EFB\"></a>The example above returns the object found at the specified index or throws a <span class=\"code\" translate=\"no\">KeyNotFoundException</span> if an object does not exist at that index. \n\
                     </p> \n\
                     <p><a name=\"GUID-92097DCF-4F5D-4FE3-A3E0-C280B96D3312\"></a>Be careful though, the following syntax compiles but does not work as expected as\n\
                        it does not change the element in the base stream: \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">myStream[18].myInt = 1.6;</pre></div> \n\
                     <p><a name=\"GUID-9F46D261-D48E-4243-828B-AE06876797B6\"></a>Instead, the example above changes the field <span class=\"code\" translate=\"no\">myInt</span> of the <em class=\"mild\">copy</em> returned by the indexer, so it is completely useless. \n\
                     </p> \n\
                     <p><a name=\"GUID-A3E53080-5B33-4A72-B31A-CD982C81F86B\"></a>For the desired result, do as follows: \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">MyStructureClass temp = myStream[18];\n\
temp.myInt = 1.6;\n\
myStream[18] = temp;\n\
</pre></div> \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">IEnumerator&lt;T&gt; GetEnumerator()</span> \n\
                     <p><a name=\"GUID-5761D0CB-A1BA-4CD5-9BAE-E7209608D4BF\"></a>This enumerates all your elements with this simple syntax: \n\
                     </p> \n\
                     <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( MyStructureClass myDotNetObj in myStream ) { … }</pre></div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_6A29BFE3A35548519D8B26604E5B7EF1\"></a> \n\
               <h3><a name=\"GUID-4CDE9960-26FA-4C0C-99A5-59ABB3CDA2C7\"></a>Using the power LINQ to perform SQL-like queries\n\
               </h3> \n\
               <p><a name=\"GUID-F9130C97-358F-4369-BA22-FEB1DE61F927\"></a>Since <span class=\"code\" translate=\"no\">IEnumerable</span> is supported on most classes, you can perform very powerful queries with your data.\n\
                  \n\
               </p> \n\
               <p><a name=\"GUID-CBD214C8-333E-4E1A-AAB3-A9A128A291CA\"></a>For instance, if your class has a field called amplitude, and you want to find the\n\
                  metadata in the vertex channel of a mesh where the amplitude is greater than 0.5,\n\
                  you can do this easily as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"> Channel chn = myAssociations[\"vertex\"];\n\
 Stream chnStream = chn[“myStream”];\n\
 var strm = new StreamForType&lt;MyStructureClass&gt;(chnStream);\n\
 var list = strm.Where( ( MyStructureClass obj ) =&gt;obj.amplitude &gt;0.5 );\n\
 foreach( MyStructureClass obj in list ) { … }</pre></div> \n\
               <p><a name=\"GUID-2FA1BE9D-B193-4002-B09E-57B5872E7949\"></a>To query the vertex index, you can do as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">var list = strm.Where( ( KeyValuePair&lt;Index,MyStructureClass&gt; keyvalue ) =&gt; keyvalue.Value.amplitude &gt; 0.5 );\n\
foreach (var keyvalue in list ) {  \n\
   Index index = keyvalue.Key;\n\
   MyStructureClass obj = keyvalue.Value;\n\
   …   \n\
}</pre></div> \n\
               <p><a name=\"GUID-F0C0B983-A125-49ED-A90E-9D6C9D351AC1\"></a>This type of query can be done on any of the following classes: Associations, Channel,\n\
                  Stream and Structure because they all implement <span class=\"code\" translate=\"no\">IEnumerable</span>, which is the only interface LINQ requires. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";