var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-66ADA1FF-3E0F-469C-84C7-74CEB36D42EC\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>PyQt and PySide Widget Best Practices</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-66ADA1FF-3E0F-469C-84C7-74CEB36D42EC\"></a><div class=\"head\">\n\
            <h1>PyQt and PySide Widget Best Practices</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4E1669DB0CFE4D7DB39FFE13CACED044\"></a> \n\
            <h2><a name=\"GUID-080FBB43-F7ED-49BB-80A9-0BF20FC20CAA\"></a>Maintain a Reference to your Widget\n\
            </h2> <a name=\"FIG_95622FC7B8814F47A0D0D8EA04ADAC3D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-4AB6AA8F-094A-422B-981B-D2867DCC6E66-low.png\"></div> \n\
            <p><a name=\"GUID-23BC5CE8-291A-4B5C-BCBA-CF29660B27A1\"></a> If you are using PyQt5 or PySide2 to customize Maya\'s user interface, be sure to\n\
               parent your widget under an existing Maya widget, such as Maya\'s main window. Otherwise,\n\
               if the widget is un-parented, it may be destroyed by the Python interpreter\'s garbage\n\
               collector if a reference to it is not maintained. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-BC36D5E8-827E-45ED-AD6A-54FDFE1A0186\"></a>The following code sample exemplifies this best practice. Note that this code also\n\
               works by importing the PyQt5 modules instead of PySide2. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from maya import OpenMayaUI as omui \n\
\n\
from PySide2.QtCore import * \n\
from PySide2.QtGui import * \n\
from PySide2.QtWidgets import *\n\
from PySide2 import __version__\n\
from shiboken2 import wrapInstance \n\
\n\
mayaMainWindowPtr = omui.MQtUtil.mainWindow() \n\
mayaMainWindow= wrapInstance(long(mayaMainWindowPtr), QWidget) \n\
\n\
# WORKS: Widget is fine \n\
hello = QLabel(\"Hello, World\", parent=mayaMainWindow) \n\
hello.setObjectName(\'MyLabel\') \n\
hello.setWindowFlags(Qt.Window) # Make this widget a standalone window even though it is parented \n\
hello.show() \n\
hello = None # the \"hello\" widget is parented, so it will not be destroyed. \n\
\n\
# BROKEN: Widget is destroyed \n\
hello = QLabel(\"Hello, World\", parent=None) \n\
hello.setObjectName(\'MyLabel\') \n\
hello.show() \n\
hello = None # the \"hello\" widget is not parented, so it will be destroyed.</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6F19D0A948134F118E3C49DB216D1A65\"></a> \n\
            <h2><a name=\"GUID-63FFC519-6186-4B81-A0D0-D5532CF1B91D\"></a>Use the maya.app.general.mayaMixin Classes\n\
            </h2> \n\
            <p>See \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-F65DBAFC-21C0-47C1-ABD0-161EE77D0F6C.htm\">Writing Workspace controls</a></span> for details on how to write PyQt and PySide widgets that are compatible with Maya\n\
               workspaces. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";