var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-83960F05-5BF9-4BA7-9A81-3458140CE2CE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Sharing OpenGL resources in QGLWidgets with Viewport 2.0</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-83960F05-5BF9-4BA7-9A81-3458140CE2CE\"></a><div class=\"head\">\n\
            <h1> Sharing OpenGL resources in QGLWidgets with Viewport 2.0 </h1>\n\
         </div><a name=\"FIG_39E69B152BB744898564367331FB1C7A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-4AB6AA8F-094A-422B-981B-D2867DCC6E66-low.png\"></div>\n\
         <p> You can directly access a QGLWidget whose context is shared with other Viewport 2.0\n\
            resources. This is useful in the case when your plug-in creates OpenGL resources for\n\
            it\'s own QGLWidget and you want it to share the plug-in\'s OpenGL resources with Viewport\n\
            2.0. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_6008E29A1916457DABB84DDD8A19819A\"></a> \n\
            <h2><a name=\"GUID-F66CD46D-AB8D-457F-BAB1-3B6100F0815E\"></a>Using Python\n\
            </h2> \n\
            <p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">import PySide2\n\
import PySide2.QtOpenGL\n\
import PySide2.QtWidgets\n\
import shiboken2\n\
# Get the property from the application (as a QWidget)\n\
widget = QtWidgets.qApp.property(\"mayaSharedQGLWidget\")\n\
# Get the raw C++ pointer\n\
ptr = long(shiboken2.getCppPointer(widget)[0])\n\
# Downcast to QGLWidget\n\
glWidget = shiboken2.wrapInstance(ptr, PySide2.QtOpenGL.QGLWidget)\n\
# Print the format of the current rendering context\n\
print glWidget.format()</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0E51D0FAEFF94E10A439FA527C1CCE76\"></a> \n\
            <h2><a name=\"GUID-671D10A3-C8E8-49BB-B533-0FC09ED89F85\"></a>Using C++\n\
            </h2> \n\
            <p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">QVariant v = qApp-&gt;property(\"mayaSharedQGLWidget\");\n\
if (v.isValid())\n\
{\n\
			QGLWidget glWidget = dynamic_cast&lt;QGLWidget*&gt;(v.value&lt;QWidget*&gt;());\n\
}</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";