var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-85B1116E-F0C1-42AD-9CD4-30E936B6C7B8\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Command Plug-ins</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-85B1116E-F0C1-42AD-9CD4-30E936B6C7B8\"></a><div class=\"head\">\n\
            <h1>Command Plug-ins</h1>\n\
         </div>\n\
         <p><a name=\"GUID-F54A22F2-8466-4827-A9EC-1685FC0C15A6\"></a>In the following topic, we outline the basic code structure of a command plug-in.\n\
            \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_CC5AA21E172C44FB943ECB624A496D81\"></a> \n\
            <h2><a name=\"GUID-32BE44FF-27EA-4CE5-A2A2-239FDAA8F148\"></a>Sample Command Plug-in\n\
            </h2> \n\
            <p><a name=\"GUID-41343C67-0DEB-471E-86C0-3DEE5950FE7F\"></a>The following Python code is a sample command plug-in. We examine the relevant sections\n\
               of this sample command plug-in below. \n\
            </p> <a name=\"SECTION_474040DA75E947EE924C51A4A1ABC174\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-427FC195-20BE-4F50-A2A6-A44FC127063C\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandClass( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    kPluginCmdName = \'myCommandName\'\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    @staticmethod \n\
    def cmdCreator():\n\
        \'\'\' Create an instance of our command. \'\'\'\n\
        return MyCommandClass() \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'        \n\
        # Remove the following \'pass\' keyword and replace it with \n\
        # the code you want to run.\n\
        pass\n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( MyCommandClass.kPluginCmdName, \n\
            MyCommandClass.cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + MyCommandClass.kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( MyCommandClass.kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + MyCommandClass.kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(\'sampleCommand.py\')\n\
cmds.myCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_8CE801F90110495CA262B719F59C4586\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-34304C4E-BA56-4A4F-836B-5FB98F528DEA\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myCommandName\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # Remove the following \'pass\' keyword and replace it with \n\
        # the code you want to run.\n\
        pass\n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCommandClass() )\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(\'sampleCommand.py\')\n\
cmds.myCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_300BCFAAB0784D649898090CBE6428C1\"></a> \n\
            <h2><a name=\"GUID-B5312B37-0734-4DBD-B727-29CB496CB6D3\"></a>Maya Plug-in Entry and Exit Points\n\
            </h2> \n\
            <p><a name=\"GUID-CCA6EB34-1EE3-4ACC-86F2-8EA408C53ED0\"></a>Maya plug-ins require two specific functions: <span class=\"code\" translate=\"no\">initializePlugin()</span>, and <span class=\"code\" translate=\"no\">uninitializePlugin()</span>, which are respectively called when Maya attempts to load and unload the plug-in.\n\
               If these two functions do not exist in the file, the plug-in will fail to load. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    ...\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    ...</pre></div> \n\
            <p><a name=\"GUID-3C2E0026-94D3-43D0-AC76-78000C172C3A\"></a>The code within these functions depends on the plug-in type; in the current case,\n\
               our plug-in class is derived from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span>, so we must register it by calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin.registerCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html#a64fa4221b58a1bd2937e0bb93e50b3c8&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin.registerCommand()</a></span>. This function takes the following two parameters: \n\
            </p> <a name=\"OL_13DD3816F9D544699FDF784741D38366\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">Command Name</em> - This variable, which has been arbitrarily named <span class=\"code\" translate=\"no\">kPluginCmdName</span>, contains the name of our command. We assign the string <span class=\"code\" translate=\"no\">\'myCommandName\'</span> as its value, which is re-used in <span class=\"code\" translate=\"no\">MFnPlugin.dergisterCommand()</span> and in the error reporting call to <span class=\"code\" translate=\"no\">sys.stderr.write()</span>. Having registered our command\'s name as <span class=\"code\" translate=\"no\">\'myCommandName\'</span>, we can run our command using the following Python instructions in Maya\'s Script\n\
                  Editor: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.myCommandName()</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">Command Creation Function Reference</em> - The second parameter is a reference to a function which creates an instance of\n\
                  our command. Here, <span class=\"code\" translate=\"no\">cmdCreator</span> creates an instance of our command class and returns it as a valid Maya object pointer.\n\
                  \n\
                  <p><a name=\"GUID-D11E63CB-D39A-4E65-B010-FA9A41E907E3\"></a>Note that in the Python API 1.0, the pointer must be cast to a valid Maya object using\n\
                     <span class=\"code\" translate=\"no\">OpenMayaMPx.asMPxPtr()</span>. This is not required in the Python API 2.0. However, a <span class=\"code\" translate=\"no\">maya_useNewAPI()</span> function must be defined to indicate what type objects are being passed. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    ...</pre></div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_83B9F0351AAB4429A90EF40030C49BCF\"></a> \n\
            <h2><a name=\"GUID-2636C127-7FCF-4CBB-A493-63198C6C8FDE\"></a>Command Behavior\n\
            </h2> \n\
            <p><a name=\"GUID-6105663B-6BF9-4CCE-A479-E4C539A58E77\"></a>The behavior of our command is defined in <span class=\"code\" translate=\"no\">MyCommandClass</span>, which inherits from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> - the base class of all custom Maya commands. Classes prefixed by <span class=\"code\" translate=\"no\">MPx</span> are known as <em class=\"mild\">proxy</em> classes, and are used to create various plug-in types. In the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A9070270-9B5D-4511-8012-BC948149884D.htm\">Dependency Graph Plug-in Basics</a></span> section, we show how classes derived from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> are used to create other plug-in types such as custom deformers, constraints, software\n\
               and hardware shading nodes, surfaces, etc. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">class MyCommandClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        ...\n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Command execution. \'\'\'\n\
        \n\
        # Remove the following \'pass\' keyword and replace it with \n\
        # the code you want to run.\n\
        pass</pre></div> \n\
            <p><a name=\"GUID-F5CAED9D-567B-48AE-9B21-940A2D8518AF\"></a> The class name (<span class=\"code\" translate=\"no\">MyCommandClass</span>) can be any arbitrary name, however it must contain two specific functions: \n\
            </p> <a name=\"UL_E0768AC42C2A4BE780CD8A60F55A387F\"></a><ul>\n\
               <li><em class=\"strong\"> __init__(self)</em> - This is the command\'s constructor. Its body must invoke the constructor of the\n\
                  base class from which it is derived. \n\
               </li>\n\
               <li><em class=\"strong\">doIt(self, args)</em> - This is the command execution function; any code you want to run when your command\n\
                  is invoked should be written here. When the command is run either through MEL or the\n\
                  <span class=\"code\" translate=\"no\">maya.cmds</span> Python module, the command is instantiated, and its <span class=\"code\" translate=\"no\">doIt()</span> method is passed the specified arguments via the <span class=\"code\" translate=\"no\">args</span> parameter. \n\
                  <div><a name=\"GUID-9831FF16-7A9D-4EC8-908A-9BC4744BAB12\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For more information on defining your command\'s arguments and flags, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A343C962-AEE1-4113-9DEC-1A88CF818AE9.htm\">Command Arguments and Flags</a></span>. \n\
                     </div>\n\
                  </div> \n\
                  <div><a name=\"GUID-27145723-E38D-44A4-B980-98060040EB91\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Your command can also support the <span class=\"code\" translate=\"no\">undoIt()</span> and <span class=\"code\" translate=\"no\">redoIt()</span> functions, allowing it to be undone and re-done. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D.htm\">Creating and Manipulating Objects</a></span>. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";