var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-A315D8E2-3D86-46BB-97DF-45E3ABE1A0AA\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Accessing Resource Handles and Device Handle</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A315D8E2-3D86-46BB-97DF-45E3ABE1A0AA\"></a><div class=\"head\">\n\
            <h1> Accessing Resource Handles and Device Handle</h1>\n\
         </div>\n\
         <p><a name=\"GUID-15BC6558-E05D-4CBB-835D-B2F5DE95401F\"></a>Although writing device or draw API specific code is discouraged, access is sometimes\n\
            necessary when device spe­cific information is required. An example of this is if\n\
            a plug-in wishes to perform some operations using GPU com­pute. \n\
         </p>\n\
         <p><a name=\"GUID-42355868-6F08-4DF3-B1A8-1BB75E63059B\"></a>The draw API specific information can be obtained by accessing a handle to a resource.\n\
            Handles can be accessed at the following levels: \n\
         </p><a name=\"UL_3283AB4B3C954B3C870D3FB84D5A804E\"></a><ul>\n\
            <li><em class=\"strong\">Device</em>: For DirectX11, a reference to the D3D device used by the framework can be returned.\n\
               For OpenGL this is an OpenGL context which can be used to share with a context created\n\
               by the plug-in. The sharing API on Windows is uni-directional, and as such, the destination\n\
               of the share should never be the context for the existing framework; otherwise, all\n\
               resources in the framework are destroyed. \n\
            </li>\n\
            <li><em class=\"strong\">Textures</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MTexture</a></span>): A pointer reference to a shader resource view for DirectX11 or a texture identifier\n\
               for OpenGL can be returned. \n\
            </li>\n\
            <li><em class=\"strong\">Target</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MRenderTarget</a></span>): This is exposed as a pointer reference to a render target view or a depth stencil\n\
               view (depending on target type) for DirectX. For OpenGL this is returned as a pointer\n\
               to a texture id. \n\
            </li>\n\
            <li><em class=\"strong\">Vertex and index buffers</em>: For DirectX11 a pointer reference to a buffer can be returned. For OpenGL a pointer\n\
               reference to the buffer id can be returned. \n\
            </li>\n\
            <li><em class=\"strong\">State objects</em>: <a name=\"UL_67ABB102F25446DA8E75DBE0F97C1E69\"></a><ul>\n\
                  <li><em class=\"strong\">Blend States</em>: For DirectX, a pointer to a Direct3D state object is returned. \n\
                  </li>\n\
                  <li><em class=\"strong\">Rasterizer States</em>: For DirectX, a pointer to a Direct3D state object is returned. \n\
                  </li>\n\
                  <li><em class=\"strong\">Depth Stencil States</em>: For DirectX, a pointer to a Direct3D state object is returned. \n\
                  </li>\n\
                  <li><em class=\"strong\">Sampler States</em>: For DirectX, a pointer to a Direct3D state object is returned. \n\
                  </li>\n\
                  <li>There is no equivalent for a state object in OpenGL. Thus, to access state, descriptors\n\
                     for each state type should be used. Setting state without using API state objects\n\
                     is discouraged as the internal framework cannot track these changes. \n\
                  </li>\n\
               </ul> \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-D8370896-C511-419E-9A1C-54C5D7C8251A\"></a>The recommended practice is for a plug-in to create all of the required resources\n\
            via the API and extract the appropriate GPU references. \n\
         </p>\n\
         <p><a name=\"GUID-82D93BFD-B775-460C-A8CC-EA98623BA192\"></a>As long as the plug-in holds on to a reference to the API wrapper, there is a reference\n\
            to it and it should not disappear. Due to resource management handling, it is always\n\
            best to re-query the handle in case it has changed. Resource handles should not change\n\
            within a single frame render. \n\
         </p>\n\
         <p><a name=\"GUID-1972DDB4-B590-4D0B-BED0-CAEEF14185CC\"></a>It is the responsibility of the plug-in to manage any resources which are created\n\
            directly on the GPU (with­out going through the API). Additionally, this data cannot\n\
            be used to create resources via the exposed API wrapper constructs. \n\
         </p>\n\
         <p><a name=\"GUID-8912CA34-1F7A-43FB-AA55-B7219CAF57C8\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxShaderOverride</a></span> is an interface which commonly accesses GPU data. Both the CgFx and the dx11Shader\n\
            SDK plug-ins show examples of how to access raw data in order to either bind parameters\n\
            to shaders or to bind geometry for drawing. Additionally, the plug-ins include code\n\
            to access the GPU context to create resources which are not tracked by the internal\n\
            framework. \n\
         </p>\n\
         <p><a name=\"GUID-78EF114C-AA3E-4388-A408-BED52F1FD29D\"></a> <span class=\"charspan-emphasis\">DirectCompute Example</span> \n\
         </p>\n\
         <p><a name=\"GUID-3FA282A5-B060-4235-8E8B-6127E515BAB5\"></a>One possible way to use GPU compute is for supporting procedurally generated geometry.\n\
            To set this up, a plug-in can be written which adds a custom DAG node (for example,\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxLocatorNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_locator_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_locator_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxLocatorNode</a></span>) along with an asso­ciated draw override (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxDrawOverride</a></span>). Within the draw routine for the override, the DirectX11 device is queried: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the device and context\n\
ID3D11Device* dxDevice = NULL;\n\
ID3D11DeviceContext* dxContext = NULL;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MRenderer</a>* theRenderer = <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MRenderer::theRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a4678a72ac6959ed21d422d27928d0343&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MHWRender::MRenderer::theRenderer</a>();\n\
if (theRenderer-&gt;drawAPI() == MHWRender::DrawAPI::kDirectX11)\n\
{\n\
    // init device\n\
    ID3D11Device* dxDevice = (ID3D11Device*)theRenderer-&gt;GPUDeviceHandle();\n\
    if (!dxDevice) return;\n\
\n\
    // get context\n\
    dxDevice-&gt;GetImmediateContext(&amp;dxContext);\n\
    if (!dxContext) return;\n\
}\n\
</pre></div>\n\
         <p><a name=\"GUID-D9903B75-89A8-47EA-9998-43C1C75702BF\"></a>After this information has been extracted, a compute shader is used to fill in a texture.\n\
            This texture is then used by a pixel shader to render some geometry. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">// Load in a compute shader\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a> shaderPath(\"myComputeShader.hlsl\");\n\
ID3D11ComputeShader* aComputeShader = NULL;\n\
\n\
ID3D10Blob* pPSBuf = NULL;	\n\
HRESULT hr = D3DX11CompileFromFile( shaderPath.asChar(), NULL, NULL, \"AComputeShader\", \"cs_5_0\", 	dwShaderFlags, NULL, NULL, &amp;pPSBuf, NULL, NULL );\n\
hr = dxDevice-&gt;CreateComputeShader( ( DWORD* )pPSBuf-&gt;GetBufferPointer(), pPSBuf-&gt;GetBufferSize(), NULL, &amp;aComputeShader );\n\
pPSBuf-&gt;Release();\n\
\n\
// The “resource” to update. Filled by the compute shader(s), and\n\
// rendered by the pixel shader.\n\
ID3D11ShaderResourceView*  shaderResourceView; // Pixel shader view\n\
ID3D11UnorderedAccessView* computeResourceView; // Compute shader view\n\
Resource pRenderOutput;\n\
ID3D11Texture2D* outputTexture = NULL;\n\
\n\
// Create a 2D texture to write into\n\
D3D11_TEXTURE2D_DESC tdesc;\n\
tdesc.Width = g_width;\n\
tdesc.Height = g_height;\n\
tdesc.MipLevels = 1;\n\
tdesc.ArraySize = 1;\n\
tdesc.SampleDesc.Count = 1;\n\
tdesc.SampleDesc.Quality = 0;\n\
tdesc.Usage = D3D11_USAGE_DEFAULT;\n\
tdesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;\n\
tdesc.BindFlags = D3D11_BIND_SHADER_RESOURCE | D3D11_BIND_UNORDERED_ACCESS;\n\
tdesc.CPUAccessFlags = 0;\n\
tdesc.MiscFlags = 0;\n\
		\n\
hr = dxDevice-&gt;CreateTexture2D(&amp;tdesc, NULL, &amp;outputTexture);\n\
\n\
// Create an unordered access view to the texture which a compute shader \n\
// can write into.\n\
dxDevice-&gt;CreateUnorderedAccessView( outputTexture, NULL, &amp;computeResourceView);\n\
// Create a resource view to the texture that will be used by a pixel shader \n\
dxDevice-&gt;CreateShaderResourceView(  outputTexture, NULL, &amp;shaderResourceView);\n\
\n\
// Set inputs\n\
dxContext-&gt;CSSetShaderResources( 0, 1, shaderResourceView);\n\
// Set outputs\n\
dxContext-&gt;CSSetUnorderedAccessViews(0, 1, computeResourceView, (UINT*)(&amp;computeResourceView));\n\
\n\
// Set the compute shader\n\
dxContext-&gt;CSSetShader(aComputeShader, NULL, 0 );\n\
// Run the compute shader with 32 x 32 groups (e.g.)\n\
dxContext-&gt;Dispatch( 32, 32, 1 );\n\
\n\
//...\n\
</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";