var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-C050065C-A7DE-4A46-B035-4B526449DE68\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Getting started with .NET API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C050065C-A7DE-4A46-B035-4B526449DE68\"></a><div class=\"head\">\n\
            <h1>Getting started with .NET API</h1>\n\
         </div>\n\
         <p><a name=\"GUID-286E4652-32BD-4149-AC7E-FEACE4899CE1\"></a> The Maya .NET API is a system that allows developers to create plug-ins and extensions\n\
            for Maya using Microsoft’s .NET technology. It includes the following features: \n\
            	 \n\
         </p><a name=\"UL_147B5FD98CDB44768B997D0EC3BF688C\"></a><ul>\n\
            <li>A system for loading plug-in code from .NET assemblies \n\
               		\n\
            </li>\n\
            <li>.NET assemblies that plug-in writers can import to access the Maya SDK from .NET languages\n\
               \n\
               		\n\
            </li>\n\
            <li>Services for embedding WPF/XAML windows into Maya’s QT system \n\
               		\n\
            </li>\n\
            <li>Examples written in C# for demonstrating the usage of the system \n\
               		\n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-859A066F-D39B-4A73-927B-D1D66399C1D3\"></a>The Maya .NET API is similar to the Maya Python API in that it is generated from the\n\
            Maya C++ API. Most classes in the .NET API have a corresponding class in the C++ API\n\
            with the same name and with a similar interface (that is, a set of functions and classes).\n\
            \n\
            	 \n\
         </p>\n\
         <p><a name=\"GUID-6D6F3DD6-F073-4E02-BDE1-BC7460D614D0\"></a>C# classes are proxies for C++ classes. \n\
            	 \n\
         </p>\n\
         <p><a name=\"GUID-D2899D40-D3E1-4E1A-A329-3B3EA8E703EA\"></a>The system provides the following advantages: \n\
            	 <a name=\"UL_D22C7602009F471995F9263696C0C3A2\"></a><ul>\n\
               <li> Allow plug-in writers to accelerate their development of plug-ins by enabling the\n\
                  use of modern tools such as C# and .NET SDKs. The Maya SDK is provided in an idiomatic\n\
                  style for .NET programmers. \n\
                  		\n\
               </li>\n\
               <li>Allow developers to better integrate their existing custom pipeline tools with Maya,\n\
                  and allow artists to have access to critical production tools inside of their content\n\
                  creation environment. \n\
                  		\n\
               </li>\n\
               <li>Allow developers to re-use their existing investment in .NET code and WPF/XAML user\n\
                  interfaces by referencing their assemblies into their Maya plug-ins. \n\
                  		\n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_26A41E8F090248FFB9E380F4A4499299\"></a> \n\
            <h2><a name=\"GUID-A7BD54B3-019E-4982-B9E8-55176F18EC79\"></a>Requirements\n\
            </h2> \n\
            <p><a name=\"GUID-E3AE299A-1B20-4BC5-B750-AE19A2062D0A\"></a>The .NET SDK is installed with Maya as of Extension 2 for Maya 2013. The .NET bindings\n\
               do not work with any other version of Maya (including Maya 2013). \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-13440CE2-466E-41CE-B5C7-F2F93A69477D\"></a>The Maya .NET API uses the .NET 4.5 Framework and is compatible with .NET 4.0 Framework.\n\
               \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-3D602A30-E400-4816-8CA2-D11BF8A5054F\"></a>It is recommended that you use .NET Framework 4.5 and Microsoft Visual Studio 2012\n\
               to compile the examples. However, you can still use .NET Framework 4.0 and Visual\n\
               Studio 2010 to create a solution and compile the examples. \n\
               		\n\
            </p> \n\
            <div><a name=\"GUID-A24706FC-B382-43CD-90F2-7C2C05C2C869\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>In this chapter, the path prefix &lt;...&gt; denotes your Maya install directory. \n\
                  		\n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9B73AE3C63D74FD9800274A261BBAB84\"></a> \n\
            <h2><a name=\"GUID-1397A38B-FF97-441B-A60B-1CF05F5418ED\"></a>.NET SDK Files\n\
            </h2> \n\
            <p><a name=\"GUID-968FC699-366E-4061-B470-F874255E41E2\"></a>The Maya .NET SDK constitutes the following files: \n\
               		\n\
            </p> <a name=\"UL_9FA27AA1EF534B2BA342AE114A723FFB\"></a><ul>\n\
               <li>In the \n\
                  			 <span class=\"code\" translate=\"no\">&lt;...&gt;\\bin</span> folder: \n\
                  			 <a name=\"UL_9DADDF2314B946D9ACD35FCC3416A722\"></a><ul>\n\
                     <li><span class=\"code\" translate=\"no\">openmayacs.dll</span> / \n\
                        				  <span class=\"code\" translate=\"no\">swigfiles.dll</span> – The .NET SDK class libraries \n\
                        				\n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">openmayacs.xml</span> <span class=\"code\" translate=\"no\"></span>- The Visual Studio XML documentation \n\
                        				\n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li>In the \n\
                  			 <span class=\"code\" translate=\"no\">devkit\\dotnet</span> folder of your Developer Kit installation: \n\
                  			 <a name=\"UL_097E01D457294BB7BC7CBF345D51CE45\"></a><ul>\n\
                     <li>C# examples files, compiled through provided solutions: \n\
                        				  <span class=\"code\" translate=\"no\">examples.sln</span> and \n\
                        				  <span class=\"code\" translate=\"no\">wpfexamples.sln</span>. \n\
                        				\n\
                     </li>\n\
                  </ul> \n\
                  <div><a name=\"GUID-2D34B2B4-737C-4E69-87EF-2CADCE0EDA8C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                        <p><a name=\"GUID-0D3EA95C-D56B-4561-8FCC-1913D840581B\"></a>The Developer Kit is available online at Autodesk Exchange at \n\
                           				  <a href=\"https://apps.exchange.autodesk.com/MAYA/en/Home/Index\" target=\"_blank\">https://apps.exchange.autodesk.com/MAYA/en/Home/Index</a>. See \n\
                           				  <span class=\"char_link\"><a href=\"#!/url=./files/Setting_up_your_build_env_Windows_env_32bit_and_64bit.htm\">Setting up your build environment: Windows environment (64-bit)</a></span> for more information. \n\
                           				\n\
                        </p> \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7DA2BD4882E1466283FC666EB6821693\"></a> \n\
            <h2><a name=\"GUID-642FA60D-B713-49F0-8C36-4D920DB84ED1\"></a>Visual Studio integrated documentation\n\
            </h2> \n\
            <p><a name=\"GUID-C445F09F-1BCD-416D-82E7-1E8BEC5FF827\"></a>In addition to using the Maya API C++ reference documentation, the Maya .NET API ships\n\
               with Visual Studio integrated documentation generated from the C++ reference documentation.\n\
               This enables: \n\
               		\n\
            </p> <a name=\"UL_4B7CCE54945C4A6D975B82BCECB3B6BF\"></a><ul>\n\
               <li>Tool tips \n\
                  		  \n\
               </li>\n\
               <li>Comments in the auto-generated code files when using \n\
                  			 <em class=\"mild\">go to definition</em> (F12). \n\
                  		  \n\
               </li>\n\
               <li>Help in object browser \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <div><a name=\"GUID-4240C559-9968-4D2D-A0AE-0C13146DBF51\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can also obtain a \n\
                  		  <span class=\"code\" translate=\"no\">.chm</span> of the .NET reference documentation at \n\
                  		  <a href=\"http://www.autodesk.com/me-sdk-docs\" target=\"_blank\">http://www.autodesk.com/me-sdk-docs</a>. \n\
                  		\n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";