var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Creating and Manipulating Objects</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CC5EDDD2-4331-4CF8-863F-9DDDA90A343D\"></a><div class=\"head\">\n\
            <h1>Creating and Manipulating Objects</h1>\n\
         </div>\n\
         <p><a name=\"GUID-7D3DC885-71CC-4AB1-BCB0-3F51CA1D6A7D\"></a>In the context of command plug-ins, object creation and manipulation is intimately\n\
            tied to Maya\'s undo/redo system. In fact, commands which manipulate the state of the\n\
            <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A9070270-9B5D-4511-8012-BC948149884D.htm\">Dependency Graph</a></span> and its nodes (which includes the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-0B85C721-C3C6-47D7-9D85-4F27B787ABB6.htm\">DAG</a></span>) should implement an undo operation to reverse the action to ensure that Maya\'s internal\n\
            state remains in sync with its undo stack. In this topic, we illustrate how to create\n\
            and manipulate objects within an undoable command. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_E64345777DC5412CB713CC00F86933E0\"></a> \n\
            <h2><a name=\"GUID-F51945E7-F04F-4C24-9556-4AC29AE4E68D\"></a>Sample Undoable Command\n\
            </h2> \n\
            <p><a name=\"GUID-C5F41770-7DA6-4B43-9F60-D51ED5836777\"></a>We begin by presenting the structure of an undoable command. Later in this topic,\n\
               we will present an undoable command which creates and manipulates a camera. \n\
            </p> <a name=\"SECTION_25749785FDB240F09ED24BB7F7C4B68A\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-335663FA-EFA3-4790-A39B-EA458F67D882\"></a><span class=\"collapsible-section-title\">Python API 2.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
\n\
kPluginCmdName = \'myUndoableCommandName\'\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return MyUndoableCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'pySampleUndoableCommand.py\' )\n\
cmds.myUndoableCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-BB767225-EFEA-461F-A5D0-809C6E299597\"></a></p> <a name=\"SECTION_F01868A8877F470CB7CC5AF81911D694\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-A95A6C2A-1322-4C3A-BD08-B2F7B7733A5C\"></a><span class=\"collapsible-section-title\">Python API 1.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = \'myUndoableCommandName\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyUndoableCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleUndoableCommand.py\' )\n\
cmds.myUndoableCommandName()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-149E5B76-2F5C-40C3-8C6C-9DF8EEABA328\"></a>The command plug-in above contains four important functions which are called by Maya\n\
               during the command execution process: \n\
            </p> <a name=\"UL_57EB8FE290B14C80BEAA36FDDB2CB4F7\"></a><ul>\n\
               <li><em class=\"strong\">isUndoable()</em> - If the command\'s <span class=\"code\" translate=\"no\">isUndoable()</span> function returns <span class=\"code\" translate=\"no\">True</span>, the instance of that command will be added to Maya\'s undo stack. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">doIt()</em> - The <span class=\"code\" translate=\"no\">doIt()</span> function of each command instance is invoked <em class=\"mild\">once</em> when the command is first executed. To maximize code re-use, it is recommended to\n\
                  have the <span class=\"code\" translate=\"no\">doIt()</span> function instantiate all the objects and variables your command instance will require,\n\
                  and to subsequently call <span class=\"code\" translate=\"no\">redoIt()</span> from within <span class=\"code\" translate=\"no\">doIt()</span> function body. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\'\n\
        \n\
        # Parse any arguments when doIt() is invoked.\n\
        self.parseArgs( args )\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">redoIt()</em> - The <span class=\"code\" translate=\"no\">redoIt()</span> function is invoked by Maya every time the command is re-done. <span class=\"code\" translate=\"no\">redoIt()</span> should therefore be used manipulate the state of the objects used in your command.\n\
                  Keep in mind that this state manipulation should be reversed in the <span class=\"code\" translate=\"no\">undoIt()</span> function. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">undoIt()</em> - The <span class=\"code\" translate=\"no\">undoIt()</span> function is called when the command is undone. The objective of the <span class=\"code\" translate=\"no\">undoIt()</span> function is to ensure that each object manipulated by your command has its state\n\
                  reversed to before your command was executed. If the instance of the command does\n\
                  not reverse its manipulations correctly, Maya\'s internal state will be inconsistent\n\
                  in regards to its undo/redo stack. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass</pre></div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2B9A7DF0170D4A84A6EFB8E085526C51\"></a> \n\
            <h2><a name=\"GUID-1C993EF3-E1F7-4D67-8F40-148BBF008C1B\"></a>Creating Objects with MDagModifier\n\
            </h2> \n\
            <p><a name=\"GUID-F68EC6D3-9DBB-40B3-BE29-14899DEE3C07\"></a> To facilitate the creation of DAG nodes, and the undoing of DAG node manipulations,\n\
               the Maya API provides the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> class. This class is derived from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span>, which is used to create and manipulate Dependency Graph nodes. Recall that the DAG\n\
               is a subset of the Dependency Graph, and so the functions provided by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span> are also provided by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> - this may help you when consulting the class documentation of the function calls\n\
               made to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span> in this topic. \n\
            </p> \n\
            <p><a name=\"GUID-0FCA13B3-339F-4169-830F-598922633299\"></a>In the undoable command that follows, we create and manipulate a camera, and also\n\
               set the current view to this newly created camera: \n\
            </p> <a name=\"SECTION_D93B978184014BBB9746006AD55B2246\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-717AB321-F291-4359-AEF7-8EA8845EEA0A\"></a><span class=\"collapsible-section-title\">Python API 2.0: </span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCameraCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
import maya.api.OpenMayaUI as OpenMayaUI\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
	\n\
kPluginCmdName = \'myCameraCommand\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a> ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        self.previousCamera=currentView.getCamera() # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        cameraDagPath = dagNodeFn.getPath()\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        self.previousCamera = currentView.getCamera()\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return  MyCameraCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'pySampleCameraCommand.py\' )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_44A9F3DA26DC4818B5EB6343EEF6B04A\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-D5904EBA-08F3-48C0-B25A-6550024B64EA\"></a><span class=\"collapsible-section-title\">Python API 1.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCameraCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaUI as OpenMayaUI\n\
\n\
kPluginCmdName = \'myCameraCommand\'\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.getCamera( self.previousCamera ) # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        dagNodeFn.getPath( cameraDagPath )\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. \'\'\'\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    \'\'\' Create an instance of our command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( MyCameraCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    \'\'\' Initialize the plug-in when Maya loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \'Failed to register command: \' + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    \'\'\' Uninitialize the plug-in when Maya un-loads it. \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \'Failed to unregister command: \' + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( \'sampleCameraCommand.py\' )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
            <p><a name=\"GUID-0069A4EE-714E-476D-BC6B-A89E16709B20\"></a>In the sample above, the key functions we are interested in (for now) are: <span class=\"code\" translate=\"no\">MDagModifer.createNode()</span>, <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> and <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span>. These functions are respectively distributed among our command\'s <span class=\"code\" translate=\"no\">doIt()</span>, <span class=\"code\" translate=\"no\">redoIt()</span> and <span class=\"code\" translate=\"no\">undoIt()</span> methods: \n\
            </p> <a name=\"OL_D8BAD32F6184474396861909BEB88C4C\"></a><ol type=\"1\" start=\"1\">\n\
               <li><em class=\"strong\">MDagModifier.createNode()</em> - When <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> is called, the operation is queued within the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span>, and an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> is returned. This <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> is a handle to a newly created Maya DAG node which has <em class=\"mild\">not yet</em> been included into DAG. Observe that we are invoking the method signature of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> which accepts a string as the first parameter. This string represents the created\n\
                  node type\'s name. Valid node type names are listed under <em class=\"strong\">Maya User Guide &gt; Technical Documentation &gt; Nodes</em>, for example: <span class=\"code\" translate=\"no\">\'transform\'</span> and <span class=\"code\" translate=\"no\">\'camera\'</span>. The call to <span class=\"code\" translate=\"no\">MDagModifier.renameNode()</span> is also queued within the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a></span>, and is used to do/undo the renaming of a node. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        \'\'\' doIt() is called once when the command is first executed. \'\'\' \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, \'myCameraTransform\' )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, \'myCameraShape\' )\n\
        \n\
        # Call self.redoIt() to perform the command\'s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()</pre></div> \n\
               </li>\n\
               <li><em class=\"strong\">MDagModifier.doIt()</em> - When <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> is called, the previously queued operations are effectively executed. As such, the\n\
                  queued <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span> operation will complete by adding the created node into the DAG. The call to <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> in our command\'s <span class=\"code\" translate=\"no\">redoIt()</span> method effectively lets us operate on the same set of created nodes defined in our\n\
                  command\'s <span class=\"code\" translate=\"no\">doIt()</span> method. Observe that we are not creating new nodes repeatedly when our command\'s\n\
                  <span class=\"code\" translate=\"no\">redoIt()</span> method is invoked. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        # ... object manipulations ...</pre></div> \n\
                  <div><a name=\"GUID-DF76C976-2FC8-407D-A84D-B4E55C9B4E20\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span><span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> can be called several times in the same command. This is necessary when a node must\n\
                        be disconnected and deleted. Consult the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDGModifier</a></span> class documentation for more information. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">MDagModifier.undoIt()</em> - When <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> is called, all the queued operations which have been completed in calls to <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> are undone. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">    def undoIt(self):\n\
        \'\'\' undoIt() is called every time the instance of this command is undone. \'\'\'\n\
        \n\
        # ... revert object manipulations ...\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations queued within the MDagModifier.\n\
        self.dagModifier.undoIt()</pre></div> \n\
                  <div><a name=\"GUID-14A8B138-F586-4079-9201-6664FC10CE13\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>It is sufficient to call <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> only once, despite the number of calls to <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> within the command. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3DB28C1401934FE380114A8ED85C9B45\"></a> \n\
            <h2><a name=\"GUID-81DE13A2-F6BA-4A99-9CBE-1B213FF752E2\"></a>Manipulating Objects\n\
            </h2> \n\
            <p><a name=\"GUID-F9ED6F86-C956-451E-A0D1-28B69C96AA4E\"></a>In our command\'s <span class=\"code\" translate=\"no\">redoIt()</span> method body, we change the position of our camera\'s transform node via a call to\n\
               <span class=\"code\" translate=\"no\">MFnCamera.setTranslation()</span>: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        \'\'\' redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. \'\'\'\n\
        \n\
        # ...\n\
        \n\
        # Set the translation value of the camera\'s transform node. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        \n\
        # ...</pre></div> \n\
            <p><a name=\"GUID-4331A63D-A28A-4699-A798-27F8855FD53A\"></a>This introduces the use of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>s and <em class=\"mild\">function sets</em> in the Maya API. \n\
            </p> <a name=\"UL_A01732147AA14888BEAF26DF27093BB8\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-C40B612B-6F1A-4317-ADFD-882A14042261\"></a><em class=\"strong\">Maya Objects (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>)</em> - The Maya API provides access to Maya objects as instances of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> wrapper class. Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> can therefore represent cameras, lights, meshes, transforms, and dependency graph\n\
                     nodes. The internal state of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> is manipulated via a compatible <em class=\"mild\">function set</em> (classes derived from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span>). All instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> have one and only one Maya Object type (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject.apiType()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html#a07b8aba7153df126d2d56334abcad1ae&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject.apiType()</a></span>), for example: <span class=\"code\" translate=\"no\">MFn.kTransform</span>, or <span class=\"code\" translate=\"no\">MFn.kCamera</span>, which may be compatible with multiple types of <em class=\"mild\">function sets</em>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject.hasFn()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html#a5affad7c61e40a3e6973ab49cd2cca72&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject.hasFn()</a></span> method determines if an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> is compatible with a given function set. \n\
                  </p> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-A6900C10-B578-4BC3-9708-36B82F45A6BB\"></a><em class=\"strong\">Function Sets (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> and subclasses)</em> - <em class=\"mild\">Function sets</em> are provided in the Maya API to manipulate the state of compatible <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>s. They exist as singletons, meaning that Maya contains only one <em class=\"mild\">function set</em> of each type internally. A <em class=\"mild\">function set</em> can only manipulate one <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> at a time, though this object can be changed using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase.setObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html#af1795cba5c81a4ee10680210b71630c6&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase.setObject()</a></span>. A reference to a specific <em class=\"mild\">function set</em> is obtained via its constructor, which can accept an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> to set the current working object. \n\
                  </p> \n\
                  <p><a name=\"GUID-8E09055F-1B6B-49F7-9C18-5B93C7EAEA6C\"></a>An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>\'s function set compatibility follows the class hierarchy up to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> class. An instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> with a Maya Object type of <span class=\"code\" translate=\"no\">MFn.kCamera</span> is therefore compatible with the following function sets: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDependencyNode</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnBase</a></span> \n\
                  </p> \n\
                  <p><a name=\"GUID-AF417BA4-936B-4A1E-AD55-BE2F297C82D4\"></a>The code sample and diagram below illustrate the use of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTransform</a></span> <em class=\"mild\">function set</em> to set the translation of a compatible <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> (of type <span class=\"code\" translate=\"no\">Mfn.kTransform</span>), namely the transform node we had previously assigned to <span class=\"code\" translate=\"no\">self.cameraTransformObj</span> and named as <span class=\"code\" translate=\"no\">\'myCameraTransform\'</span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># Set the translation value of the camera\'s transform node. \n\
transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )</pre></div> <img src=\"images/GUID-13626E8D-6F17-4E47-97C8-64EBC321DF28-low.png\"> \n\
                  <div><a name=\"GUID-451D1E95-4043-4C99-B613-6D185CDA0A20\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The second parameter (<span class=\"code\" translate=\"no\">OpenMaya.MSpace.kTransform</span>) in the call to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform.setTranslation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html#a5b9618d6d1e974b011d5ce6ba6684890&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnTransform.setTranslation()</a></span> specifies that the translation should be applied in the transform node\'s local coordinate\n\
                        space. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_106239DA0CB44E7EA586E810327491F4\"></a> \n\
            <h2><a name=\"GUID-A33EFA40-C785-4F9B-B23A-E5A7C6A677F1\"></a>Warning: Creating and Manipulating Nodes Without MDagModifier\n\
            </h2> \n\
            <p><a name=\"GUID-569D9BC1-936B-4701-A692-46FE16DA9821\"></a>You will notice that the majority of <em class=\"mild\">function sets</em> also provide a <span class=\"code\" translate=\"no\">create()</span> function, for example: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#acf98cd8b37cd4f7747e624e05de34d8b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnCamera.create()</a></span>, which takes care of instantiating an appropriate shape and transform node for you.\n\
               We recommend only using these functions within one-time-use, non-undoable commands,\n\
               for example to initialize a scene. An exception to this guideline is <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a3571e84c33d2411e2909e1c6108e27f7&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh.create()</a></span>, whose use in a command is illustrated in <span class=\"char_link\"><a href=\"#!/url=./files/GUID-D92830AD-7CB7-4FDD-B008-2AF1F11F0CD6.htm\">Example: Creating a Scene</a></span>. In this example, we create a parent transform node with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.createNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a35eec45cc82c334793c92b08ff4fc1f4&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.createNode()</a></span>, and must use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh.create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a3571e84c33d2411e2909e1c6108e27f7&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh.create()</a></span> to define the mesh data under it as a child node. \n\
            </p> \n\
            <p><a name=\"GUID-11202B04-D123-461D-AE9B-8DBF72B52F88\"></a>In a similar fashion, you may notice that the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode</a></span> <em class=\"mild\">function set</em> contains <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode.addChild()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html#a8f50db4c5e3e3ce8bf198ab8debfb91a&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode.addChild()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode.removeChild()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html#a91fb5496562cdd1886aca26ff9887942&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnDagNode.removeChild()</a></span>, and other DAG hierarchy manipulation functions. Unless you are creating a single-use,\n\
               non-undoable command, or want to manually implement your command\'s <span class=\"code\" translate=\"no\">undoIt()</span> logic to reverse these actions, it is preferable to use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier.reparentNode()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html#a9c3459407b5cc1da796cbcd6c6f751cb&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier.reparentNode()</a></span> function, followed by a call to <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6833493CE06A4D148D4D99AC30D56CA6\"></a> \n\
            <h2><a name=\"GUID-CE98FC7B-4939-461C-A5C5-6BF089576EFB\"></a>Warning: Node Deletion with MGlobal.deleteNode()\n\
            </h2> \n\
            <p><a name=\"GUID-7A16F304-0396-4E09-A552-1A03ED75F02F\"></a>You may also be tempted to reverse your command\'s node creations via calls to <span class=\"code\" translate=\"no\">MGlobal.deleteNode()</span> within your command\'s <span class=\"code\" translate=\"no\">undoIt()</span> method. Doing so is not advisable, as calling <span class=\"code\" translate=\"no\">MGlobal.deleteNode()</span> actually executes the MEL node deletion command internally, thereby causing Maya\n\
               to add a command to the undo stack while it is in the process of undoing a command.\n\
               This causes an inconsistency within Maya\'s undo stack, and can result in a crash.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-8A9B92F3-34EE-421A-A28C-813F1E7657E2\"></a> \n\
               <div><a name=\"GUID-BFD53AEF-CBAC-4819-9F74-4656701B612C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For the same reason, we do not recommend invoking <span class=\"code\" translate=\"no\">maya.cmds</span> functions within a command plug-in. The safe alternative is to use the <span class=\"code\" translate=\"no\">MDagModifier.commandToExecute()</span> function to enqueue MEL commands which will be safely executed when <span class=\"code\" translate=\"no\">MDagModifier.doIt()</span> is called. The same MEL commands will be safely undone when <span class=\"code\" translate=\"no\">MDagModifier.undoIt()</span> is called, thus avoiding any undo stack inconsistencies within Maya. Consult <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6031DE26-93CE-445A-AED9-C27C659268E5.htm\">Example: Creating an IK Joint Chain</a></span> for more information. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";