var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-D353FAE7-4B6A-4EAD-9742-A6999CED11C2\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Custom Evaluator API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D353FAE7-4B6A-4EAD-9742-A6999CED11C2\"></a><div class=\"head\">\n\
            <h1>Custom Evaluator API</h1>\n\
         </div><a name=\"FIG_F4C78C424E844CCF95DF6D00B957ADBE\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-57E9DA6F-DB97-48FB-859F-5FA7A7471DF8-low.png\"></div>\n\
         <p>The following section describes new API classes and methods to define custom evaluators.\n\
            Custom evaluators allow control over how the Maya scene is computed. \n\
            	 \n\
         </p>\n\
         <p>If you want to create a custom evaluator, you need to define a plug-in that extends\n\
            the \n\
            		<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator</a></span> class. The following lists the key class methods that you should override. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_DE7CB19B799842198E6F9E6510C2853C\"></a> \n\
            <h2><a name=\"GUID-BF92320A-B011-4956-A6A8-F75B353738F7\"></a>The Basics\n\
            </h2> \n\
            <p>Before new evaluators can be used, they must be registered: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> registerEvaluator(\n\
    // name of the evaluator\n\
    const char *     evaluatorName,  \n\
\n\
    // evaluator priority. Higher priority evaluators get \'first-dibs\'\n\
    unsigned int     uniquePriority,\n\
\n\
    // function pointer to method returning a new evaluator instance \n\
    MCreatorFunction creatorFunction\n\
)</pre></div> \n\
            <p>and deregistered: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> deregisterEvaluator(\n\
    // name of the evaluator\n\
    const char* evaluatorName \n\
)</pre></div> \n\
            <p>using \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin</a></span> methods. These functions should be used during plug-in initialization: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> initializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin</a> plugin( obj, PLUGIN_COMPANY, \"3.0\", \"Any\");\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status = plugin.registerEvaluator(\n\
        \"SimpleValuator\", \n\
        40 /* unused priority */, \n\
        simpleEvaluator::creator);\n\
    if (!status) \n\
        status.perror(\"registerEvaluator\");\n\
    return status;\n\
}</pre></div> \n\
            <p>and uninitialization: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> uninitializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> obj)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnPlugin</a> plugin( obj );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> status = plugin.deregisterEvaluator( \"SimpleValuator\" );\n\
    if (!status)\n\
        status.perror(\"deRegisterEvaluator\");\n\
    return status;\n\
}</pre></div> \n\
            <p>as illustrated above. \n\
               		\n\
            </p> \n\
            <p>Once the plug-in has been loaded, you can use Python or MEL commands to \n\
               		  <em class=\"strong\">enable</em>: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.evaluator(enable=True, name=\'SimpleEvaluator\')\n\
\n\
# Result: False #</pre></div> \n\
            <p><em class=\"strong\">disable</em>: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">cmds.evaluator(enable=False, name=\'SimpleEvaluator\')\n\
\n\
# Result: True # </pre></div> \n\
            <p>and \n\
               		  <em class=\"strong\">query</em> information about evaluators: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">print cmds.evaluator(query=True)\n\
\n\
[u\'dynamics\', ... u\'SimpleEvaluator\']</pre></div> \n\
            <div><a name=\"GUID-75303FE4-566C-47A7-9282-C69F57DC2C4D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The evaluator command returns the previous state of the evaluator. This command fails\n\
                  if the evaluator cannot be enabled. See the \n\
                  		  <em class=\"mild\">Technical Documentation</em> section of the Maya Help for more information on this command. \n\
                  		\n\
               </div>\n\
            </div> \n\
            <p>To view the priorities of all loaded evaluators, use the priority flag on the evaluator\n\
               command: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">for evaluatorName in cmds.evaluator():\n\
    print \"%-25s : %d\" % (\n\
        evaluatorName,\n\
        cmds.evaluator(name=evaluatorName, query=True, priority=True))\n\
\n\
dynamics                 : 103000\n\
ikSystem                 : 102000\n\
timeEditorCurveEvaluator : 101000\n\
disabling                : 100000\n\
GPUOverride              : 5000\n\
transformFlattening      : 3000\n\
reference                : 1000\n\
SimpleValuator           : 40</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DE38DC470C6D40128A4CE3B61EE2BF57\"></a> \n\
            <h2><a name=\"GUID-F5BC3FE3-1039-4596-8B55-DD96576CE90D\"></a>API Reference\n\
            </h2> \n\
            <p>This section provides more detail on different \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator</a></span> API methods. \n\
               		\n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_E32408B0899A4D4AACD49482989B1863\"></a> \n\
               <h3><a name=\"GUID-3A5A0373-3513-49CC-AC92-5233A0CCF073\"></a>Claiming clusters\n\
               </h3> \n\
               <p>During EG partitioning, each evaluator can claim evaluation nodes, using the: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">bool <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::markIfSupported\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#ab796c49be826aa53c78faf09f05ab0c8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::markIfSupported</a>(const <a href=\"javascript:void(0)\" data-symbol=\"MEvaluationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvaluationNode</a>* node)</pre></div>method. It is safe to cause evaluation in this call, but it increases partitioning\n\
               and evaluation time. It is up to the developer to decide whether evaluation is required\n\
               (call \n\
               		  <span class=\"code\" translate=\"no\">.outputValue/.outputArrayValue</span>) or whether the previously evaluated datablock values can be re-used (call \n\
               		  <span class=\"code\" translate=\"no\">.inputValue/.inputArrayValue</span>). If multiple evaluators mark a specific node, priority is used to determine which\n\
               evaluator is assigned a node at run-time. For example, if you have two evaluators,\n\
               A and B, mark node C of interest, and if evaluator A has priority 100, and evaluator\n\
               B has priority 10, then during graph evaluation, evaluator A is assigned the cluster\n\
               with node C. \n\
               		\n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_6E47CF2AB7B14630BB256263F0229AC1\"></a> \n\
               <h3><a name=\"GUID-DAE72F0F-F4BF-40F1-BF56-E84B95A818A7\"></a>Scheduling\n\
               </h3> \n\
               <p>To determine if an evaluator can evaluate clusters in Parallel, use: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode::SchedulingType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html#aa4dfc80e0475312169cf7a2b4299b825&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MCustomEvaluatorClusterNode::SchedulingType</a> schedulingType(\n\
    // a disjoint set of nodes on a custom evaluator layer\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MCustomEvaluatorClusterNode</a> * cluster \n\
)</pre></div> \n\
               <p>where, \n\
                  		  \n\
               </p> <a name=\"TABLE_AADD734FBBE84B45A666C495F50856E3\"></a><div class=\"table-not-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n\
                     <colgroup>\n\
                        <col>\n\
                        <col>\n\
                     </colgroup>\n\
                     <tr class=\"not-ruled-heading\">\n\
                        <th class=\"table-heading\">Scheduling Type \n\
                           					 \n\
                        </th>\n\
                        <th class=\"table-heading\">Details \n\
                           					 \n\
                        </th>\n\
                     </tr>\n\
                     <tr class=\"not-ruled-odd-row\">\n\
                        <td class=\"table-body\">kParallel \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\">any number of nodes of the same type can run in parallel \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"not-ruled-even-row\">\n\
                        <td class=\"table-body\">kSerial \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\">all nodes of this type should be chained and executed sequentially \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"not-ruled-odd-row\">\n\
                        <td class=\"table-body\">kGloballySerial \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\">only one node of this type can be run at a time \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"not-ruled-even-row\">\n\
                        <td class=\"table-body\">kUntrusted \n\
                           					 \n\
                        </td>\n\
                        <td class=\"table-body\">nothing else can execute with this node since it is not possible to predict what will\n\
                           happen \n\
                           					 \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
               <p>During EG scheduling: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">bool <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::clusterInitialize\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#aadcd7c91ee41f0f4ac48923ed11db44b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::clusterInitialize</a>(\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MCustomEvaluatorClusterNode</a>* cluster // evaluation cluster node\n\
)</pre></div> \n\
               <p>can be used to do any required cluster preparation. The pointer to the cluster remains\n\
                  valid until graph invalidation, such as when the scene topology changes. \n\
                  		  \n\
               </p> \n\
               <p>Before the cluster is deleted, \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::clusterTerminate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#a93f7f73d9a911cd75458e64fa9b4a29b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::clusterTerminate</a>(\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MCustomEvaluatorClusterNode</a>* cluster // the cluster to terminate\n\
)</pre></div> \n\
               <p>is called to allow needed cleanup, such as releasing evaluator-specific resources.\n\
                  It\'s up to the custom evaluator to decide if it wants to clear its internal representation.\n\
                  \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_52BB7BA55015411287577C27373024EB\"></a> \n\
               <h3><a name=\"GUID-56AC83CD-AFA9-4AD6-B1A1-CAE56C876E69\"></a>Execution\n\
               </h3> \n\
               <p>There are 3 main methods used during execution. \n\
                  		  \n\
               </p> \n\
               <p>Prior to graph execution, the EM calls: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::preEvaluate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#a0ee39c4c551994ada0ae27f4b9407c48&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::preEvaluate</a>(\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MEvaluationGraph\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_graph.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvaluationGraph</a>* graph // the graph about to be evaluated\n\
)</pre></div> \n\
               <p>during execution, the EM calls: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::clusterEvaluate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#a9bded60be46fea26c410402438aa331a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::clusterEvaluate</a>(\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MCustomEvaluatorClusterNode</a>* cluster // the cluster to be evaluated\n\
)</pre></div> \n\
               <p>You will only receive clusters that belong to this evaluator. This call always happens\n\
                  after \n\
                  			 <span class=\"code\" translate=\"no\">clusterInitialize</span> and never after \n\
                  			 <span class=\"code\" translate=\"no\">clusterTerminate</span>. Finally, \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void <a href=\"javascript:void(0)\" data-symbol=\"MPxCustomEvaluator::postEvaluate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_custom_evaluator.html#a15601c71655108beeb74c77bf70b021a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCustomEvaluator::postEvaluate</a>(\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MEvaluationGraph\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_graph.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MEvaluationGraph</a>* graph // the graph that was evaluated\n\
)</pre></div> \n\
               <p>is called just after a graph evaluation finishes. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_62D58E6C6B6A4A0785BD5C19283FB4EE\"></a> \n\
               <h3><a name=\"GUID-86DD3770-4937-40C1-B2DE-7A1A34EB6535\"></a>Simple Evaluator API example\n\
               </h3> \n\
               <p>Refer to the \n\
                  			 <em class=\"mild\">simpleEvaluator</em> plug-in in the Developer Kit for an example that limits evaluation by caching previous\n\
                  results. \n\
                  		  \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_53D23BA804BC492B80D036306C696232\"></a> \n\
            <h2><a name=\"GUID-7F219AED-AA41-49FC-96CE-4DD5F0BA801B\"></a>Useful script\n\
            </h2> \n\
            <p>This simple script checks which nodes are associated with a given evaluator: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def printClusters(evaluatorName):\n\
    \"\"\"\n\
    Print out any clusters of nodes captured by the specified evaluator.\n\
    \"\"\"\n\
    evaluators = cmds.evaluator( query=True )\n\
    if evaluatorName in evaluators:\n\
        try:\n\
            print cmds.evaluator( \n\
                query=True, \n\
                name=evaluatorName, \n\
                clusters=True )[1:]\n\
        except KeyError:\n\
            print \'No clusters in the specified evaluator\'\n\
    else:\n\
        print \'The specified evaluator is not active. Use the \"evaluator\" command to activate it\'</pre></div> \n\
         </div>\n\
         <p>  </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";