var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-F65DBAFC-21C0-47C1-ABD0-161EE77D0F6C\">\n\
      <meta name=\"indexterm\" content=\"workspaceControl command\">\n\
      <meta name=\"indexterm\" content=\"workspaceControl MEL\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Writing Workspace controls</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F65DBAFC-21C0-47C1-ABD0-161EE77D0F6C\"></a><div class=\"head\">\n\
            <h1> Writing Workspace controls </h1>\n\
         </div><a name=\"FIG_8D5B0E4F9F3D46ED96EFC48662DCAE3F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-889B2E93-B1A5-42D7-9CB5-4408CC0D7121-low.png\"></div>\n\
         <p> You can use workspace controls to create custom UI that can be dragged, docked and\n\
            saved within Maya\'s workspaces system. Workspace controls are created using the \n\
            		<span class=\"code\" translate=\"no\">workspaceControl</span> command. Calling the command with a script passed to the \n\
            		<span class=\"code\" translate=\"no\">uiScript</span> flag that creates the internal UI, allows the workspaces system to save it to a given\n\
            workspace, and properly restore the control the next time it is opened. Note that\n\
            anything called in that script must be available for execution during any subsequent\n\
            Maya startup, which is the time that any saved workspace is restored. \n\
            	 \n\
         </p>\n\
         <p>MEL scripts have to be sourced while Python modules have to be imported. The only\n\
            exceptions are as follows: \n\
            	 \n\
         </p><a name=\"UL_4EB43C1A7F2445F78021240FEA5AC654\"></a><ul>\n\
            <li>Calls to access another workspace control or its contained UI. In this case, you must\n\
               provide the \n\
               		  <span class=\"code\" translate=\"no\">requiredControl</span> flag with the name of the other workspace control. Be aware of cyclical dependencies,\n\
               such as controls that require each other. \n\
               		\n\
            </li>\n\
            <li>Calls to functionality from a plug-in. In this case, you user must provide the \n\
               		  <span class=\"code\" translate=\"no\">requiredPlugin</span> flag with the name of the plug-in. \n\
               		\n\
            </li>\n\
         </ul>\n\
         <p>Workspace controls replace the \n\
            		<span class=\"code\" translate=\"no\">dockControl</span> command which was previously used to create UI that could be docked around the four\n\
            sides of the central viewport. The \n\
            		<span class=\"code\" translate=\"no\">dockControl</span> functionality is no longer supported. You can migrate to workspaceControl functionality\n\
            by creating a script that generates the internal UI when executed, and attach it to\n\
            a \n\
            		<span class=\"code\" translate=\"no\">workspaceControl</span> command call using the \n\
            		<span class=\"code\" translate=\"no\">uiScript</span> flag. You should no longer create a window with internal UI and then attach it to\n\
            a \n\
            		<span class=\"code\" translate=\"no\">dockControl</span> command call via the \n\
            		<span class=\"code\" translate=\"no\">content</span> flag. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_A218EA131CD842A0A880D2B820514DC1\"></a> \n\
            <h2><a name=\"GUID-6B712C20-BEE7-4679-9720-C31E7E23C4C0\"></a>Create workspace controls using MEL\n\
            </h2> \n\
            <p>The following example shows the easiest way of creating workspace controls using MEL.\n\
               Note that the example assumes this script exists in \n\
               		  <span class=\"code\" translate=\"no\">customWorkspaceControlFile.mel</span>. \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">	global proc createCustomWorkspaceControlUI()\n\
	{\n\
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; columnLayout;\n\
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; button;\n\
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; button;\n\
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; button;\n\
	}\n\
	&nbsp;\n\
</pre></div> \n\
            <p> Execute this command to create the control for the first time: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">workspaceControl -retain false -floating true \n\
-uiScript \"if(!`exists createCustomWorkspaceControlUI`) source customWorkspaceControlFile; createCustomWorkspaceControlUI();\" \n\
myCustomWorkspaceControl;</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_15C756DA089148A6A9B9CCABA6C1D17B\"></a> \n\
            <h2><a name=\"GUID-F98A4998-B0DD-4164-B88A-4872602FFDE2\"></a>Create workspace controls using Python with Pyside bindings \n\
            </h2> \n\
            <p>You can create workspace controls in Python by using Maya command scripting. PySide\n\
               only applies if the UI content of the workspace control is PySide-based. \n\
               		\n\
            </p> \n\
            <p> Create a workspace control in PySide UI by doing the following: \n\
               		\n\
            </p> <a name=\"OL_8F6658010DE84D56B1A84FF97BD8CCE3\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Derive the top-level widget from the \n\
                  			 <span class=\"code\" translate=\"no\">MayaQWidgetDockableMixin</span> class. \n\
                  		  \n\
               </li>\n\
               <li>Open the widget using a call to \n\
                  			 <span class=\"code\" translate=\"no\">show()</span> with \n\
                  			 <span class=\"code\" translate=\"no\">dockable</span> set to \n\
                  			 <span class=\"code\" translate=\"no\">True</span>. \n\
                  		  \n\
               </li>\n\
               <li>Set \n\
                  			 <span class=\"code\" translate=\"no\">uiScript</span> to a script that recreates the widget. The script needs to parent the recreated widget\n\
                  into the restored workspace control (locate using \n\
                  			 <span class=\"code\" translate=\"no\">MQtUtil.findControl</span>) using \n\
                  			 <span class=\"code\" translate=\"no\">MQtUtil.addWidgetToMayaLayout</span>. \n\
                  		  \n\
               </li>\n\
            </ol> \n\
            <p> For more information about creating a workspace control using Python see the \n\
               		  <span class=\"code\" translate=\"no\">dockableWorkspaceWidget.py</span> devkit example. To run the example, open it in the \n\
               		  <span class=\"MenuCascade\">Script Editor</span> and execute it. See also \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-66ADA1FF-3E0F-469C-84C7-74CEB36D42EC.htm\">PyQt and PySide Widget Best Practices</a></span>. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_890E1DF429A6454ABFD3A611638156ED\"></a> \n\
            <h2><a name=\"GUID-D3CD1713-F784-4B68-89E6-DAD816DE6BF6\"></a> <em class=\"strong\">Create workspace controls using C++</em> \n\
            </h2> \n\
            <p>When using C++, you must first create the workspace control using the \n\
               		  <span class=\"code\" translate=\"no\">workspaceControl</span> MEL command. It can be executed using the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::executeCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a09e405631e7cf680f8ac9d934ad73434&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal::executeCommand()</a></span> method. You can then parent your C++-created Qt UI into the workspace control using\n\
               the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::addWidgetToMayaLayout()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a42ba7b27654231ee3b1add771f0b7896&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil::addWidgetToMayaLayout()</a></span> method. \n\
               		\n\
            </p> \n\
            <p>The<span class=\"code\" translate=\"no\"> workspaceControlCmd.cpp \n\
                  		  </span>example demonstrates how to create a command that generates the workspace control\n\
               and the containing UI. It also shows how to pass it into the workspaceControl\'s \n\
               		  <span class=\"code\" translate=\"no\">uiScript</span> flag to restore the UI on reopen. Since the command is part of a plug-in, the workspace\n\
               control must be made aware of that plug-in using the \n\
               		  <span class=\"code\" translate=\"no\">requiredPlugin</span> flag so that it can execute the command to restore the UI. \n\
               		\n\
            </p> \n\
            <p>To build the workspaceControlCmd example, see the \n\
               		  <em class=\"mild\">Building the plug-in \n\
                  		  </em>section of the \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-13434252-F0BF-4AC0-B47B-09BD626B0881.htm\">Using Qt in Plug-ins</a></span> topic. After the plug-in is built, load it into Maya and execute the following MEL\n\
               script: \n\
               		\n\
            </p> \n\
            <p><span class=\"code\" translate=\"no\">workspaceControlWindow; \n\
                  		  </span>. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";