var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-94F6D15F-A514-4404-9A39-50A2162EFC43\">\n\
      <meta name=\"indexterm\" content=\"MIt\">\n\
      <meta name=\"indexterm\" content=\"MPx\">\n\
      <meta name=\"indexterm\" content=\"M classes\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using the Maya Python API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-94F6D15F-A514-4404-9A39-50A2162EFC43\"></a><div class=\"head\">\n\
            <h1>Using the Maya Python API</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F923\"></a>It is possible to write basic scripts that use the wrapper, iterator and function\n\
            set classes of the Maya API. These scripts can query and manipulate the Maya model\n\
            but are not fully integrated into Maya. A scripted plug-in provides a more complex\n\
            solution that is tightly integrated into Maya. In this section, we discuss how to\n\
            write both basic and scripted plug-in scripts along with standalone scripts. \n\
            	 \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F924\"></a>As this is a Python based API, knowledge of Python is required. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F925\"></a> \n\
            <h2><a name=\"GUID-E922B9CD-4758-4B8E-B579-51126FDAC593\"></a>Importing modules\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F926\"></a>The Maya Python API is contained in a number of Python modules. You must import the\n\
               functionality that you wish to use in your script. Additionally, the Maya Python API\n\
               lives in the Maya namespace; therefore, an extra prefix is required. To import the\n\
               OpenMaya module, run the following: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F927\"></a> \n\
            <h2><a name=\"GUID-0D7A6EC0-E15D-4EA4-B25C-7D8728E9CC05\"></a>Help on a module or class\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F928\"></a>Information can be displayed about any of the modules or classes using the \n\
               		  <span class=\"code\" translate=\"no\">help</span> command. For example, if you wish to display the class information for \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a></span>, use: \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F929\"></a> <span class=\"code\" translate=\"no\">help(maya.OpenMaya.MVector)</span> \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92A\"></a>It is also possible to display the information of an entire module: \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92B\"></a> <span class=\"code\" translate=\"no\">help(maya.OpenMaya)</span> \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92C\"></a>This operation will take a while to return since the OpenMaya module is very large.\n\
               \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92D\"></a> \n\
            <h2><a name=\"GUID-3512B293-1A51-4E67-BFEC-96227FCD9F1C\"></a>Writing scripts\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92E\"></a>The Maya Python API modules contain the classes that are available for Python programming.\n\
               These classes are separated into different categories and have appropriate naming\n\
               conventions to signify their association. Classes include: \n\
               		\n\
            </p> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F92F\"></a> \n\
               <h3><a name=\"GUID-B1317219-6889-4282-9A80-8C420922FD7E\"></a>MFn\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F930\"></a>Any class with this prefix is a function set used to operate on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>s of a particular type. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F931\"></a> \n\
               <h3><a name=\"GUID-C39194F8-49C1-40B2-B436-0FDB3A44BF08\"></a>MIt\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F932\"></a> These classes are iterators and work on \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>s similar to the way a function set does. For example, \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItCurveCV\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_curve_c_v.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItCurveCV</a></span> is used to operate on an individual NURBS curve CV (there is no \n\
                  			 <span class=\"code\" translate=\"no\">MFnNurbsCurveCV</span>), or, iteratively, on all the CVs of a curve. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F934\"></a> \n\
               <h3><a name=\"GUID-7CD20500-63E7-4AAB-A43B-796067B8B6FC\"></a>MPx\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F935\"></a> Classes with this prefix are all \"Proxies\", that is, API classes designed for you\n\
                  to derive from and create your own object types. \n\
                  		  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F937\"></a> \n\
               <h3><a name=\"GUID-ED69A6C7-92AC-4C2D-9662-9DEE384D18A5\"></a>M classes\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F938\"></a> Most, although not all, of these classes are \"Wrappers\". Examples of this class are:\n\
                  \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a></span>, \n\
                  			 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIntArray</a></span>, and so forth. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F93A\"></a>We can use wrapper and function set classes to write scripts such as the following:\n\
                  \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya\n\
vector1 = maya.OpenMaya.MVector(0,1,0)\n\
vector2 = maya.OpenMaya.MVector(1,0,0)\n\
vector3 = maya.OpenMaya.MVector(0,0,2)\n\
newVector = vector1 + vector2 + vector3\n\
print \"newVector %f, %f, %f \" % (newVector.x, newVector.y, newVector.z)\n\
</pre></div> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F93B\"></a>It is possible to shorten the symbol names used by modifying the import command: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya\n\
vector1 = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>(0,1,0)\n\
</pre></div> \n\
               <p><a name=\"WS17956D7ADBC6E7362E08295F117AE33293A-7FFF\"></a>Scripts can access dependency graph information using the Maya Python API classes.\n\
                  The following is a script that finds the persp node and prints out its \n\
                  			 <span class=\"code\" translate=\"no\">translateX</span> attribute value: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
# import the OpenMaya module\n\
import maya.OpenMaya as OpenMaya\n\
\n\
# function that returns a node object given a name\n\
def nameToNode( name ):\n\
    selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
    selectionList.add( name )\n\
    node = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    selectionList.getDependNode( 0, node )\n\
    return node\n\
\n\
# function that finds a plug given a node object and plug name\n\
def nameToNodePlug( attrName, nodeObject ):\n\
    depNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDependencyNode</a>( nodeObject )\n\
    attrObject = depNodeFn.attribute( attrName )\n\
    plug = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPlug</a>( nodeObject, attrObject )\n\
    return plug\n\
\n\
# Find the persp camera node\n\
print \"Find the persp camera\"\n\
perspNode = nameToNode( \"persp\" )\n\
print \"APItype %d\" % perspNode.apiType()\n\
print \"APItype string %s\" % perspNode.apiTypeStr()\n\
\n\
# Print the translateX value\n\
translatePlug = nameToNodePlug( \"translateX\", perspNode )\n\
print \"Plug name: %s\" % translatePlug.name()\n\
print \"Plug value %g\" % translatePlug.asDouble())\n\
</pre></div> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F93C\"></a>The example above demonstrates the following: \n\
                  		  \n\
               </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F93D\"></a><ul>\n\
                  <li>To instantiate a class, use the \n\
                     				<span class=\"code\" translate=\"no\">fn = OpenMaya.MFnFunctionSet()</span> notation. \n\
                     			 \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span>s can be created using \n\
                     				<span class=\"code\" translate=\"no\">node = OpenMaya.MObject()</span>. \n\
                     			 \n\
                  </li>\n\
                  <li>Although Python is a typeless language, you must instantiate the correct type in order\n\
                     to pass it as a parameter of the class. \n\
                     			 \n\
                  </li>\n\
                  <li>Python strings are passed and returned in place of the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MString</a></span> wrapper class. \n\
                     				\n\
                     <div><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F942\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                           <p><a name=\"GUID-9910DB1B-0EFB-4803-BFD4-E73AD63A976A\"></a>For the sake of clarity, the example above has omitted error checking. \n\
                              				  \n\
                           </p> \n\
                        </div>\n\
                     </div> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F943\"></a> \n\
            <h2><a name=\"GUID-9D832556-03D7-4DB2-8634-06FC4B3CE317\"></a>Scripted plug-ins\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F944\"></a>Scripted plug-ins allow a developer to create a solution that is tightly coupled with\n\
               Maya. Scripted plug-ins allow a developer to support functionality such as the undoing\n\
               of commands and the building of appropriate requires lines into the Maya scene file.\n\
               Another advantage of using a scripted plug-in is that its functionality is available\n\
               in both MEL and Python. \n\
               		\n\
            </p> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F945\"></a> \n\
               <h3><a name=\"GUID-15FB3A62-2276-4C22-B7EA-CE60B65A6CB2\"></a>Using a scripted plug-in\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F946\"></a>We have extended the Maya \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-15C051B5-5036-4229-99EC-241D70138757\">Plug-in Manager</span> to support the loading and unloading of scripted plug-ins. \n\
                  		  \n\
               </p> <a name=\"WS1A9193826455F5FF3CBC1E051237AC78BEC-7D61\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-AA4D9EA5-3047-4D76-A95E-AB294E3B11AE-low.png\"></div> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F948\"></a>Any file ending with a \n\
                  			 <span class=\"code\" translate=\"no\">.py</span> extension that is on the \n\
                  			 <span class=\"code\" translate=\"no\">MAYA_PLUG_IN_PATH</span> is displayed in the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-D2E355B0-9809-4CDD-B540-4A892EF0F5A3\">Plug-in Manager</span>. Select the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-80E6A21C-10CB-4E96-832A-1CB21AAC3A44\">Loaded</span> check-box or the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-F63C57C0-F749-4D4A-8F37-365A2BB0FA19\">Auto load</span> check box to either load or auto-load the scripted plug-in. \n\
                  		  \n\
               </p> \n\
               <div><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F949\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                     <p><a name=\"GUID-E673C156-EB18-42FC-B8DE-6A29E3FB5960\"></a>Although, it is possible to have a non scripted plug-in \n\
                        				<span class=\"code\" translate=\"no\">.py</span> script on the \n\
                        				<span class=\"code\" translate=\"no\">MAYA_PLUG_IN_PATH</span>, these items will not load. Warnings will be issued that entry points cannot be found.\n\
                        \n\
                        			 \n\
                     </p> \n\
                  </div>\n\
               </div> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F94A\"></a>The plug-in can either be loaded from the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-E2CEBA0C-06F2-4758-9271-6A20B11774EB\">Plug-in Manager</span> or from the MEL or Python command tabs. In MEL, use the \n\
                  			 <span class=\"code\" translate=\"no\">loadPlugin()</span> command. In Python, use the \n\
                  			 <span class=\"code\" translate=\"no\">maya.cmds.loadPlugin() \n\
                     			 </span>command \n\
                  		  \n\
               </p> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F94B\"></a>To run an example such as \n\
                  			 <span class=\"code\" translate=\"no\">helixCmd.py</span>, load the plug-in and enter the following in the \n\
                  			 <span class=\"MenuCascade\" id=\"GUID-EEABD78B-2A47-45BF-ADE7-42BB4F5516D3\">Python Editor</span> tab: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya\n\
maya.cmds.spHelix().\n\
</pre></div> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F94C\"></a>Invoking this Python script does the following: \n\
                  		  \n\
               </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F94D\"></a><ul>\n\
                  <li>Import the Maya module so that the \n\
                     				<span class=\"code\" translate=\"no\">cmds</span> module becomes available \n\
                     			 \n\
                  </li>\n\
                  <li>Invoke the custom command \n\
                     				<span class=\"code\" translate=\"no\">spHelix()</span> \n\
                     <div><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F950\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F951\"></a><ul>\n\
                              <li>The \n\
                                 						<span class=\"code\" translate=\"no\">sp</span> prefix is used for \"scripted plug-in\". \n\
                                 					 \n\
                              </li>\n\
                              <li>Scripted plug-ins must be loaded using the loadPlugin command. It cannot be loaded\n\
                                 by running the source of a scripted plug-in. \n\
                                 					 \n\
                              </li>\n\
                           </ul> \n\
                        </div>\n\
                     </div> \n\
                  </li>\n\
               </ul> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F954\"></a>This plug-in can also be unloaded using the Python command: \n\
                  			 <span class=\"code\" translate=\"no\">maya.cmds.unloadPlugin(\"helixCmd.py\")</span> \n\
               </p> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F955\"></a>The load and execute steps can also be invoked in the MEL editor using: \n\
                  		  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
loadPlugin helixCmd.py;\n\
spHelix();\n\
</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F956\"></a> \n\
               <h3><a name=\"GUID-0EF9F496-2DE2-4430-A006-833200CBCC40\"></a>Writing a scripted plug-in\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F957\"></a>Writing a scripted plug-in requires the definition of some specialized functions within\n\
                  the plug-in. The scripted plug-in must: \n\
                  		  \n\
               </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F958\"></a><ul>\n\
                  <li>Define \n\
                     				<span class=\"code\" translate=\"no\">initializePlugin</span> and \n\
                     				<span class=\"code\" translate=\"no\">uninitializePlugin</span> entry points. \n\
                     			 \n\
                  </li>\n\
                  <li>Register and unregister the proxy class within these entry points. \n\
                     			 \n\
                  </li>\n\
                  <li>Implement creator and initialize methods (as required) which Maya calls to build the\n\
                     proxy class. \n\
                     			 \n\
                  </li>\n\
                  <li>Implement the required functionality of the proxy class. This requires importing the\n\
                     necessary modules. \n\
                     			 \n\
                  </li>\n\
               </ul> \n\
               <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F95D\"></a>The following sections describe these pieces in more detail with examples. \n\
                  		  \n\
               </p> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F95E\"></a> \n\
                  <h4><a name=\"GUID-20869227-DA3D-41FF-A2F7-29C840CCFE35\"></a>Importing\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F95F\"></a>Python uses the import keyword to include functionality from a module into a script.\n\
                     For example: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import sys\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F960\"></a>It is possible for a scripted plug-in to be split among several files. The import\n\
                     command is used to load the functionality of the secondary file into the scripted\n\
                     plug-in. \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import polyModifier\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F961\"></a>Any secondary scripts must be located in the same directory as the scripted plug-in.\n\
                     \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F962\"></a> \n\
                  <h4><a name=\"GUID-F919D219-B2FE-4363-8A27-B5454E1ABCE6\"></a>Scripted plug-in initialization\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F963\"></a>When a scripted plug-in is loaded, Maya searches for an \n\
                     				<span class=\"code\" translate=\"no\">initializePlugin()</span> function in its definition. Within this function, all proxy nodes are registered:\n\
                     \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
# Initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
        raise\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F964\"></a>If the \n\
                     				<span class=\"code\" translate=\"no\">initializePlugin() \n\
                        				</span>function is not found, the scripted plug-in fails to load. In addition, during the\n\
                     load, Maya searches for an \n\
                     				<span class=\"code\" translate=\"no\">uninitializePlugin()</span> function. If this is not found, then the scripted plug-in fails to load. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F965\"></a> \n\
                  <h4><a name=\"GUID-20DF44C0-246B-4B7D-8AB8-AC5EF0A7DB06\"></a>Scripted plug-in uninitialization\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F966\"></a>When Maya is attempting to unload the plug-in, the previously found \n\
                     				<span class=\"code\" translate=\"no\">uninitializePlugin()</span> function is called to unload the resources of the plug-in. \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
        raise\n\
</pre></div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F967\"></a> \n\
                  <h4><a name=\"GUID-3B27BB5E-1C34-434C-B135-B0EF22E46623\"></a>Creator functions\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F968\"></a>Creator functions are used to return a derived version of a proxy class to Maya. Virtual\n\
                     methods are implemented on the derived class which are called from Maya. An example\n\
                     of a class definition and a creator function is: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    # ...\n\
def cmdCreator():\n\
    return OpenMayaMPx.asMPxPtr( scriptedCommand() )\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F969\"></a>It is very important to call the \n\
                     				<span class=\"code\" translate=\"no\">OpenMayaMPx.asMPxPtr()</span> on the newly created proxy object. This call transfers ownership of the object from\n\
                     Python to Maya. Program errors will occur if you do not make this call since Python\n\
                     can unreference this object and destroy it. This will leave a dangling pointer in\n\
                     Maya. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96A\"></a> \n\
                  <h4><a name=\"GUID-DB8E597D-B52F-4B6B-8AA8-2890CF104DC2\"></a>Class implementation\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96B\"></a>Implementing a proxy class requires deriving from the Maya Python API object. \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    def __init__(self):\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    def doIt(self,argList):\n\
        print \"Hello World!\"\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96C\"></a>The \n\
                     				<span class=\"code\" translate=\"no\">scriptedCommand</span> class is derived from \n\
                     				<span class=\"code\" translate=\"no\">OpenMayaMPx.MPxCommand</span>. The constructor or \n\
                     				<span class=\"code\" translate=\"no\">__init__</span> method must call the parent class \n\
                     				<span class=\"code\" translate=\"no\">__init__</span> method. All class methods require \n\
                     				<span class=\"code\" translate=\"no\">self</span> as the first parameter, followed by the normal argument list. This command’s \n\
                     				<span class=\"code\" translate=\"no\">doIt()</span> method simply prints out \"Hello World!\". \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96D\"></a> \n\
                  <h4><a name=\"GUID-A29D6422-2031-4E88-B604-1879BA69706A\"></a>Initialization Functions\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96E\"></a>Initialization functions are used within scripted plug-ins that define new proxy nodes\n\
                     using the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> class. The following is an example that demonstrates how to create a simple scripted\n\
                     plug-in node, the output of which is the sine function. \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import math, sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
kPluginNodeTypeName = \"spSineNode\"\n\
sineNodeId = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MTypeId</a>(0x8700)\n\
\n\
# Node definition\n\
class sineNode(OpenMayaMPx.MPxNode):\n\
    # class variables\n\
    input = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    output = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
    \n\
    def __init__(self):\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self,plug,dataBlock):\n\
        if ( plug == sineNode.output ):\n\
            dataHandle = dataBlock.inputValue( sineNode.input )\n\
            \n\
            inputFloat = dataHandle.asFloat()\n\
            result = math.sin( inputFloat ) * 10.0\n\
            outputHandle = dataBlock.outputValue( sineNode.output )\n\
            outputHandle.setFloat( result )\n\
            dataBlock.setClean( plug )\n\
# creator\n\
def nodeCreator():\n\
    return OpenMayaMPx.asMPxPtr( sineNode() )\n\
    \n\
# initializer\n\
def nodeInitializer():\n\
    # input\n\
    nAttr = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    sineNode.input = nAttr.create( \"input\", \"in\", <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, 0.0 )\n\
    nAttr.setStorable(1)\n\
    # output\n\
    nAttr = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericAttribute</a>()\n\
    sineNode.output = nAttr.create( \"output\", \"out\", <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNumericData.kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNumericData.kFloat</a>, 0.0 )\n\
    nAttr.setStorable(1)\n\
    nAttr.setWritable(1)\n\
    # add attributes\n\
    sineNode.addAttribute( sineNode.input )\n\
    sineNode.addAttribute( sineNode.output )\n\
    sineNode.attributeAffects( sineNode.input, sineNode.output )\n\
    \n\
# initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.registerNode( kPluginNodeTypeName, sineNodeId, nodeCreator, nodeInitializer )\n\
    except:\n\
        sys.stderr.write( \"Failed to register node: %s\" % kPluginNodeTypeName )\n\
        raise\n\
        \n\
# uninitialize the script plug-in\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterNode( sineNodeId )\n\
    except:\n\
        sys.stderr.write( \"Failed to register node: %s\" % kPluginNodeTypeName )\n\
        raise\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F96F\"></a>The \n\
                     				<span class=\"code\" translate=\"no\">nodeInitializer()</span> function is passed to \n\
                     				<span class=\"code\" translate=\"no\">registerNode()</span> in the \n\
                     				<span class=\"code\" translate=\"no\">initializePlugin()</span> function. As the plug-in loads, Maya calls the \n\
                     				<span class=\"code\" translate=\"no\">nodeInitializer()</span> function to create the attributes of the node. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F970\"></a> \n\
                  <h4><a name=\"GUID-2D077661-B919-4D54-8121-CD991042D0BB\"></a>Error Conditions\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F971\"></a>The Maya Python API uses Python exceptions for querying and setting error states in\n\
                     script. In most cases, exceptions are used even though the class documentation indicates\n\
                     that a method has a return value. There are many situations where an exception can\n\
                     occur: \n\
                     			 \n\
                  </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F972\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>A call fails and the failure state needs to be preserved: \n\
                        				  \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterNode( sineNodeId )\n\
    except:\n\
        sys.stderr.write( \"Failed to deregister node: %s\" % kPluginNodeTypeName )\n\
        raise\n\
</pre></div> \n\
                        <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F974\"></a>In this example, if the \n\
                           					 <span class=\"code\" translate=\"no\">deregisterNode()</span> call failed, the \n\
                           					 <span class=\"code\" translate=\"no\">uninitializePlugin()</span> call passes the exception back to Maya and the plug-in fails to unload. \n\
                           				  \n\
                        </p> \n\
                     </li>\n\
                     <li>A call fails and the failure state needs to be cleared: \n\
                        				  \n\
                        <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F977\"></a>This code can be modified to catch the error and still allow the plug-in to unload\n\
                           if the \n\
                           					 <span class=\"code\" translate=\"no\">deregisterNode()</span> call fails: \n\
                           				  \n\
                        </p> \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterNode( sineNodeId )\n\
    except:\n\
        sys.stderr.write( \"Failed to deregister node: %s\" % kPluginNodeTypeName )\n\
        pass\n\
</pre></div> \n\
                        <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F978\"></a>The only change being that the \n\
                           					 <span class=\"code\" translate=\"no\">raise</span> keyword has been changed to \n\
                           					 <span class=\"code\" translate=\"no\">pass</span>. This technique is useful for writing iterator code that may fail if incorrect objects\n\
                           are being examined. \n\
                           				  \n\
                        </p> \n\
                        <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F979\"></a>3. Unknown parameter return value \n\
                           				  \n\
                        </p> \n\
                        <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97A\"></a>In the Maya Python API, an unknown parameter return value is used to indicate that\n\
                           a method cannot handle a specific case and it is up to the caller to take care of\n\
                           the operation. One such method is \n\
                           					 <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::compute()</a></span>. In this situation, the Python code would return \n\
                           					 <span class=\"code\" translate=\"no\">OpenMaya.kUnknownParameter.</span> \n\
                        </p> \n\
                     </li>\n\
                  </ol> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0F\"></a> \n\
                  <h4><a name=\"GUID-4CC8FD4A-E0EB-4393-B6E0-8713411BB84A\"></a>Exceptions versus MStatus\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0E\"></a>As noted in the previous section, the Maya Python API uses exceptions to communicate\n\
                     status information rather than MStatus values. When trying to divine the Pythonic\n\
                     behavior of an API method from its C++ documentation, the rules below hold. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0D\"></a>There are two ways in which C++ API methods can return MStatus values, either as the\n\
                     method\'s return value: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a> someMethod(Type arg1, Type arg2, ...) \n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0C\"></a>or through an optional pointer to an MStatus variable in its parameter list, usually\n\
                     as the final parameter: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
Type someMethod(Type arg1, Type arg2, ..., <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a>* ReturnStatus = NULL) \n\
</pre></div> \n\
                  <div class=\"section\"><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0B\"></a> \n\
                     <h5><a name=\"GUID-C068E6A7-2F51-4ABD-B1A7-F2478FD07460\"></a>Method returns MStatus as its function value\n\
                     </h5> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F0A\"></a>When the method returns an \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> as its function value, that return value is handled in Python as follows: \n\
                        				\n\
                     </p> <a name=\"WS73099CC142F48755-BF06786125831C4316-7F09\"></a><ul>\n\
                        <li>if the status is \n\
                           					 <span class=\"code\" translate=\"no\">MS::kUnknownParameter</span>, then the string \n\
                           					 <span class=\"code\" translate=\"no\">unknown</span> is returned to Python; \n\
                           				  \n\
                        </li>\n\
                        <li>if the status is \n\
                           					 <span class=\"code\" translate=\"no\">MS::kSuccess</span>, then nothing is returned and no exception is raised; \n\
                           				  \n\
                        </li>\n\
                        <li>if the status is anything else, then nothing is returned but a \n\
                           					 <span class=\"code\" translate=\"no\">RuntimeError</span> exception is raised. \n\
                           				  \n\
                        </li>\n\
                     </ul> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F05\"></a>The reason for the special handling of \n\
                        				  <span class=\"code\" translate=\"no\">MS::kUnknownParameter</span> is to accomodate \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode::compute()</a></span>. \n\
                        				\n\
                     </p> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F04\"></a>There are no special API-specific exceptions. Maya simply uses Python\'s standard \n\
                        				  <span class=\"code\" translate=\"no\">RuntimeError</span> and passes the error string as its argument. \n\
                        				\n\
                     </p> \n\
                  </div> \n\
                  <div class=\"section\"><a name=\"WS73099CC142F48755-BF06786125831C4316-7F03\"></a> \n\
                     <h5><a name=\"GUID-7ADAAB23-FA4C-4DAF-9290-73B32CFD17B2\"></a>Method returns MStatus through a pointer variable\n\
                     </h5> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7F02\"></a>When an API method returns an \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> through a pointer variable in its parameter list, then that \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> is handled as follows: \n\
                        				\n\
                     </p> <a name=\"WS73099CC142F48755-BF06786125831C4316-7F01\"></a><ul>\n\
                        <li>if the status is \n\
                           					 <span class=\"code\" translate=\"no\">MS::kSuccess</span>, then no exception is raised; \n\
                           				  \n\
                        </li>\n\
                        <li>if the status is anything else, then nothing is returned but a \n\
                           					 <span class=\"code\" translate=\"no\">RuntimeError</span> exception is raised. \n\
                           				  \n\
                        </li>\n\
                     </ul> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7EFE\"></a>This means that users writing plug-ins in C++ can continue to return \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> codes as they normally would, regardless of whether their code is called from C++\n\
                        or Python. Maya will internally convert those codes to Python exceptions if necessary.\n\
                        \n\
                        				\n\
                     </p> \n\
                     <p><a name=\"WS73099CC142F48755-BF06786125831C4316-7EFD\"></a>Users writing plug-ins in Python should raise exceptions rather than return \n\
                        				  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> values, unless they want their \n\
                        				  <span class=\"code\" translate=\"no\">compute()</span> method to indicate that it is not going to handle a plug. In this case, it should\n\
                        return \n\
                        				  <span class=\"code\" translate=\"no\">maya.OpenMaya.kUnknownParameter</span>. \n\
                        				\n\
                     </p> \n\
                  </div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97B\"></a> \n\
                  <h4><a name=\"GUID-5DCCAB1C-F491-41CF-B69D-4FC8245DCB31\"></a>Classes support slicing\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97C\"></a> \n\
                     				All of the number arrays (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MIntArray</a></span>, \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUintArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uint_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_uint_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MUintArray</a></span>, \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MUint64Array\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uint64_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_uint64_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MUint64Array</a></span>, \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatArray</a></span>, and \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_double_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDoubleArray</a></span>) support Python-style slicing. For example: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya \n\
array = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MUintArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_uint_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MUintArray</a>() \n\
for i in range(0,9):\n\
   array.append( i )\n\
array[2:8:2]\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97D\"></a> <span class=\"code\" translate=\"no\"># Result:[2, 4, 6] # \n\
                        				</span> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97E\"></a> \n\
                  <h4><a name=\"GUID-61B65C25-D882-4EE4-B3A2-398474DFFF85\"></a>Accessing static MObjects of an MPx class\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F97F\"></a>The proxy classes provide some standard information to a developer about the node\n\
                     that is being used. This includes attribute objects that are used to define the node.\n\
                     To access a static class \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> in the Maya Python API, similar code can be used: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
envelope = OpenMayaMPx.cvar.MPxDeformerNode_envelope\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F980\"></a>After making this call, the envelope will be an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a></span> for \n\
                     				<span class=\"code\" translate=\"no\">MPxDeformerNode::envelope</span>. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F981\"></a> \n\
                  <h4><a name=\"GUID-D3702161-7572-484A-B5CF-44497A5F5626\"></a>Messages\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F982\"></a>Message classes are supported in the Maya Python API. A Python function is passed\n\
                     for the callback. This function must have the exact number of parameters required\n\
                     by the callback message. If it does not, an exception will occur when the message\n\
                     is invoked and information will be written to the console. Client data in the form\n\
                     of a python object can also be passed with most messages. The following is an example\n\
                     of a message: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
# Message callback\n\
def dagParentAddedCallback( child, parent, clientData ):\n\
    print \"dagParentAddedCallback...\"\n\
    print \"\\tchild %s\" % child.fullPathName()\n\
    print \"\\tparent %s\" % parent.fullPathName()\n\
    print \"\\tclient data %s\" % clientData\n\
\n\
# Create the mesage\n\
def createParentAddedCallback(stringData):\n\
    try:\n\
        id = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagMessage.addParentAddedCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_message.html#a56df287a6a45e5ae6b49689724a88556&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagMessage.addParentAddedCallback</a>( dagParentAddedCallback, stringData )\n\
    except:\n\
        sys.stderr.write( \"Failed to install dag parent added callback\\n\" )\n\
        messageIdSet = False\n\
    else:\n\
        messageIdSet = True\n\
    return id\n\
# Call the message creator\n\
messageId = createParentAddedCallback( \"_noData_\" )\n\
</pre></div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F983\"></a> \n\
                  <h4><a name=\"GUID-40D05D6A-F088-4DCC-85BA-18F5BDBE452A\"></a>Modify Parameter Values Instead of Using an Assignment\n\
                  </h4> \n\
                  <p><a name=\"WS1A9193826455F5FF-1034D8ED126D167ED83-6E0C\"></a>In Python, it is best to modify a parameter rather than use an assignment. The code\n\
                     below contains an assignment and demonstrates how an error can occur: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya \n\
def vectorTest(v): \n\
    lv = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>(1,5,9) \n\
    v = lv \n\
    print \"%g %g %g\" % (v.x,v.y,v.z) \n\
v = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>() \n\
vectorTest(v) \n\
print \"%g %g %g\" % (v.x,v.y,v.z)\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F984\"></a>The second print command will emit all zeroes. In Python, either modify the parameter\n\
                     value or write the code so that a new value is returned. Rewrite the \n\
                     				<span class=\"code\" translate=\"no\">vectorTest()</span> function as follows: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def vectorTest(v): \n\
    lv = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>(1,5,9) \n\
    v.x = lv.x\n\
    v.y = lv.y\n\
    v.z = lv.z\n\
    print \"%g %g %g\" % (v.x,v.y,v.z) \n\
</pre></div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F985\"></a> \n\
                  <h4><a name=\"GUID-A535AE6C-08FF-4AC4-B454-9B7DE9002FF0\"></a>References to Basic Types\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F986\"></a>The Maya Python API contains many calls in which return values or parameters are references\n\
                     to basic types such as: int&amp;, char&amp;, float&amp; etc. In the Maya Python API, all references\n\
                     are treated as pointers. As a result, special calls are required to create, set and\n\
                     access the values of these items. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F987\"></a>A utility class called \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MScriptUtil</a></span> that exists in the OpenMaya.py module provides methods for working with these type\n\
                     of parameters and return values. This class allows for creating data and then acquiring\n\
                     a pointer to the data so that information can be passed to class methods requiring\n\
                     references. See \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MScriptUtil</a></span> in the API Reference documentation. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-79C2\"></a> The following example should help to clarify the usage of \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MScriptUtil</a></span>. It shows how to get the x, y and z values from a call to \n\
                     				<span class=\"code\" translate=\"no\">MFnLattice.getDivisions()</span>: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaAnim as Anim\n\
xutil = OpenMaya.MScriptUtil()\n\
xutil.createFromInt(0)\n\
xptr = xutil.asUintPtr()\n\
yutil = OpenMaya.MScriptUtil()\n\
yutil.createFromInt(0)\n\
yptr = yutil.asUintPtr()\n\
zutil = OpenMaya.MScriptUtil()\n\
zutil.createFromInt(0)\n\
zptr = zutil.asUintPtr()\n\
it = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDependencyNodes\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dependency_nodes.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDependencyNodes</a>(OpenMaya.MFn.kFFD)\n\
while not it.isDone():\n\
    latDefFn = Anim.MFnLatticeDeformer( it.thisNode() )\n\
 &nbsp;&nbsp;&nbsp;latFn = Anim.MFnLattice( latDefFn.deformLattice() )\n\
 &nbsp;&nbsp;&nbsp;latFn.getDivisions(xptr, yptr, zptr)\n\
 &nbsp;&nbsp;&nbsp;x = xutil.getUint(xptr)\n\
 &nbsp;&nbsp;&nbsp;y = yutil.getUint(yptr)\n\
 &nbsp;&nbsp;&nbsp;z = zutil.getUint(zptr)\n\
 &nbsp;&nbsp;&nbsp;doSomethingUseful(x, y, z)\n\
 &nbsp;&nbsp;&nbsp;it.next()\n\
</pre></div> \n\
                  <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-79C1\"></a>Since \n\
                     				<span class=\"code\" translate=\"no\">getUint()</span> is a static method of \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MScriptUtil</a></span>, an alternative way of retrieving the final values is to call it directly from the\n\
                     class. For example: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
x = OpenMaya.MScriptUtil.getUint(xptr)\n\
</pre></div> \n\
                  <p><a name=\"GUID-B645ACC5-6A68-4D81-8752-B63A25AAA088\"></a> References to enumerated types should be treated as references to short ints. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F988\"></a> \n\
                  <h4><a name=\"GUID-70AF140E-75AD-4D3A-A8E5-F16C83318A2F\"></a>Commands with Flags\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F989\"></a> A command which has flags must specify its syntax using an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSyntax</a></span> object and parse the flags using the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgParser</a></span> or \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgDatabase</a></span> classes, otherwise the flags will not be accessible when the command is used from\n\
                     within Python. This is true regardless of whether the command is written in Python\n\
                     or C++. Below is an example of a scripted plug-in which implements a command with\n\
                     flags: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import sys, math\n\
kPluginCmdName=\"spHelix\"\n\
kPitchFlag = \"-p\"\n\
kPitchLongFlag = \"-pitch\"\n\
kRadiusFlag = \"-r\"\n\
kRadiusLongFlag = \"-radius\"\n\
\n\
# command\n\
class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    def __init__(self):\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        deg = 3\n\
        ncvs = 20\n\
        spans = ncvs - deg\n\
        nknots = spans+2*deg-1\n\
        radius = 4.0\n\
        pitch = 0.5\n\
        \n\
        # Parse the arguments.\n\
        argData = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MArgDatabase</a>(self.syntax(), args)\n\
        if argData.isFlagSet(kPitchFlag):\n\
            pitch = argData.flagArgumentDouble(kPitchFlag, 0)\n\
        if argData.isFlagSet(kRadiusFlag):\n\
            radius = argData.flagArgumentDouble(kRadiusFlag, 0)\n\
        controlVertices = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPointArray</a>()\n\
        knotSequences = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_double_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDoubleArray</a>()\n\
        \n\
        # Set up cvs and knots for the helix\n\
        for i in range(0, ncvs):\n\
            controlVertices.append( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>( radius * math.cos(i),\n\
                pitch * i, radius * math.sin(i) ) )\n\
        for i in range(0, nknots):\n\
            knotSequences.append( i )\n\
        \n\
        # Now create the curve\n\
        curveFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnNurbsCurve</a>()\n\
        \n\
        nullObj = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MObject</a>()\n\
        try:\n\
            # This plugin normally creates the curve by passing in the\n\
            # cv\'s. A function to create curves by passing in the ep\'s\n\
            # has been added. Set this to False to get that behaviour.\n\
            if True:\n\
                curveFn.create( controlVertices, knotSequences, deg, OpenMaya.MFnNurbsCurve.kOpen, 0, 0, nullObj )\n\
            else:\n\
                curveFn.createWithEditPoints(controlVertices, 3, OpenMaya.MFnNurbsCurve.kOpen, False, False, False)\n\
        except:\n\
            sys.stderr.write( \"Error creating curve.\\n\" )\n\
            raise\n\
# Creator\n\
def cmdCreator():\n\
    # Create the command\n\
    return OpenMayaMPx.asMPxPtr( scriptedCommand() )\n\
\n\
# Syntax creator\n\
def syntaxCreator():\n\
    syntax = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax</a>()\n\
    syntax.addFlag(kPitchFlag, kPitchLongFlag, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>)\n\
    syntax.addFlag(kRadiusFlag, kRadiusLongFlag, <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSyntax.kDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html#a9b557d97e6ea6e2e7a3757b810a4c627&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSyntax.kDouble</a>)\n\
    return syntax\n\
\n\
# Initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject, \"Autodesk\", \"1.0\", \"Any\")\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
        raise\n\
        \n\
# Uninitialize the script plug-in\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
        raise\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F98A\"></a>This example includes the syntax creator function along with parsing operations in\n\
                     the \n\
                     				<span class=\"code\" translate=\"no\">doIt()</span> method of the class. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F98B\"></a> \n\
                  <h4><a name=\"GUID-16527D0D-BE32-4E3C-A4C9-A2F615EE5DF5\"></a>Protected methods\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F98C\"></a>The Maya Python API contains several methods that should only be called from the class\n\
                     the method belongs to. We follow the Python designation of using an _ as the first\n\
                     letter of the method name to indicate that protection applies to this method. Several\n\
                     examples of these methods exist in the \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> class: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
_forceCache()\n\
_setMPSafe()\n\
</pre></div> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F98D\"></a>Please respect the method usage requirements of protected methods in the Maya Python\n\
                     API. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F98E\"></a> \n\
                  <h4><a name=\"GUID-AD624988-AF32-4FB9-87E9-E97791BA28CF\"></a>Getting derived object from MPx base object\n\
                  </h4> \n\
                  <p><a name=\"GUID-B3454D14-C96E-474C-A397-9D8C30C4EFC0\"></a>Some API methods return your custom objects as instances of their base \n\
                     				<span class=\"code\" translate=\"no\">MPx</span> class rather than instances of your derived class. For example, \n\
                     				<span class=\"code\" translate=\"no\">MPxContext._newToolCommand()</span> returns your custom tool command as an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxToolCommand</a></span> object and \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI.surfaceShape()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_surface_shape_u_i.html#a6a21cf4eb530aa3fd49f95b667400c4c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShapeUI.surfaceShape()</a></span> returns your custom surface shape as an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span> object. While these base instances refer to the same internal Maya objects as the\n\
                     original derived instances, they are separate Python objects which do not retain any\n\
                     of the member variable values set in the derived instances, so calling methods or\n\
                     accessing member variables on the returned objects may give incorrect results. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-B2E4B67C-99A5-43BC-9147-44BD667A450D\"></a>You can work around this problem by taking advantage of the properties of the \n\
                     				<span class=\"code\" translate=\"no\">OpenMayaMPx.asHashable()</span> function. \n\
                     				<span class=\"code\" translate=\"no\">OpenMayaMPx.asHashable()</span> takes an \n\
                     				<span class=\"code\" translate=\"no\">MPx</span> object and returns a hash value which uniquely identifies the underlying Maya object.\n\
                     It doesn\'t matter whether the object is an instance of the base \n\
                     				<span class=\"code\" translate=\"no\">MPx</span> class or your derived class: so long as they both refer to the same underlying Maya\n\
                     object they will return the same hash value. This allows you to set up a dictionary\n\
                     which can translate a base instance into its corresponding derived instance. \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"GUID-90531321-D92A-49D5-A830-093580FC5CB2\"></a>The first step is to add an empty dictionary to the class: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class MoveToolCmd(OpenMayaMPx.MPxToolCommand):\n\
    kTrackingDictionary = {}\n\
</pre></div> \n\
                  <p><a name=\"GUID-6E0D2C03-EE90-43E8-B436-CCC25C24482D\"></a>In the class\'s \n\
                     				<span class=\"code\" translate=\"no\">__init__</span> method, add an entry to the dictionary, mapping the new object\'s hash value to the\n\
                     object itself: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def __init__(self): \n\
    OpenMayaMPx.MPxToolCommand.__init__(self)\n\
    MoveToolCmd.kTrackingDictionary[OpenMayaMPx.asHashable(self)] = self \n\
\n\
</pre></div> \n\
                  <p><a name=\"GUID-5ACB3D71-67D9-4493-B64F-190590A3F3F1\"></a>In the class\'s \n\
                     				<span class=\"code\" translate=\"no\">__del__ \n\
                        				</span>method, remove the deleted object from the dictionary: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
def __del__(self): \n\
    del MoveToolCmd.kTrackingDictionary[OpenMayaMPx.asHashable(self)] \n\
\n\
</pre></div> \n\
                  <p><a name=\"GUID-8E44EA8C-BB29-4248-B60A-83B8883A897A\"></a>Now that you have the tracking dictionary, you can use it to retrieve the derived\n\
                     object from its corresponding base object: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
class MoveContext(OpenMayaMPx.MPxSelectionContext): \n\
    ... \n\
    \n\
    def doPress(self, event): \n\
\n\
        # Create an instance of the move tool command. \n\
        baseCmd = self._newToolCommand() \n\
        derivedCmd = MoveToolCmd.kTrackingDictionary.get( \n\
                        OpenMayaMPx.asHashable(baseCmd), None \n\
                     ) \n\
\n\
        # Call its methods.\n\
        derivedCmd.setVector(0.0, 0.0, 0.0) \n\
\n\
</pre></div> \n\
                  <p><a name=\"GUID-7788F938-E372-41B1-917E-21E45F392F56\"></a>When defining custom node types (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span>, \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxSurfaceShape</a></span>, etc) some additional effort is required. When Maya does a file open or new file\n\
                     operation it destroys the scene without executing the __del__ method for each node.\n\
                     That means that the entries for those nodes are never removed from the tracking dictionary.\n\
                     To get around this, callbacks must be set up in your initializePlugin method to clear\n\
                     their tracking dictionaries on file open and file new: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
fileOpenCB = 0\n\
fileNewCB = 0\n\
\n\
def clearTrackingDictionaries(unused):\n\
    MyNode.kTrackingDictionary = {} \n\
    MySurfaceShape.kTrackingDictionary = {}\n\
\n\
def initializePlugin(plugin): \n\
    ... \n\
    fileOpenCB = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSceneMessage.addCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_scene_message.html#abca4a003f2dc19d55b88798d0cb4aa32&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSceneMessage.addCallback</a>(\n\
                     OpenMaya.MSceneMessage.kBeforeOpen, \n\
                     clearTrackingDictionaries \n\
                 )\n\
    fileNewCB  = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSceneMessage.addCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_scene_message.html#abca4a003f2dc19d55b88798d0cb4aa32&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSceneMessage.addCallback</a>(\n\
                     OpenMaya.MSceneMessage.kBeforeNew, \n\
                     clearTrackingDictionaries \n\
                 )\n\
    ...\n\
}\n\
\n\
def uninitializePlugin(plugin): \n\
    ... \n\
    if fileOpenCB != 0:\n\
        OpenMaya.MSceneMessage.removeCallback(fileOpenCB) \n\
        fileOpenCB = 0 \n\
\n\
    if fileNewCB != 0: \n\
        OpenMaya.MSceneMessage.removeCallback(fileNewCB)\n\
        fileNewCB = 0\n\
</pre></div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99A\"></a> \n\
                  <h4><a name=\"GUID-4C8E21D4-2D0F-45A6-88CF-286FAA682048\"></a>Operating System Types\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99B\"></a>There are some methods in the Maya Python API that require \n\
                     				<span class=\"code\" translate=\"no\">&lt;iosteam&gt;</span> operating system types. As these are not included in Python, a \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStreamUtils\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_stream_utils.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStreamUtils</a></span> class is available for creating and using these type of objects. Please check the\n\
                     Developer Kit for examples on how to use this class. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99C\"></a> \n\
                  <h4><a name=\"GUID-06F478FA-E91E-4B67-B5FE-821F095007E1\"></a>Calling into the Parent class\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99D\"></a>Often when writing an MPx proxy class, the scripts will require calling into the parent\n\
                     class. This is done using notation such as the following: \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99E\"></a> <span class=\"code\" translate=\"no\">matrix = OpenMayaMPx.MPxTransformationMatrix.asMatrix(self)</span> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F99F\"></a> \n\
                  <h4><a name=\"GUID-33513D31-3916-4204-A7B2-E931B5E56270\"></a>Enum values\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A0\"></a>Enum values are accessed using a moduleName.className.value notation such as: \n\
                     			 \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A1\"></a> <span class=\"code\" translate=\"no\">OpenMaya.MSyntax.kDouble</span> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A2\"></a> \n\
                  <h4><a name=\"GUID-071F7C9D-965B-466D-B09F-7581B9D1A539\"></a>Using OpenGL\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A3\"></a>We have provided a wrapper class \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MGLFunctionTable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_l_function_table.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGLFunctionTable</a></span> for using OpenGL functionality in script on all of our support platforms. To acquire\n\
                     a reference to this class use the following code: \n\
                     			 \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
glRenderer = OpenMayaRender.MHardwareRenderer.theRenderer()\n\
glFT = glRenderer.glFunctionTable()\n\
</pre></div> \n\
               </div> \n\
               <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A4\"></a> \n\
                  <h4><a name=\"GUID-0CB7B25E-D203-4085-BFAA-BD52ACBFB9D0\"></a>Nested iterators and Garbage Collection\n\
                  </h4> \n\
                  <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A5\"></a>When writing nested iterators, it is normal to have the current item of the outer\n\
                     loop passed into an inner loop. For example, the current item of an \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSelectionList</a></span> is passed into a \n\
                     				<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItSurfaceCV\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_surface_c_v.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_surface_c_v.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItSurfaceCV</a></span> iterator. You may encounter garbage collection issues in this case where the inner\n\
                     iterator is holding on to information that may no longer be valid. You can work around\n\
                     this by resetting the inner iterator to None once its loop has been completed. This\n\
                     releases the iterator’s information before the outer loop continues, which is important\n\
                     if current items are being rebuilt or updated. \n\
                     			 \n\
                  </p> \n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A6\"></a> \n\
            <h2><a name=\"GUID-DD2E8377-C325-405D-B6FF-ECD53C021F02\"></a>Standalone Scripts\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A7\"></a>It is possible to write standalone scripts that make use of the wrapper classes and\n\
               function sets to modify the Maya model. These scripts are run from the command line.\n\
               A simple \"hello world\" standalone script follows: \n\
               		\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
import maya.standalone\n\
import maya.OpenMaya as OpenMaya\n\
import sys\n\
def main( argv = None ):\n\
    try:\n\
        maya.standalone.initialize( name=\'python\' )\n\
    except:\n\
        sys.stderr.write( \"Failed in initialize standalone application\" )\n\
        raise\n\
    sys.stderr.write( \"Hello world! (script output)\\n\" )\n\
    <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MGlobal</a>().executeCommand( \"print \\\"Hello world! (command script output)\\\\n\\\"\" )\n\
    maya.standalone.uninitialize()\n\
    \n\
if __name__ == \"__main__\":\n\
    main()\n\
</pre></div> \n\
            <p><a name=\"GUID-B1917E75-BB4E-48FD-A73F-B603CF64F9B2\"></a>After the standalone is initialized, Maya commands and API classes can be used to\n\
               create and modify a Maya model. When finished, the standalone is uninitialized to\n\
               allow Maya to clean up after itself. Do not attempt to use Maya commands or API classes\n\
               before the call to \n\
               		  <span class=\"code\" translate=\"no\">initialize()</span> or after the call to \n\
               		  <span class=\"code\" translate=\"no\">uninitialize()</span>; otherwise, unstable behaviour may result. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-296031C5-3DEB-4D8F-B751-667D3E03C2FD\"></a>A standalone script must be run using the Python executable that is supplied with\n\
               Maya. For example: \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F9A9\"></a> <span class=\"code\" translate=\"no\">$MAYA_LOCATION/bin/mayapy helloWorld.py</span> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";