var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-EB5E3701-E2BC-4883-84BF-5B77880E5813\">\n\
      <meta name=\"indexterm\" content=\"tweaks\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Construction History and Tweaks</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EB5E3701-E2BC-4883-84BF-5B77880E5813\"></a><div class=\"head\">\n\
            <h1>Construction History and Tweaks</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F8\"></a>This section assumes basic knowledge of the dependency graph. For details, see <span class=\"char_link\"><a href=\"#!/url=./files/Dependency_graph_plugins_Dependency_Graph_DG_nodes.htm\">Dependency Graph (DG) nodes</a></span>.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F7\"></a>All the operations that can be performed on a polygonal mesh can be generalized into\n\
            three basic types: create, edit and query. While both the creating and querying a\n\
            mesh are straightforward, editing involves complications resulting from construction\n\
            history and tweaks and how they work within the confines of the dependency graph.\n\
            \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS17956D7ADBC6E736-68E564E117AE33261D-7FF4\"></a> \n\
            <h2><a name=\"GUID-25FECEB8-EE81-47C8-8117-65465358D310\"></a>Construction History\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F6\"></a>Construction history provides a backlog of actions performed on a mesh. The implementation\n\
               of construction history in the DG makes it unique. For all objects in Maya, a single\n\
               linear chain of DG nodes can exist upstream from the object’s node. This chain is\n\
               known as the construction history of an object. The final node of a history chain\n\
               always represents the object that the history is recording actions for. At the beginning\n\
               of the chain lies a hidden intermediate node representing the initial state of the\n\
               node when the history first began to record actions performed on the mesh.\n\
            </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F5\"></a><div class=\"figure-anchor\"><img src=\"images/comp_Construction_History.png\"></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F4\"></a>The manipulation of the mesh can be complicated by the following factors, which affect\n\
               the state of a node: \n\
            </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F3\"></a><ul>\n\
               <li>Whether or not the mesh has construction history</li>\n\
               <li>Whether or not the user has construction history recording turned on</li>\n\
            </ul> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2F0\"></a>The presence of construction history indicates that there is a chain of modifier nodes\n\
               upstream from the mesh node—the history chain. Each modifier node in the history chain\n\
               is connected via their inMesh/outMesh attributes through which the mesh data flows\n\
               down the chain. During a DG evaluation, the outMesh at the top of the history chain\n\
               passes the mesh down to each modifier node, each applying their modification in turn.\n\
               Once the mesh reaches the actual mesh node and end of the chain, the modified mesh\n\
               is stored on the node, overwriting any previous data on the node.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2EF\"></a>Attempting to modify a mesh node via API mutator methods writes the information directly\n\
               onto the inMesh attribute of the given mesh node. Although some methods are history\n\
               sensitive, there are many that are not. This, combined with the DG evaluation process\n\
               presents the problem if history exists. Since a DG evaluation will overwrite the inMesh\n\
               of the mesh node due to the connection from the outMesh of the modifier node directly\n\
               upstream from the mesh, any modifications made to the mesh will be discarded. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2EE\"></a>The solution to this problem is to create a node that performs the modification want\n\
               and if history exists, to insert your node directly ahead of your mesh node in the\n\
               history chain as shown below. The node directly upstream from the mesh node always\n\
               represents the last change made to the mesh.\n\
            </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2ED\"></a><div class=\"figure-anchor\"><img src=\"images/comp_Modifier_Node.png\"></div> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2EC\"></a>Whether the user has construction history turned on or off does not restrict the modification\n\
               of a node as rigidly as whether the mesh has construction history. However it is a\n\
               good practice to adhere to the user’s construction history preferences and behave\n\
               similarly to the rest of Maya. This preference will change how the node should be\n\
               modified as well as what the node will look like in the DG following the operation.\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2EB\"></a>With history turned on, the user has selected to keep a history chain. Following the\n\
               operation, the resulting mesh would look like the previous diagram (Inserting a modifier\n\
               node). \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2EA\"></a>With history turned off, the user has selected not to see a history chain. From here\n\
               there are two possible ways to modify the mesh:\n\
            </p> <a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E9\"></a><ul>\n\
               <li>Operate on the mesh directly.</li>\n\
               <li>Use a modifier node as shown in the previous diagram (Inserting a modifier node),\n\
                  and then collapse the node down into the mesh.\n\
                  <div><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n\
                        <p><a name=\"GUID-A673389E-2EC5-4879-AAD8-95BED2A251E9\"></a>If history already exists on the mesh and history is turned off, the preference is\n\
                           ignored and regarded as though history was turned on. This leaves it at the user’s\n\
                           discretion to collapse all history down into the mesh node.\n\
                        </p> \n\
                     </div>\n\
                  </div>\n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E5\"></a> \n\
            <h2><a name=\"GUID-04EB033D-B98D-465C-9FAE-226497A11128\"></a>Tweaks\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E4\"></a> Tweaks are manual transformations applied to polygonal components (for example, manually\n\
               repositioning a vertex through a translate transformation). The presence of tweaks\n\
               on a shape complicates the interface of a polyShape node because they change the data\n\
               flow through the node. Although the change isn’t drastic it affects how you modify\n\
               the node. The challenge with tweaks is maintaining the order of operations. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E2\"></a>Tweaks are stored locally on the node and applied to the input mesh of the node (inMesh\n\
               or cachedInMesh). If a node is inserted ahead of the polyShape node (common for a\n\
               node with history), the order of operations is not kept. This can change the resulting\n\
               mesh if a modifier node was altering the topology of the mesh. For example, if the\n\
               modifier node rotated the edge containing a tweaked vertex, the resulting position\n\
               of the edge would vary based on the order of operations. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2E1\"></a>The polyTweak node resolves this problem. This node stores tweaks inside a local tweak\n\
               attribute. Upon receiving a mesh input (inputPolymesh attribute), the node applies\n\
               its tweaks to the mesh and returns the output through its output attribute. To address\n\
               the problem with this node, you extract the tweaks into the polyTweak node and insert\n\
               the polyTweak node ahead of the modifier node. This maintains the order of operations.\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";