var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2018\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-22\">\n\
      <meta name=\"topicid\" content=\"GUID-F96282D5-4F05-40A6-8FB9-875E1427D0A4\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Implementing a custom transform</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F96282D5-4F05-40A6-8FB9-875E1427D0A4\"></a><div class=\"head\">\n\
            <h1>Implementing a custom transform</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA3\"></a>When implementing a custom transform, you need to build the transform, configure its\n\
            attributes, and so on.\n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA4\"></a> \n\
            <h2><a name=\"GUID-193B92EC-3749-4AF1-A996-CFF9BBFD688A\"></a>Simple versus complex custom transform\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA5\"></a>Transforms have input and output attributes that are used to process and store the\n\
               transformation information. The simplest type of custom transform is one that does\n\
               not introduce any new attributes that can affect the transformation matrix. For example,\n\
               the transform may limit the \n\
               		  <span class=\"code\" translate=\"no\">translate</span> attribute to a certain world space volume using a predetermined calculation. \n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA6\"></a>A more complex custom transform is one that introduces one or more attributes that\n\
               affects the transformation matrix. For example, the transform may introduce a new\n\
               type of rotation parameter that is taken and integrated into the final calculation\n\
               of the transformation matrix. In this case, there are two types of rotation that the\n\
               custom transform understands and the original rotation attribute (supplied by \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform</a></span>) is left untouched in the calculations of the new rotation.\n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA7\"></a> \n\
            <h2><a name=\"GUID-93F647CC-CF71-49D6-8E2C-DCFB3FA55686\"></a>World space attributes\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA8\"></a>Instancing an object saves system memory, and is useful to display an object multiple\n\
               times while maintaining its exact properties. However, instancing an object opens\n\
               up some interesting coding challenges since there are multiple paths to the same object.\n\
               Maya handles this situation with array attributes that are classified as world space.\n\
               An array is necessary for handling multiple paths.\n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAA9\"></a>A world space attribute is one that is dependent on the transformations of an object\'s\n\
               parent(s) in addition to its own transformation. Marking an attribute as world space\n\
               will cause the attribute to be recalculated (if it is requested) if one of its parents\n\
               is transformed. World space attributes are arrays that handle the instancing scenario\n\
               described above. An example of a world space attribute is \n\
               		  <span class=\"code\" translate=\"no\">worldMatrix</span>. Configuring an attribute as an array and making it world space is done in the \n\
               		  <span class=\"code\" translate=\"no\">initialize()</span> method of the custom transform node with the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute</a></span> class.\n\
               		\n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAA\"></a>Given that world space attributes are arrays, the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArrayDataBuilder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArrayDataBuilder</a></span> class can be used to create the information that will be placed in the attribute.\n\
               It would then be necessary to configure the attribute with the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::setUsesArrayDataBuilder()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#a08fb5fd3764795485a0d799616646ef1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute::setUsesArrayDataBuilder()</a></span> in the \n\
               		  <span class=\"code\" translate=\"no\">initialize()</span> method.\n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAB\"></a> \n\
            <h2><a name=\"GUID-70CC77C2-1AF6-4002-B8E7-1C057406FC34\"></a>Affects world space attribute\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAC\"></a>An attribute marked as \n\
               		  <em class=\"mild\">affects world space</em> causes world space attributes to be recalculated (if world space is being requested)\n\
               on the given node and the children DAGs of the node. There is no array requirement\n\
               for this type of attribute. An example of an affects world space attribute is the\n\
               \n\
               		  <span class=\"code\" translate=\"no\">translate</span> attribute that is found on DAG nodes. Setting an attribute as world space is done\n\
               in the \n\
               		  <span class=\"code\" translate=\"no\">initialize()</span> method of the custom transform node with the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnAttribute</a></span> class.\n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAD\"></a> \n\
            <h2><a name=\"GUID-5146E2A8-F3BF-4639-B0E4-12A391BB7794\"></a>Transform Limits\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAE\"></a>There are special attributes on the transform (and custom transform) node that are\n\
               used for clamping values of associated attributes. Transform limits are available\n\
               for \n\
               		  <span class=\"code\" translate=\"no\">translate</span>, \n\
               		  <span class=\"code\" translate=\"no\">rotate</span> and \n\
               		  <span class=\"code\" translate=\"no\">scale</span>. Each operation includes three additional attributes: enabled, minimum and maximum.\n\
               Custom transforms modifying these attributes can implement a node that restricts \n\
               		  <span class=\"code\" translate=\"no\">translate</span>, \n\
               		  <span class=\"code\" translate=\"no\">rotate</span> and \n\
               		  <span class=\"code\" translate=\"no\">scale</span> to parts of world space. This is a simple implementation of a custom transform. A\n\
               more complex version of this custom transform can change the minimum and maximum based\n\
               on an external attribute input such as distance to another object. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAAF\"></a> \n\
            <h2><a name=\"GUID-E77748BC-2B2D-482E-B715-00CE872CD254\"></a>Balancing a transform\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB0\"></a>In the Maya implementation of a transform node, it is possible to keep the transformation\n\
               matrix the same while modifying the pivots (rotate and scale) and rotation order.\n\
               This is referred to as \n\
               		  <em class=\"mild\">balancing the transform</em>. Balance is a parameter that is included in methods related to modifying pivot and\n\
               rotation order information. The virtuals provided for \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform</a></span> and \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransformationMatrix</a></span> will handle balancing correctly if the custom transform does not attempt to change\n\
               the standard way that Maya handles pivots.\n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB1\"></a> \n\
            <h2><a name=\"GUID-DEB43F25-DFE1-42B7-926A-075C3A7E7CBB\"></a>Validating and setting\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB2\"></a>Maya uses a standard \n\
               		  <em class=\"mild\">validate and set</em> mechanism for updating the attribute values of custom transforms. You are required\n\
               to use this mechanism for any attributes that affect the matrix. The \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::mustCallValidateAndSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#a0533b06e6c41eed320612ce1aae241f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform::mustCallValidateAndSet()</a></span> must be called in the \n\
               		  <span class=\"code\" translate=\"no\">initialize()</span> method for all attributes that affect the matrix of the transform. It ensures that\n\
               the matrix is properly calculated when the attribute is explicitly set and that the\n\
               \n\
               		  <span class=\"code\" translate=\"no\">MPxTransform::validateAndSet()</span> method is called for this attribute. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB3\"></a> \n\
            <h2><a name=\"GUID-283CFD80-365B-4157-8FAC-4E9F30F44AA1\"></a>Returning the matrix\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-3D114B7511841AEFA9FAB4\"></a>As a part of the DG updating process, Maya will ask a custom transform for its transformation\n\
               matrix. This request goes directly to the \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::getMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#af6e52bdebc5f622b643dfdf60d9e15fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransform::getMatrix()</a></span> call. This virtual method in turn calls \n\
               		  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix::asMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html#a8e2933c5f73e8cfb7409366582caa596&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxTransformationMatrix::asMatrix()</a></span>. It is very important to implement these two methods so that the custom transform\n\
               will be returned to Maya.\n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";